/* Generated automatically -- do not modify!    -*- buffer-read-only: t -*- */

#ifndef ICNBREC_IDL_HEADER
#define ICNBREC_IDL_HEADER 1

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include "ovsdb-data.h"
#include "ovsdb-idl-provider.h"
#include "smap.h"
#include "uuid.h"

#ifdef  __cplusplus
extern "C" {
#endif


/* Connection table. */
struct icnbrec_connection {
	struct ovsdb_idl_row header_;

	/* external_ids column. */
	struct smap external_ids;

	/* inactivity_probe column. */
	int64_t *inactivity_probe;
	size_t n_inactivity_probe;

	/* is_connected column. */
	bool is_connected;

	/* max_backoff column. */
	int64_t *max_backoff;
	size_t n_max_backoff;

	/* other_config column. */
	struct smap other_config;

	/* status column. */
	struct smap status;

	/* target column. */
	char *target;	/* Always nonnull. */
};

enum icnbrec_connection_column_id {
    ICNBREC_CONNECTION_COL_EXTERNAL_IDS,
    ICNBREC_CONNECTION_COL_INACTIVITY_PROBE,
    ICNBREC_CONNECTION_COL_IS_CONNECTED,
    ICNBREC_CONNECTION_COL_MAX_BACKOFF,
    ICNBREC_CONNECTION_COL_OTHER_CONFIG,
    ICNBREC_CONNECTION_COL_STATUS,
    ICNBREC_CONNECTION_COL_TARGET,
    ICNBREC_CONNECTION_N_COLUMNS
};

#define icnbrec_connection_col_external_ids (icnbrec_connection_columns[ICNBREC_CONNECTION_COL_EXTERNAL_IDS])
#define icnbrec_connection_col_inactivity_probe (icnbrec_connection_columns[ICNBREC_CONNECTION_COL_INACTIVITY_PROBE])
#define icnbrec_connection_col_is_connected (icnbrec_connection_columns[ICNBREC_CONNECTION_COL_IS_CONNECTED])
#define icnbrec_connection_col_max_backoff (icnbrec_connection_columns[ICNBREC_CONNECTION_COL_MAX_BACKOFF])
#define icnbrec_connection_col_other_config (icnbrec_connection_columns[ICNBREC_CONNECTION_COL_OTHER_CONFIG])
#define icnbrec_connection_col_status (icnbrec_connection_columns[ICNBREC_CONNECTION_COL_STATUS])
#define icnbrec_connection_col_target (icnbrec_connection_columns[ICNBREC_CONNECTION_COL_TARGET])

extern struct ovsdb_idl_column icnbrec_connection_columns[ICNBREC_CONNECTION_N_COLUMNS];

const struct icnbrec_connection_table *icnbrec_connection_table_get(const struct ovsdb_idl *);
const struct icnbrec_connection *icnbrec_connection_table_first(const struct icnbrec_connection_table *);

#define ICNBREC_CONNECTION_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = icnbrec_connection_table_first(TABLE); \
             (ROW); \
             (ROW) = icnbrec_connection_next(ROW))
#define ICNBREC_CONNECTION_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = icnbrec_connection_table_first(TABLE); \
             (ROW) ? ((NEXT) = icnbrec_connection_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct icnbrec_connection *icnbrec_connection_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct icnbrec_connection *icnbrec_connection_table_get_for_uuid(const struct icnbrec_connection_table *, const struct uuid *);
const struct icnbrec_connection *icnbrec_connection_first(const struct ovsdb_idl *);
const struct icnbrec_connection *icnbrec_connection_next(const struct icnbrec_connection *);
#define ICNBREC_CONNECTION_FOR_EACH(ROW, IDL) \
        for ((ROW) = icnbrec_connection_first(IDL); \
             (ROW); \
             (ROW) = icnbrec_connection_next(ROW))
#define ICNBREC_CONNECTION_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = icnbrec_connection_first(IDL); \
             (ROW) ? ((NEXT) = icnbrec_connection_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int icnbrec_connection_get_seqno(const struct ovsdb_idl *);
unsigned int icnbrec_connection_row_get_seqno(const struct icnbrec_connection *row, enum ovsdb_idl_change change);
const struct icnbrec_connection *icnbrec_connection_track_get_first(const struct ovsdb_idl *);
const struct icnbrec_connection *icnbrec_connection_track_get_next(const struct icnbrec_connection *);
#define ICNBREC_CONNECTION_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = icnbrec_connection_track_get_first(IDL); \
             (ROW); \
             (ROW) = icnbrec_connection_track_get_next(ROW))

const struct icnbrec_connection *icnbrec_connection_table_track_get_first(const struct icnbrec_connection_table *);
#define ICNBREC_CONNECTION_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = icnbrec_connection_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = icnbrec_connection_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool icnbrec_connection_is_new(const struct icnbrec_connection *row)
{
    return icnbrec_connection_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool icnbrec_connection_is_deleted(const struct icnbrec_connection *row)
{
    return icnbrec_connection_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void icnbrec_connection_index_destroy_row(const struct icnbrec_connection *);

struct icnbrec_connection *icnbrec_connection_index_find(struct ovsdb_idl_index *, const struct icnbrec_connection *);

int icnbrec_connection_index_compare(
    struct ovsdb_idl_index *, 
    const struct icnbrec_connection *, 
    const struct icnbrec_connection *);
struct ovsdb_idl_cursor icnbrec_connection_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor icnbrec_connection_cursor_first_eq(
    struct ovsdb_idl_index *, const struct icnbrec_connection *);
struct ovsdb_idl_cursor icnbrec_connection_cursor_first_ge(
    struct ovsdb_idl_index *, const struct icnbrec_connection *);

struct icnbrec_connection *icnbrec_connection_cursor_data(struct ovsdb_idl_cursor *);

#define ICNBREC_CONNECTION_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_connection_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = icnbrec_connection_cursor_data(&cursor__), \
                  !(TO) || icnbrec_connection_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define ICNBREC_CONNECTION_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_connection_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = icnbrec_connection_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define ICNBREC_CONNECTION_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_connection_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = icnbrec_connection_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void icnbrec_connection_init(struct icnbrec_connection *);
void icnbrec_connection_delete(const struct icnbrec_connection *);
struct icnbrec_connection *icnbrec_connection_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum icnbrec_connection_column_id' of
 * the row referenced by 'struct icnbrec_connection *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool icnbrec_connection_is_updated(const struct icnbrec_connection *, enum icnbrec_connection_column_id);

void icnbrec_connection_verify_external_ids(const struct icnbrec_connection *);
void icnbrec_connection_verify_inactivity_probe(const struct icnbrec_connection *);
void icnbrec_connection_verify_is_connected(const struct icnbrec_connection *);
void icnbrec_connection_verify_max_backoff(const struct icnbrec_connection *);
void icnbrec_connection_verify_other_config(const struct icnbrec_connection *);
void icnbrec_connection_verify_status(const struct icnbrec_connection *);
void icnbrec_connection_verify_target(const struct icnbrec_connection *);

const struct ovsdb_datum *icnbrec_connection_get_external_ids(const struct icnbrec_connection *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *icnbrec_connection_get_inactivity_probe(const struct icnbrec_connection *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_connection_get_is_connected(const struct icnbrec_connection *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_connection_get_max_backoff(const struct icnbrec_connection *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_connection_get_other_config(const struct icnbrec_connection *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *icnbrec_connection_get_status(const struct icnbrec_connection *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *icnbrec_connection_get_target(const struct icnbrec_connection *, enum ovsdb_atomic_type key_type);

void icnbrec_connection_set_external_ids(const struct icnbrec_connection *, const struct smap *);
void icnbrec_connection_set_inactivity_probe(const struct icnbrec_connection *, const int64_t *inactivity_probe, size_t n_inactivity_probe);
void icnbrec_connection_set_is_connected(const struct icnbrec_connection *, bool is_connected);
void icnbrec_connection_set_max_backoff(const struct icnbrec_connection *, const int64_t *max_backoff, size_t n_max_backoff);
void icnbrec_connection_set_other_config(const struct icnbrec_connection *, const struct smap *);
void icnbrec_connection_set_status(const struct icnbrec_connection *, const struct smap *);
void icnbrec_connection_set_target(const struct icnbrec_connection *, const char *target);

void icnbrec_connection_update_external_ids_setkey(const struct icnbrec_connection *,  const char *, const char *);
void icnbrec_connection_update_external_ids_delkey(const struct icnbrec_connection *,  const char *);
void icnbrec_connection_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int icnbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_connection_update_inactivity_probe_addvalue(const struct icnbrec_connection *,  int64_t );
void icnbrec_connection_update_inactivity_probe_delvalue(const struct icnbrec_connection *,  int64_t );
void icnbrec_connection_add_clause_inactivity_probe(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *inactivity_probe, size_t n_inactivity_probe);
unsigned int icnbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_connection_add_clause_is_connected(struct ovsdb_idl_condition *, enum ovsdb_function function, bool is_connected);
unsigned int icnbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_connection_update_max_backoff_addvalue(const struct icnbrec_connection *,  int64_t );
void icnbrec_connection_update_max_backoff_delvalue(const struct icnbrec_connection *,  int64_t );
void icnbrec_connection_add_clause_max_backoff(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *max_backoff, size_t n_max_backoff);
unsigned int icnbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_connection_update_other_config_setkey(const struct icnbrec_connection *,  const char *, const char *);
void icnbrec_connection_update_other_config_delkey(const struct icnbrec_connection *,  const char *);
void icnbrec_connection_add_clause_other_config(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int icnbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_connection_update_status_setkey(const struct icnbrec_connection *,  const char *, const char *);
void icnbrec_connection_update_status_delkey(const struct icnbrec_connection *,  const char *);
void icnbrec_connection_add_clause_status(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int icnbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_connection_add_clause_target(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *target);
unsigned int icnbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct icnbrec_connection *icnbrec_connection_index_init_row(struct ovsdb_idl_index *);
void icnbrec_connection_index_set_external_ids(const struct icnbrec_connection *,
const struct smap *);
void icnbrec_connection_index_set_inactivity_probe(const struct icnbrec_connection *,
const int64_t *inactivity_probe, size_t n_inactivity_probe);
void icnbrec_connection_index_set_is_connected(const struct icnbrec_connection *,
bool is_connected);
void icnbrec_connection_index_set_max_backoff(const struct icnbrec_connection *,
const int64_t *max_backoff, size_t n_max_backoff);
void icnbrec_connection_index_set_other_config(const struct icnbrec_connection *,
const struct smap *);
void icnbrec_connection_index_set_status(const struct icnbrec_connection *,
const struct smap *);
void icnbrec_connection_index_set_target(const struct icnbrec_connection *,
const char *target);

/* IC_NB_Global table. */
struct icnbrec_ic_nb_global {
	struct ovsdb_idl_row header_;

	/* connections column. */
	struct icnbrec_connection **connections;
	size_t n_connections;

	/* external_ids column. */
	struct smap external_ids;

	/* options column. */
	struct smap options;

	/* ssl column. */
	struct icnbrec_ssl *ssl;
};

enum icnbrec_ic_nb_global_column_id {
    ICNBREC_IC_NB_GLOBAL_COL_CONNECTIONS,
    ICNBREC_IC_NB_GLOBAL_COL_EXTERNAL_IDS,
    ICNBREC_IC_NB_GLOBAL_COL_OPTIONS,
    ICNBREC_IC_NB_GLOBAL_COL_SSL,
    ICNBREC_IC_NB_GLOBAL_N_COLUMNS
};

#define icnbrec_ic_nb_global_col_connections (icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_COL_CONNECTIONS])
#define icnbrec_ic_nb_global_col_external_ids (icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_COL_EXTERNAL_IDS])
#define icnbrec_ic_nb_global_col_options (icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_COL_OPTIONS])
#define icnbrec_ic_nb_global_col_ssl (icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_COL_SSL])

extern struct ovsdb_idl_column icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_N_COLUMNS];

const struct icnbrec_ic_nb_global_table *icnbrec_ic_nb_global_table_get(const struct ovsdb_idl *);
const struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_table_first(const struct icnbrec_ic_nb_global_table *);

#define ICNBREC_IC_NB_GLOBAL_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = icnbrec_ic_nb_global_table_first(TABLE); \
             (ROW); \
             (ROW) = icnbrec_ic_nb_global_next(ROW))
#define ICNBREC_IC_NB_GLOBAL_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = icnbrec_ic_nb_global_table_first(TABLE); \
             (ROW) ? ((NEXT) = icnbrec_ic_nb_global_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_table_get_for_uuid(const struct icnbrec_ic_nb_global_table *, const struct uuid *);
const struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_first(const struct ovsdb_idl *);
const struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_next(const struct icnbrec_ic_nb_global *);
#define ICNBREC_IC_NB_GLOBAL_FOR_EACH(ROW, IDL) \
        for ((ROW) = icnbrec_ic_nb_global_first(IDL); \
             (ROW); \
             (ROW) = icnbrec_ic_nb_global_next(ROW))
#define ICNBREC_IC_NB_GLOBAL_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = icnbrec_ic_nb_global_first(IDL); \
             (ROW) ? ((NEXT) = icnbrec_ic_nb_global_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int icnbrec_ic_nb_global_get_seqno(const struct ovsdb_idl *);
unsigned int icnbrec_ic_nb_global_row_get_seqno(const struct icnbrec_ic_nb_global *row, enum ovsdb_idl_change change);
const struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_track_get_first(const struct ovsdb_idl *);
const struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_track_get_next(const struct icnbrec_ic_nb_global *);
#define ICNBREC_IC_NB_GLOBAL_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = icnbrec_ic_nb_global_track_get_first(IDL); \
             (ROW); \
             (ROW) = icnbrec_ic_nb_global_track_get_next(ROW))

const struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_table_track_get_first(const struct icnbrec_ic_nb_global_table *);
#define ICNBREC_IC_NB_GLOBAL_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = icnbrec_ic_nb_global_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = icnbrec_ic_nb_global_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool icnbrec_ic_nb_global_is_new(const struct icnbrec_ic_nb_global *row)
{
    return icnbrec_ic_nb_global_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool icnbrec_ic_nb_global_is_deleted(const struct icnbrec_ic_nb_global *row)
{
    return icnbrec_ic_nb_global_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void icnbrec_ic_nb_global_index_destroy_row(const struct icnbrec_ic_nb_global *);

struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_index_find(struct ovsdb_idl_index *, const struct icnbrec_ic_nb_global *);

int icnbrec_ic_nb_global_index_compare(
    struct ovsdb_idl_index *, 
    const struct icnbrec_ic_nb_global *, 
    const struct icnbrec_ic_nb_global *);
struct ovsdb_idl_cursor icnbrec_ic_nb_global_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor icnbrec_ic_nb_global_cursor_first_eq(
    struct ovsdb_idl_index *, const struct icnbrec_ic_nb_global *);
struct ovsdb_idl_cursor icnbrec_ic_nb_global_cursor_first_ge(
    struct ovsdb_idl_index *, const struct icnbrec_ic_nb_global *);

struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_cursor_data(struct ovsdb_idl_cursor *);

#define ICNBREC_IC_NB_GLOBAL_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_ic_nb_global_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = icnbrec_ic_nb_global_cursor_data(&cursor__), \
                  !(TO) || icnbrec_ic_nb_global_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define ICNBREC_IC_NB_GLOBAL_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_ic_nb_global_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = icnbrec_ic_nb_global_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define ICNBREC_IC_NB_GLOBAL_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_ic_nb_global_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = icnbrec_ic_nb_global_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void icnbrec_ic_nb_global_init(struct icnbrec_ic_nb_global *);
void icnbrec_ic_nb_global_delete(const struct icnbrec_ic_nb_global *);
struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum icnbrec_ic_nb_global_column_id' of
 * the row referenced by 'struct icnbrec_ic_nb_global *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool icnbrec_ic_nb_global_is_updated(const struct icnbrec_ic_nb_global *, enum icnbrec_ic_nb_global_column_id);

void icnbrec_ic_nb_global_verify_connections(const struct icnbrec_ic_nb_global *);
void icnbrec_ic_nb_global_verify_external_ids(const struct icnbrec_ic_nb_global *);
void icnbrec_ic_nb_global_verify_options(const struct icnbrec_ic_nb_global *);
void icnbrec_ic_nb_global_verify_ssl(const struct icnbrec_ic_nb_global *);

const struct ovsdb_datum *icnbrec_ic_nb_global_get_connections(const struct icnbrec_ic_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_ic_nb_global_get_external_ids(const struct icnbrec_ic_nb_global *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *icnbrec_ic_nb_global_get_options(const struct icnbrec_ic_nb_global *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *icnbrec_ic_nb_global_get_ssl(const struct icnbrec_ic_nb_global *, enum ovsdb_atomic_type key_type);

void icnbrec_ic_nb_global_set_connections(const struct icnbrec_ic_nb_global *, struct icnbrec_connection **connections, size_t n_connections);
void icnbrec_ic_nb_global_set_external_ids(const struct icnbrec_ic_nb_global *, const struct smap *);
void icnbrec_ic_nb_global_set_options(const struct icnbrec_ic_nb_global *, const struct smap *);
void icnbrec_ic_nb_global_set_ssl(const struct icnbrec_ic_nb_global *, const struct icnbrec_ssl *ssl);

void icnbrec_ic_nb_global_update_connections_addvalue(const struct icnbrec_ic_nb_global *,  const struct icnbrec_connection *);
void icnbrec_ic_nb_global_update_connections_delvalue(const struct icnbrec_ic_nb_global *,  const struct icnbrec_connection *);
void icnbrec_ic_nb_global_add_clause_connections(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **connections, size_t n_connections);
unsigned int icnbrec_ic_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ic_nb_global_update_external_ids_setkey(const struct icnbrec_ic_nb_global *,  const char *, const char *);
void icnbrec_ic_nb_global_update_external_ids_delkey(const struct icnbrec_ic_nb_global *,  const char *);
void icnbrec_ic_nb_global_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int icnbrec_ic_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ic_nb_global_update_options_setkey(const struct icnbrec_ic_nb_global *,  const char *, const char *);
void icnbrec_ic_nb_global_update_options_delkey(const struct icnbrec_ic_nb_global *,  const char *);
void icnbrec_ic_nb_global_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int icnbrec_ic_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ic_nb_global_update_ssl_addvalue(const struct icnbrec_ic_nb_global *,  const struct icnbrec_ssl *);
void icnbrec_ic_nb_global_update_ssl_delvalue(const struct icnbrec_ic_nb_global *,  const struct icnbrec_ssl *);
void icnbrec_ic_nb_global_add_clause_ssl(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *ssl);
unsigned int icnbrec_ic_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct icnbrec_ic_nb_global *icnbrec_ic_nb_global_index_init_row(struct ovsdb_idl_index *);
void icnbrec_ic_nb_global_index_set_connections(const struct icnbrec_ic_nb_global *,
struct icnbrec_connection **connections, size_t n_connections);
void icnbrec_ic_nb_global_index_set_external_ids(const struct icnbrec_ic_nb_global *,
const struct smap *);
void icnbrec_ic_nb_global_index_set_options(const struct icnbrec_ic_nb_global *,
const struct smap *);
void icnbrec_ic_nb_global_index_set_ssl(const struct icnbrec_ic_nb_global *,
const struct icnbrec_ssl *ssl);

/* SSL table. */
struct icnbrec_ssl {
	struct ovsdb_idl_row header_;

	/* bootstrap_ca_cert column. */
	bool bootstrap_ca_cert;

	/* ca_cert column. */
	char *ca_cert;	/* Always nonnull. */

	/* certificate column. */
	char *certificate;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* private_key column. */
	char *private_key;	/* Always nonnull. */

	/* ssl_ciphers column. */
	char *ssl_ciphers;	/* Always nonnull. */

	/* ssl_protocols column. */
	char *ssl_protocols;	/* Always nonnull. */
};

enum icnbrec_ssl_column_id {
    ICNBREC_SSL_COL_BOOTSTRAP_CA_CERT,
    ICNBREC_SSL_COL_CA_CERT,
    ICNBREC_SSL_COL_CERTIFICATE,
    ICNBREC_SSL_COL_EXTERNAL_IDS,
    ICNBREC_SSL_COL_PRIVATE_KEY,
    ICNBREC_SSL_COL_SSL_CIPHERS,
    ICNBREC_SSL_COL_SSL_PROTOCOLS,
    ICNBREC_SSL_N_COLUMNS
};

#define icnbrec_ssl_col_bootstrap_ca_cert (icnbrec_ssl_columns[ICNBREC_SSL_COL_BOOTSTRAP_CA_CERT])
#define icnbrec_ssl_col_ca_cert (icnbrec_ssl_columns[ICNBREC_SSL_COL_CA_CERT])
#define icnbrec_ssl_col_certificate (icnbrec_ssl_columns[ICNBREC_SSL_COL_CERTIFICATE])
#define icnbrec_ssl_col_external_ids (icnbrec_ssl_columns[ICNBREC_SSL_COL_EXTERNAL_IDS])
#define icnbrec_ssl_col_private_key (icnbrec_ssl_columns[ICNBREC_SSL_COL_PRIVATE_KEY])
#define icnbrec_ssl_col_ssl_ciphers (icnbrec_ssl_columns[ICNBREC_SSL_COL_SSL_CIPHERS])
#define icnbrec_ssl_col_ssl_protocols (icnbrec_ssl_columns[ICNBREC_SSL_COL_SSL_PROTOCOLS])

extern struct ovsdb_idl_column icnbrec_ssl_columns[ICNBREC_SSL_N_COLUMNS];

const struct icnbrec_ssl_table *icnbrec_ssl_table_get(const struct ovsdb_idl *);
const struct icnbrec_ssl *icnbrec_ssl_table_first(const struct icnbrec_ssl_table *);

#define ICNBREC_SSL_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = icnbrec_ssl_table_first(TABLE); \
             (ROW); \
             (ROW) = icnbrec_ssl_next(ROW))
#define ICNBREC_SSL_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = icnbrec_ssl_table_first(TABLE); \
             (ROW) ? ((NEXT) = icnbrec_ssl_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct icnbrec_ssl *icnbrec_ssl_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct icnbrec_ssl *icnbrec_ssl_table_get_for_uuid(const struct icnbrec_ssl_table *, const struct uuid *);
const struct icnbrec_ssl *icnbrec_ssl_first(const struct ovsdb_idl *);
const struct icnbrec_ssl *icnbrec_ssl_next(const struct icnbrec_ssl *);
#define ICNBREC_SSL_FOR_EACH(ROW, IDL) \
        for ((ROW) = icnbrec_ssl_first(IDL); \
             (ROW); \
             (ROW) = icnbrec_ssl_next(ROW))
#define ICNBREC_SSL_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = icnbrec_ssl_first(IDL); \
             (ROW) ? ((NEXT) = icnbrec_ssl_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int icnbrec_ssl_get_seqno(const struct ovsdb_idl *);
unsigned int icnbrec_ssl_row_get_seqno(const struct icnbrec_ssl *row, enum ovsdb_idl_change change);
const struct icnbrec_ssl *icnbrec_ssl_track_get_first(const struct ovsdb_idl *);
const struct icnbrec_ssl *icnbrec_ssl_track_get_next(const struct icnbrec_ssl *);
#define ICNBREC_SSL_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = icnbrec_ssl_track_get_first(IDL); \
             (ROW); \
             (ROW) = icnbrec_ssl_track_get_next(ROW))

const struct icnbrec_ssl *icnbrec_ssl_table_track_get_first(const struct icnbrec_ssl_table *);
#define ICNBREC_SSL_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = icnbrec_ssl_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = icnbrec_ssl_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool icnbrec_ssl_is_new(const struct icnbrec_ssl *row)
{
    return icnbrec_ssl_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool icnbrec_ssl_is_deleted(const struct icnbrec_ssl *row)
{
    return icnbrec_ssl_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void icnbrec_ssl_index_destroy_row(const struct icnbrec_ssl *);

struct icnbrec_ssl *icnbrec_ssl_index_find(struct ovsdb_idl_index *, const struct icnbrec_ssl *);

int icnbrec_ssl_index_compare(
    struct ovsdb_idl_index *, 
    const struct icnbrec_ssl *, 
    const struct icnbrec_ssl *);
struct ovsdb_idl_cursor icnbrec_ssl_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor icnbrec_ssl_cursor_first_eq(
    struct ovsdb_idl_index *, const struct icnbrec_ssl *);
struct ovsdb_idl_cursor icnbrec_ssl_cursor_first_ge(
    struct ovsdb_idl_index *, const struct icnbrec_ssl *);

struct icnbrec_ssl *icnbrec_ssl_cursor_data(struct ovsdb_idl_cursor *);

#define ICNBREC_SSL_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_ssl_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = icnbrec_ssl_cursor_data(&cursor__), \
                  !(TO) || icnbrec_ssl_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define ICNBREC_SSL_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_ssl_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = icnbrec_ssl_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define ICNBREC_SSL_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_ssl_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = icnbrec_ssl_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void icnbrec_ssl_init(struct icnbrec_ssl *);
void icnbrec_ssl_delete(const struct icnbrec_ssl *);
struct icnbrec_ssl *icnbrec_ssl_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum icnbrec_ssl_column_id' of
 * the row referenced by 'struct icnbrec_ssl *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool icnbrec_ssl_is_updated(const struct icnbrec_ssl *, enum icnbrec_ssl_column_id);

void icnbrec_ssl_verify_bootstrap_ca_cert(const struct icnbrec_ssl *);
void icnbrec_ssl_verify_ca_cert(const struct icnbrec_ssl *);
void icnbrec_ssl_verify_certificate(const struct icnbrec_ssl *);
void icnbrec_ssl_verify_external_ids(const struct icnbrec_ssl *);
void icnbrec_ssl_verify_private_key(const struct icnbrec_ssl *);
void icnbrec_ssl_verify_ssl_ciphers(const struct icnbrec_ssl *);
void icnbrec_ssl_verify_ssl_protocols(const struct icnbrec_ssl *);

const struct ovsdb_datum *icnbrec_ssl_get_bootstrap_ca_cert(const struct icnbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_ssl_get_ca_cert(const struct icnbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_ssl_get_certificate(const struct icnbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_ssl_get_external_ids(const struct icnbrec_ssl *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *icnbrec_ssl_get_private_key(const struct icnbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_ssl_get_ssl_ciphers(const struct icnbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_ssl_get_ssl_protocols(const struct icnbrec_ssl *, enum ovsdb_atomic_type key_type);

void icnbrec_ssl_set_bootstrap_ca_cert(const struct icnbrec_ssl *, bool bootstrap_ca_cert);
void icnbrec_ssl_set_ca_cert(const struct icnbrec_ssl *, const char *ca_cert);
void icnbrec_ssl_set_certificate(const struct icnbrec_ssl *, const char *certificate);
void icnbrec_ssl_set_external_ids(const struct icnbrec_ssl *, const struct smap *);
void icnbrec_ssl_set_private_key(const struct icnbrec_ssl *, const char *private_key);
void icnbrec_ssl_set_ssl_ciphers(const struct icnbrec_ssl *, const char *ssl_ciphers);
void icnbrec_ssl_set_ssl_protocols(const struct icnbrec_ssl *, const char *ssl_protocols);

void icnbrec_ssl_add_clause_bootstrap_ca_cert(struct ovsdb_idl_condition *, enum ovsdb_function function, bool bootstrap_ca_cert);
unsigned int icnbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ssl_add_clause_ca_cert(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *ca_cert);
unsigned int icnbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ssl_add_clause_certificate(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *certificate);
unsigned int icnbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ssl_update_external_ids_setkey(const struct icnbrec_ssl *,  const char *, const char *);
void icnbrec_ssl_update_external_ids_delkey(const struct icnbrec_ssl *,  const char *);
void icnbrec_ssl_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int icnbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ssl_add_clause_private_key(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *private_key);
unsigned int icnbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ssl_add_clause_ssl_ciphers(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *ssl_ciphers);
unsigned int icnbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_ssl_add_clause_ssl_protocols(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *ssl_protocols);
unsigned int icnbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct icnbrec_ssl *icnbrec_ssl_index_init_row(struct ovsdb_idl_index *);
void icnbrec_ssl_index_set_bootstrap_ca_cert(const struct icnbrec_ssl *,
bool bootstrap_ca_cert);
void icnbrec_ssl_index_set_ca_cert(const struct icnbrec_ssl *,
const char *ca_cert);
void icnbrec_ssl_index_set_certificate(const struct icnbrec_ssl *,
const char *certificate);
void icnbrec_ssl_index_set_external_ids(const struct icnbrec_ssl *,
const struct smap *);
void icnbrec_ssl_index_set_private_key(const struct icnbrec_ssl *,
const char *private_key);
void icnbrec_ssl_index_set_ssl_ciphers(const struct icnbrec_ssl *,
const char *ssl_ciphers);
void icnbrec_ssl_index_set_ssl_protocols(const struct icnbrec_ssl *,
const char *ssl_protocols);

/* Transit_Switch table. */
struct icnbrec_transit_switch {
	struct ovsdb_idl_row header_;

	/* external_ids column. */
	struct smap external_ids;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* other_config column. */
	struct smap other_config;
};

enum icnbrec_transit_switch_column_id {
    ICNBREC_TRANSIT_SWITCH_COL_EXTERNAL_IDS,
    ICNBREC_TRANSIT_SWITCH_COL_NAME,
    ICNBREC_TRANSIT_SWITCH_COL_OTHER_CONFIG,
    ICNBREC_TRANSIT_SWITCH_N_COLUMNS
};

#define icnbrec_transit_switch_col_external_ids (icnbrec_transit_switch_columns[ICNBREC_TRANSIT_SWITCH_COL_EXTERNAL_IDS])
#define icnbrec_transit_switch_col_name (icnbrec_transit_switch_columns[ICNBREC_TRANSIT_SWITCH_COL_NAME])
#define icnbrec_transit_switch_col_other_config (icnbrec_transit_switch_columns[ICNBREC_TRANSIT_SWITCH_COL_OTHER_CONFIG])

extern struct ovsdb_idl_column icnbrec_transit_switch_columns[ICNBREC_TRANSIT_SWITCH_N_COLUMNS];

const struct icnbrec_transit_switch_table *icnbrec_transit_switch_table_get(const struct ovsdb_idl *);
const struct icnbrec_transit_switch *icnbrec_transit_switch_table_first(const struct icnbrec_transit_switch_table *);

#define ICNBREC_TRANSIT_SWITCH_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = icnbrec_transit_switch_table_first(TABLE); \
             (ROW); \
             (ROW) = icnbrec_transit_switch_next(ROW))
#define ICNBREC_TRANSIT_SWITCH_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = icnbrec_transit_switch_table_first(TABLE); \
             (ROW) ? ((NEXT) = icnbrec_transit_switch_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct icnbrec_transit_switch *icnbrec_transit_switch_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct icnbrec_transit_switch *icnbrec_transit_switch_table_get_for_uuid(const struct icnbrec_transit_switch_table *, const struct uuid *);
const struct icnbrec_transit_switch *icnbrec_transit_switch_first(const struct ovsdb_idl *);
const struct icnbrec_transit_switch *icnbrec_transit_switch_next(const struct icnbrec_transit_switch *);
#define ICNBREC_TRANSIT_SWITCH_FOR_EACH(ROW, IDL) \
        for ((ROW) = icnbrec_transit_switch_first(IDL); \
             (ROW); \
             (ROW) = icnbrec_transit_switch_next(ROW))
#define ICNBREC_TRANSIT_SWITCH_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = icnbrec_transit_switch_first(IDL); \
             (ROW) ? ((NEXT) = icnbrec_transit_switch_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int icnbrec_transit_switch_get_seqno(const struct ovsdb_idl *);
unsigned int icnbrec_transit_switch_row_get_seqno(const struct icnbrec_transit_switch *row, enum ovsdb_idl_change change);
const struct icnbrec_transit_switch *icnbrec_transit_switch_track_get_first(const struct ovsdb_idl *);
const struct icnbrec_transit_switch *icnbrec_transit_switch_track_get_next(const struct icnbrec_transit_switch *);
#define ICNBREC_TRANSIT_SWITCH_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = icnbrec_transit_switch_track_get_first(IDL); \
             (ROW); \
             (ROW) = icnbrec_transit_switch_track_get_next(ROW))

const struct icnbrec_transit_switch *icnbrec_transit_switch_table_track_get_first(const struct icnbrec_transit_switch_table *);
#define ICNBREC_TRANSIT_SWITCH_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = icnbrec_transit_switch_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = icnbrec_transit_switch_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool icnbrec_transit_switch_is_new(const struct icnbrec_transit_switch *row)
{
    return icnbrec_transit_switch_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool icnbrec_transit_switch_is_deleted(const struct icnbrec_transit_switch *row)
{
    return icnbrec_transit_switch_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void icnbrec_transit_switch_index_destroy_row(const struct icnbrec_transit_switch *);

struct icnbrec_transit_switch *icnbrec_transit_switch_index_find(struct ovsdb_idl_index *, const struct icnbrec_transit_switch *);

int icnbrec_transit_switch_index_compare(
    struct ovsdb_idl_index *, 
    const struct icnbrec_transit_switch *, 
    const struct icnbrec_transit_switch *);
struct ovsdb_idl_cursor icnbrec_transit_switch_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor icnbrec_transit_switch_cursor_first_eq(
    struct ovsdb_idl_index *, const struct icnbrec_transit_switch *);
struct ovsdb_idl_cursor icnbrec_transit_switch_cursor_first_ge(
    struct ovsdb_idl_index *, const struct icnbrec_transit_switch *);

struct icnbrec_transit_switch *icnbrec_transit_switch_cursor_data(struct ovsdb_idl_cursor *);

#define ICNBREC_TRANSIT_SWITCH_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_transit_switch_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = icnbrec_transit_switch_cursor_data(&cursor__), \
                  !(TO) || icnbrec_transit_switch_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define ICNBREC_TRANSIT_SWITCH_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_transit_switch_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = icnbrec_transit_switch_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define ICNBREC_TRANSIT_SWITCH_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = icnbrec_transit_switch_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = icnbrec_transit_switch_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void icnbrec_transit_switch_init(struct icnbrec_transit_switch *);
void icnbrec_transit_switch_delete(const struct icnbrec_transit_switch *);
struct icnbrec_transit_switch *icnbrec_transit_switch_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum icnbrec_transit_switch_column_id' of
 * the row referenced by 'struct icnbrec_transit_switch *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool icnbrec_transit_switch_is_updated(const struct icnbrec_transit_switch *, enum icnbrec_transit_switch_column_id);

void icnbrec_transit_switch_verify_external_ids(const struct icnbrec_transit_switch *);
void icnbrec_transit_switch_verify_name(const struct icnbrec_transit_switch *);
void icnbrec_transit_switch_verify_other_config(const struct icnbrec_transit_switch *);

const struct ovsdb_datum *icnbrec_transit_switch_get_external_ids(const struct icnbrec_transit_switch *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *icnbrec_transit_switch_get_name(const struct icnbrec_transit_switch *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *icnbrec_transit_switch_get_other_config(const struct icnbrec_transit_switch *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);

void icnbrec_transit_switch_set_external_ids(const struct icnbrec_transit_switch *, const struct smap *);
void icnbrec_transit_switch_set_name(const struct icnbrec_transit_switch *, const char *name);
void icnbrec_transit_switch_set_other_config(const struct icnbrec_transit_switch *, const struct smap *);

void icnbrec_transit_switch_update_external_ids_setkey(const struct icnbrec_transit_switch *,  const char *, const char *);
void icnbrec_transit_switch_update_external_ids_delkey(const struct icnbrec_transit_switch *,  const char *);
void icnbrec_transit_switch_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int icnbrec_transit_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_transit_switch_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int icnbrec_transit_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void icnbrec_transit_switch_update_other_config_setkey(const struct icnbrec_transit_switch *,  const char *, const char *);
void icnbrec_transit_switch_update_other_config_delkey(const struct icnbrec_transit_switch *,  const char *);
void icnbrec_transit_switch_add_clause_other_config(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int icnbrec_transit_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct icnbrec_transit_switch *icnbrec_transit_switch_index_init_row(struct ovsdb_idl_index *);
void icnbrec_transit_switch_index_set_external_ids(const struct icnbrec_transit_switch *,
const struct smap *);
void icnbrec_transit_switch_index_set_name(const struct icnbrec_transit_switch *,
const char *name);
void icnbrec_transit_switch_index_set_other_config(const struct icnbrec_transit_switch *,
const struct smap *);

enum icnbrec_table_id {
    ICNBREC_TABLE_CONNECTION,
    ICNBREC_TABLE_IC_NB_GLOBAL,
    ICNBREC_TABLE_SSL,
    ICNBREC_TABLE_TRANSIT_SWITCH,
    ICNBREC_N_TABLES
};

#define icnbrec_table_connection (icnbrec_table_classes[ICNBREC_TABLE_CONNECTION])
#define icnbrec_table_ic_nb_global (icnbrec_table_classes[ICNBREC_TABLE_IC_NB_GLOBAL])
#define icnbrec_table_ssl (icnbrec_table_classes[ICNBREC_TABLE_SSL])
#define icnbrec_table_transit_switch (icnbrec_table_classes[ICNBREC_TABLE_TRANSIT_SWITCH])

extern struct ovsdb_idl_table_class icnbrec_table_classes[ICNBREC_N_TABLES];

extern struct ovsdb_idl_class icnbrec_idl_class;

const char * icnbrec_get_db_version(void);

#ifdef  __cplusplus
}
#endif

#endif /* ICNBREC_IDL_HEADER */
