/* Generated automatically -- do not modify!    -*- buffer-read-only: t -*- */

#ifndef NBREC_IDL_HEADER
#define NBREC_IDL_HEADER 1

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include "ovsdb-data.h"
#include "ovsdb-idl-provider.h"
#include "smap.h"
#include "uuid.h"

#ifdef  __cplusplus
extern "C" {
#endif


/* ACL table. */
struct nbrec_acl {
	struct ovsdb_idl_row header_;

	/* action column. */
	char *action;	/* Always nonnull. */

	/* direction column. */
	char *direction;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* log column. */
	bool log;

	/* match column. */
	char *match;	/* Always nonnull. */

	/* meter column. */
	char *meter;

	/* name column. */
	char *name;

	/* priority column. */
	int64_t priority;

	/* severity column. */
	char *severity;
};

enum nbrec_acl_column_id {
    NBREC_ACL_COL_ACTION,
    NBREC_ACL_COL_DIRECTION,
    NBREC_ACL_COL_EXTERNAL_IDS,
    NBREC_ACL_COL_LOG,
    NBREC_ACL_COL_MATCH,
    NBREC_ACL_COL_METER,
    NBREC_ACL_COL_NAME,
    NBREC_ACL_COL_PRIORITY,
    NBREC_ACL_COL_SEVERITY,
    NBREC_ACL_N_COLUMNS
};

#define nbrec_acl_col_action (nbrec_acl_columns[NBREC_ACL_COL_ACTION])
#define nbrec_acl_col_direction (nbrec_acl_columns[NBREC_ACL_COL_DIRECTION])
#define nbrec_acl_col_external_ids (nbrec_acl_columns[NBREC_ACL_COL_EXTERNAL_IDS])
#define nbrec_acl_col_log (nbrec_acl_columns[NBREC_ACL_COL_LOG])
#define nbrec_acl_col_match (nbrec_acl_columns[NBREC_ACL_COL_MATCH])
#define nbrec_acl_col_meter (nbrec_acl_columns[NBREC_ACL_COL_METER])
#define nbrec_acl_col_name (nbrec_acl_columns[NBREC_ACL_COL_NAME])
#define nbrec_acl_col_priority (nbrec_acl_columns[NBREC_ACL_COL_PRIORITY])
#define nbrec_acl_col_severity (nbrec_acl_columns[NBREC_ACL_COL_SEVERITY])

extern struct ovsdb_idl_column nbrec_acl_columns[NBREC_ACL_N_COLUMNS];

const struct nbrec_acl_table *nbrec_acl_table_get(const struct ovsdb_idl *);
const struct nbrec_acl *nbrec_acl_table_first(const struct nbrec_acl_table *);

#define NBREC_ACL_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_acl_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_acl_next(ROW))
#define NBREC_ACL_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_acl_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_acl_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_acl *nbrec_acl_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_acl *nbrec_acl_table_get_for_uuid(const struct nbrec_acl_table *, const struct uuid *);
const struct nbrec_acl *nbrec_acl_first(const struct ovsdb_idl *);
const struct nbrec_acl *nbrec_acl_next(const struct nbrec_acl *);
#define NBREC_ACL_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_acl_first(IDL); \
             (ROW); \
             (ROW) = nbrec_acl_next(ROW))
#define NBREC_ACL_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_acl_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_acl_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_acl_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_acl_row_get_seqno(const struct nbrec_acl *row, enum ovsdb_idl_change change);
const struct nbrec_acl *nbrec_acl_track_get_first(const struct ovsdb_idl *);
const struct nbrec_acl *nbrec_acl_track_get_next(const struct nbrec_acl *);
#define NBREC_ACL_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_acl_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_acl_track_get_next(ROW))

const struct nbrec_acl *nbrec_acl_table_track_get_first(const struct nbrec_acl_table *);
#define NBREC_ACL_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_acl_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_acl_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_acl_is_new(const struct nbrec_acl *row)
{
    return nbrec_acl_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_acl_is_deleted(const struct nbrec_acl *row)
{
    return nbrec_acl_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_acl_index_destroy_row(const struct nbrec_acl *);

struct nbrec_acl *nbrec_acl_index_find(struct ovsdb_idl_index *, const struct nbrec_acl *);

int nbrec_acl_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_acl *, 
    const struct nbrec_acl *);
struct ovsdb_idl_cursor nbrec_acl_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_acl_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_acl *);
struct ovsdb_idl_cursor nbrec_acl_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_acl *);

struct nbrec_acl *nbrec_acl_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_ACL_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_acl_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_acl_cursor_data(&cursor__), \
                  !(TO) || nbrec_acl_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_ACL_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_acl_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_acl_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_ACL_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_acl_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_acl_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_acl_init(struct nbrec_acl *);
void nbrec_acl_delete(const struct nbrec_acl *);
struct nbrec_acl *nbrec_acl_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_acl_column_id' of
 * the row referenced by 'struct nbrec_acl *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_acl_is_updated(const struct nbrec_acl *, enum nbrec_acl_column_id);

void nbrec_acl_verify_action(const struct nbrec_acl *);
void nbrec_acl_verify_direction(const struct nbrec_acl *);
void nbrec_acl_verify_external_ids(const struct nbrec_acl *);
void nbrec_acl_verify_log(const struct nbrec_acl *);
void nbrec_acl_verify_match(const struct nbrec_acl *);
void nbrec_acl_verify_meter(const struct nbrec_acl *);
void nbrec_acl_verify_name(const struct nbrec_acl *);
void nbrec_acl_verify_priority(const struct nbrec_acl *);
void nbrec_acl_verify_severity(const struct nbrec_acl *);

const struct ovsdb_datum *nbrec_acl_get_action(const struct nbrec_acl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_acl_get_direction(const struct nbrec_acl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_acl_get_external_ids(const struct nbrec_acl *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_acl_get_log(const struct nbrec_acl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_acl_get_match(const struct nbrec_acl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_acl_get_meter(const struct nbrec_acl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_acl_get_name(const struct nbrec_acl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_acl_get_priority(const struct nbrec_acl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_acl_get_severity(const struct nbrec_acl *, enum ovsdb_atomic_type key_type);

void nbrec_acl_set_action(const struct nbrec_acl *, const char *action);
void nbrec_acl_set_direction(const struct nbrec_acl *, const char *direction);
void nbrec_acl_set_external_ids(const struct nbrec_acl *, const struct smap *);
void nbrec_acl_set_log(const struct nbrec_acl *, bool log);
void nbrec_acl_set_match(const struct nbrec_acl *, const char *match);
void nbrec_acl_set_meter(const struct nbrec_acl *, const char *meter);
void nbrec_acl_set_name(const struct nbrec_acl *, const char *name);
void nbrec_acl_set_priority(const struct nbrec_acl *, int64_t priority);
void nbrec_acl_set_severity(const struct nbrec_acl *, const char *severity);

void nbrec_acl_add_clause_action(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *action);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_acl_add_clause_direction(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *direction);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_acl_update_external_ids_setkey(const struct nbrec_acl *,  const char *, const char *);
void nbrec_acl_update_external_ids_delkey(const struct nbrec_acl *,  const char *);
void nbrec_acl_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_acl_add_clause_log(struct ovsdb_idl_condition *, enum ovsdb_function function, bool log);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_acl_add_clause_match(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *match);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_acl_update_meter_addvalue(const struct nbrec_acl *,  const char *);
void nbrec_acl_update_meter_delvalue(const struct nbrec_acl *,  const char *);
void nbrec_acl_add_clause_meter(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *meter);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_acl_update_name_addvalue(const struct nbrec_acl *,  const char *);
void nbrec_acl_update_name_delvalue(const struct nbrec_acl *,  const char *);
void nbrec_acl_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_acl_add_clause_priority(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t priority);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_acl_update_severity_addvalue(const struct nbrec_acl *,  const char *);
void nbrec_acl_update_severity_delvalue(const struct nbrec_acl *,  const char *);
void nbrec_acl_add_clause_severity(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *severity);
unsigned int nbrec_acl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_acl *nbrec_acl_index_init_row(struct ovsdb_idl_index *);
void nbrec_acl_index_set_action(const struct nbrec_acl *,
const char *action);
void nbrec_acl_index_set_direction(const struct nbrec_acl *,
const char *direction);
void nbrec_acl_index_set_external_ids(const struct nbrec_acl *,
const struct smap *);
void nbrec_acl_index_set_log(const struct nbrec_acl *,
bool log);
void nbrec_acl_index_set_match(const struct nbrec_acl *,
const char *match);
void nbrec_acl_index_set_meter(const struct nbrec_acl *,
const char *meter);
void nbrec_acl_index_set_name(const struct nbrec_acl *,
const char *name);
void nbrec_acl_index_set_priority(const struct nbrec_acl *,
int64_t priority);
void nbrec_acl_index_set_severity(const struct nbrec_acl *,
const char *severity);

/* Address_Set table. */
struct nbrec_address_set {
	struct ovsdb_idl_row header_;

	/* addresses column. */
	char **addresses;
	size_t n_addresses;

	/* external_ids column. */
	struct smap external_ids;

	/* name column. */
	char *name;	/* Always nonnull. */
};

enum nbrec_address_set_column_id {
    NBREC_ADDRESS_SET_COL_ADDRESSES,
    NBREC_ADDRESS_SET_COL_EXTERNAL_IDS,
    NBREC_ADDRESS_SET_COL_NAME,
    NBREC_ADDRESS_SET_N_COLUMNS
};

#define nbrec_address_set_col_addresses (nbrec_address_set_columns[NBREC_ADDRESS_SET_COL_ADDRESSES])
#define nbrec_address_set_col_external_ids (nbrec_address_set_columns[NBREC_ADDRESS_SET_COL_EXTERNAL_IDS])
#define nbrec_address_set_col_name (nbrec_address_set_columns[NBREC_ADDRESS_SET_COL_NAME])

extern struct ovsdb_idl_column nbrec_address_set_columns[NBREC_ADDRESS_SET_N_COLUMNS];

const struct nbrec_address_set_table *nbrec_address_set_table_get(const struct ovsdb_idl *);
const struct nbrec_address_set *nbrec_address_set_table_first(const struct nbrec_address_set_table *);

#define NBREC_ADDRESS_SET_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_address_set_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_address_set_next(ROW))
#define NBREC_ADDRESS_SET_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_address_set_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_address_set_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_address_set *nbrec_address_set_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_address_set *nbrec_address_set_table_get_for_uuid(const struct nbrec_address_set_table *, const struct uuid *);
const struct nbrec_address_set *nbrec_address_set_first(const struct ovsdb_idl *);
const struct nbrec_address_set *nbrec_address_set_next(const struct nbrec_address_set *);
#define NBREC_ADDRESS_SET_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_address_set_first(IDL); \
             (ROW); \
             (ROW) = nbrec_address_set_next(ROW))
#define NBREC_ADDRESS_SET_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_address_set_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_address_set_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_address_set_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_address_set_row_get_seqno(const struct nbrec_address_set *row, enum ovsdb_idl_change change);
const struct nbrec_address_set *nbrec_address_set_track_get_first(const struct ovsdb_idl *);
const struct nbrec_address_set *nbrec_address_set_track_get_next(const struct nbrec_address_set *);
#define NBREC_ADDRESS_SET_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_address_set_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_address_set_track_get_next(ROW))

const struct nbrec_address_set *nbrec_address_set_table_track_get_first(const struct nbrec_address_set_table *);
#define NBREC_ADDRESS_SET_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_address_set_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_address_set_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_address_set_is_new(const struct nbrec_address_set *row)
{
    return nbrec_address_set_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_address_set_is_deleted(const struct nbrec_address_set *row)
{
    return nbrec_address_set_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_address_set_index_destroy_row(const struct nbrec_address_set *);

struct nbrec_address_set *nbrec_address_set_index_find(struct ovsdb_idl_index *, const struct nbrec_address_set *);

int nbrec_address_set_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_address_set *, 
    const struct nbrec_address_set *);
struct ovsdb_idl_cursor nbrec_address_set_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_address_set_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_address_set *);
struct ovsdb_idl_cursor nbrec_address_set_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_address_set *);

struct nbrec_address_set *nbrec_address_set_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_ADDRESS_SET_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_address_set_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_address_set_cursor_data(&cursor__), \
                  !(TO) || nbrec_address_set_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_ADDRESS_SET_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_address_set_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_address_set_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_ADDRESS_SET_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_address_set_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_address_set_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_address_set_init(struct nbrec_address_set *);
void nbrec_address_set_delete(const struct nbrec_address_set *);
struct nbrec_address_set *nbrec_address_set_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_address_set_column_id' of
 * the row referenced by 'struct nbrec_address_set *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_address_set_is_updated(const struct nbrec_address_set *, enum nbrec_address_set_column_id);

void nbrec_address_set_verify_addresses(const struct nbrec_address_set *);
void nbrec_address_set_verify_external_ids(const struct nbrec_address_set *);
void nbrec_address_set_verify_name(const struct nbrec_address_set *);

const struct ovsdb_datum *nbrec_address_set_get_addresses(const struct nbrec_address_set *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_address_set_get_external_ids(const struct nbrec_address_set *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_address_set_get_name(const struct nbrec_address_set *, enum ovsdb_atomic_type key_type);

void nbrec_address_set_set_addresses(const struct nbrec_address_set *, const char **addresses, size_t n_addresses);
void nbrec_address_set_set_external_ids(const struct nbrec_address_set *, const struct smap *);
void nbrec_address_set_set_name(const struct nbrec_address_set *, const char *name);

void nbrec_address_set_update_addresses_addvalue(const struct nbrec_address_set *,  const char *);
void nbrec_address_set_update_addresses_delvalue(const struct nbrec_address_set *,  const char *);
void nbrec_address_set_add_clause_addresses(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **addresses, size_t n_addresses);
unsigned int nbrec_address_set_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_address_set_update_external_ids_setkey(const struct nbrec_address_set *,  const char *, const char *);
void nbrec_address_set_update_external_ids_delkey(const struct nbrec_address_set *,  const char *);
void nbrec_address_set_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_address_set_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_address_set_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_address_set_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_address_set *nbrec_address_set_index_init_row(struct ovsdb_idl_index *);
void nbrec_address_set_index_set_addresses(const struct nbrec_address_set *,
const char **addresses, size_t n_addresses);
void nbrec_address_set_index_set_external_ids(const struct nbrec_address_set *,
const struct smap *);
void nbrec_address_set_index_set_name(const struct nbrec_address_set *,
const char *name);

/* BFD table. */
struct nbrec_bfd {
	struct ovsdb_idl_row header_;

	/* detect_mult column. */
	int64_t *detect_mult;
	size_t n_detect_mult;

	/* dst_ip column. */
	char *dst_ip;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* logical_port column. */
	char *logical_port;	/* Always nonnull. */

	/* min_rx column. */
	int64_t *min_rx;
	size_t n_min_rx;

	/* min_tx column. */
	int64_t *min_tx;
	size_t n_min_tx;

	/* options column. */
	struct smap options;

	/* status column. */
	char *status;
};

enum nbrec_bfd_column_id {
    NBREC_BFD_COL_DETECT_MULT,
    NBREC_BFD_COL_DST_IP,
    NBREC_BFD_COL_EXTERNAL_IDS,
    NBREC_BFD_COL_LOGICAL_PORT,
    NBREC_BFD_COL_MIN_RX,
    NBREC_BFD_COL_MIN_TX,
    NBREC_BFD_COL_OPTIONS,
    NBREC_BFD_COL_STATUS,
    NBREC_BFD_N_COLUMNS
};

#define nbrec_bfd_col_detect_mult (nbrec_bfd_columns[NBREC_BFD_COL_DETECT_MULT])
#define nbrec_bfd_col_dst_ip (nbrec_bfd_columns[NBREC_BFD_COL_DST_IP])
#define nbrec_bfd_col_external_ids (nbrec_bfd_columns[NBREC_BFD_COL_EXTERNAL_IDS])
#define nbrec_bfd_col_logical_port (nbrec_bfd_columns[NBREC_BFD_COL_LOGICAL_PORT])
#define nbrec_bfd_col_min_rx (nbrec_bfd_columns[NBREC_BFD_COL_MIN_RX])
#define nbrec_bfd_col_min_tx (nbrec_bfd_columns[NBREC_BFD_COL_MIN_TX])
#define nbrec_bfd_col_options (nbrec_bfd_columns[NBREC_BFD_COL_OPTIONS])
#define nbrec_bfd_col_status (nbrec_bfd_columns[NBREC_BFD_COL_STATUS])

extern struct ovsdb_idl_column nbrec_bfd_columns[NBREC_BFD_N_COLUMNS];

const struct nbrec_bfd_table *nbrec_bfd_table_get(const struct ovsdb_idl *);
const struct nbrec_bfd *nbrec_bfd_table_first(const struct nbrec_bfd_table *);

#define NBREC_BFD_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_bfd_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_bfd_next(ROW))
#define NBREC_BFD_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_bfd_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_bfd_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_bfd *nbrec_bfd_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_bfd *nbrec_bfd_table_get_for_uuid(const struct nbrec_bfd_table *, const struct uuid *);
const struct nbrec_bfd *nbrec_bfd_first(const struct ovsdb_idl *);
const struct nbrec_bfd *nbrec_bfd_next(const struct nbrec_bfd *);
#define NBREC_BFD_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_bfd_first(IDL); \
             (ROW); \
             (ROW) = nbrec_bfd_next(ROW))
#define NBREC_BFD_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_bfd_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_bfd_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_bfd_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_bfd_row_get_seqno(const struct nbrec_bfd *row, enum ovsdb_idl_change change);
const struct nbrec_bfd *nbrec_bfd_track_get_first(const struct ovsdb_idl *);
const struct nbrec_bfd *nbrec_bfd_track_get_next(const struct nbrec_bfd *);
#define NBREC_BFD_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_bfd_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_bfd_track_get_next(ROW))

const struct nbrec_bfd *nbrec_bfd_table_track_get_first(const struct nbrec_bfd_table *);
#define NBREC_BFD_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_bfd_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_bfd_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_bfd_is_new(const struct nbrec_bfd *row)
{
    return nbrec_bfd_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_bfd_is_deleted(const struct nbrec_bfd *row)
{
    return nbrec_bfd_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_bfd_index_destroy_row(const struct nbrec_bfd *);

struct nbrec_bfd *nbrec_bfd_index_find(struct ovsdb_idl_index *, const struct nbrec_bfd *);

int nbrec_bfd_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_bfd *, 
    const struct nbrec_bfd *);
struct ovsdb_idl_cursor nbrec_bfd_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_bfd_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_bfd *);
struct ovsdb_idl_cursor nbrec_bfd_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_bfd *);

struct nbrec_bfd *nbrec_bfd_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_BFD_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_bfd_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_bfd_cursor_data(&cursor__), \
                  !(TO) || nbrec_bfd_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_BFD_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_bfd_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_bfd_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_BFD_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_bfd_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_bfd_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_bfd_init(struct nbrec_bfd *);
void nbrec_bfd_delete(const struct nbrec_bfd *);
struct nbrec_bfd *nbrec_bfd_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_bfd_column_id' of
 * the row referenced by 'struct nbrec_bfd *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_bfd_is_updated(const struct nbrec_bfd *, enum nbrec_bfd_column_id);

void nbrec_bfd_verify_detect_mult(const struct nbrec_bfd *);
void nbrec_bfd_verify_dst_ip(const struct nbrec_bfd *);
void nbrec_bfd_verify_external_ids(const struct nbrec_bfd *);
void nbrec_bfd_verify_logical_port(const struct nbrec_bfd *);
void nbrec_bfd_verify_min_rx(const struct nbrec_bfd *);
void nbrec_bfd_verify_min_tx(const struct nbrec_bfd *);
void nbrec_bfd_verify_options(const struct nbrec_bfd *);
void nbrec_bfd_verify_status(const struct nbrec_bfd *);

const struct ovsdb_datum *nbrec_bfd_get_detect_mult(const struct nbrec_bfd *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_bfd_get_dst_ip(const struct nbrec_bfd *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_bfd_get_external_ids(const struct nbrec_bfd *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_bfd_get_logical_port(const struct nbrec_bfd *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_bfd_get_min_rx(const struct nbrec_bfd *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_bfd_get_min_tx(const struct nbrec_bfd *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_bfd_get_options(const struct nbrec_bfd *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_bfd_get_status(const struct nbrec_bfd *, enum ovsdb_atomic_type key_type);

void nbrec_bfd_set_detect_mult(const struct nbrec_bfd *, const int64_t *detect_mult, size_t n_detect_mult);
void nbrec_bfd_set_dst_ip(const struct nbrec_bfd *, const char *dst_ip);
void nbrec_bfd_set_external_ids(const struct nbrec_bfd *, const struct smap *);
void nbrec_bfd_set_logical_port(const struct nbrec_bfd *, const char *logical_port);
void nbrec_bfd_set_min_rx(const struct nbrec_bfd *, const int64_t *min_rx, size_t n_min_rx);
void nbrec_bfd_set_min_tx(const struct nbrec_bfd *, const int64_t *min_tx, size_t n_min_tx);
void nbrec_bfd_set_options(const struct nbrec_bfd *, const struct smap *);
void nbrec_bfd_set_status(const struct nbrec_bfd *, const char *status);

void nbrec_bfd_update_detect_mult_addvalue(const struct nbrec_bfd *,  int64_t );
void nbrec_bfd_update_detect_mult_delvalue(const struct nbrec_bfd *,  int64_t );
void nbrec_bfd_add_clause_detect_mult(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *detect_mult, size_t n_detect_mult);
unsigned int nbrec_bfd_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_bfd_add_clause_dst_ip(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *dst_ip);
unsigned int nbrec_bfd_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_bfd_update_external_ids_setkey(const struct nbrec_bfd *,  const char *, const char *);
void nbrec_bfd_update_external_ids_delkey(const struct nbrec_bfd *,  const char *);
void nbrec_bfd_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_bfd_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_bfd_add_clause_logical_port(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *logical_port);
unsigned int nbrec_bfd_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_bfd_update_min_rx_addvalue(const struct nbrec_bfd *,  int64_t );
void nbrec_bfd_update_min_rx_delvalue(const struct nbrec_bfd *,  int64_t );
void nbrec_bfd_add_clause_min_rx(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *min_rx, size_t n_min_rx);
unsigned int nbrec_bfd_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_bfd_update_min_tx_addvalue(const struct nbrec_bfd *,  int64_t );
void nbrec_bfd_update_min_tx_delvalue(const struct nbrec_bfd *,  int64_t );
void nbrec_bfd_add_clause_min_tx(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *min_tx, size_t n_min_tx);
unsigned int nbrec_bfd_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_bfd_update_options_setkey(const struct nbrec_bfd *,  const char *, const char *);
void nbrec_bfd_update_options_delkey(const struct nbrec_bfd *,  const char *);
void nbrec_bfd_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_bfd_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_bfd_update_status_addvalue(const struct nbrec_bfd *,  const char *);
void nbrec_bfd_update_status_delvalue(const struct nbrec_bfd *,  const char *);
void nbrec_bfd_add_clause_status(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *status);
unsigned int nbrec_bfd_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_bfd *nbrec_bfd_index_init_row(struct ovsdb_idl_index *);
void nbrec_bfd_index_set_detect_mult(const struct nbrec_bfd *,
const int64_t *detect_mult, size_t n_detect_mult);
void nbrec_bfd_index_set_dst_ip(const struct nbrec_bfd *,
const char *dst_ip);
void nbrec_bfd_index_set_external_ids(const struct nbrec_bfd *,
const struct smap *);
void nbrec_bfd_index_set_logical_port(const struct nbrec_bfd *,
const char *logical_port);
void nbrec_bfd_index_set_min_rx(const struct nbrec_bfd *,
const int64_t *min_rx, size_t n_min_rx);
void nbrec_bfd_index_set_min_tx(const struct nbrec_bfd *,
const int64_t *min_tx, size_t n_min_tx);
void nbrec_bfd_index_set_options(const struct nbrec_bfd *,
const struct smap *);
void nbrec_bfd_index_set_status(const struct nbrec_bfd *,
const char *status);

/* Connection table. */
struct nbrec_connection {
	struct ovsdb_idl_row header_;

	/* external_ids column. */
	struct smap external_ids;

	/* inactivity_probe column. */
	int64_t *inactivity_probe;
	size_t n_inactivity_probe;

	/* is_connected column. */
	bool is_connected;

	/* max_backoff column. */
	int64_t *max_backoff;
	size_t n_max_backoff;

	/* other_config column. */
	struct smap other_config;

	/* status column. */
	struct smap status;

	/* target column. */
	char *target;	/* Always nonnull. */
};

enum nbrec_connection_column_id {
    NBREC_CONNECTION_COL_EXTERNAL_IDS,
    NBREC_CONNECTION_COL_INACTIVITY_PROBE,
    NBREC_CONNECTION_COL_IS_CONNECTED,
    NBREC_CONNECTION_COL_MAX_BACKOFF,
    NBREC_CONNECTION_COL_OTHER_CONFIG,
    NBREC_CONNECTION_COL_STATUS,
    NBREC_CONNECTION_COL_TARGET,
    NBREC_CONNECTION_N_COLUMNS
};

#define nbrec_connection_col_external_ids (nbrec_connection_columns[NBREC_CONNECTION_COL_EXTERNAL_IDS])
#define nbrec_connection_col_inactivity_probe (nbrec_connection_columns[NBREC_CONNECTION_COL_INACTIVITY_PROBE])
#define nbrec_connection_col_is_connected (nbrec_connection_columns[NBREC_CONNECTION_COL_IS_CONNECTED])
#define nbrec_connection_col_max_backoff (nbrec_connection_columns[NBREC_CONNECTION_COL_MAX_BACKOFF])
#define nbrec_connection_col_other_config (nbrec_connection_columns[NBREC_CONNECTION_COL_OTHER_CONFIG])
#define nbrec_connection_col_status (nbrec_connection_columns[NBREC_CONNECTION_COL_STATUS])
#define nbrec_connection_col_target (nbrec_connection_columns[NBREC_CONNECTION_COL_TARGET])

extern struct ovsdb_idl_column nbrec_connection_columns[NBREC_CONNECTION_N_COLUMNS];

const struct nbrec_connection_table *nbrec_connection_table_get(const struct ovsdb_idl *);
const struct nbrec_connection *nbrec_connection_table_first(const struct nbrec_connection_table *);

#define NBREC_CONNECTION_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_connection_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_connection_next(ROW))
#define NBREC_CONNECTION_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_connection_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_connection_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_connection *nbrec_connection_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_connection *nbrec_connection_table_get_for_uuid(const struct nbrec_connection_table *, const struct uuid *);
const struct nbrec_connection *nbrec_connection_first(const struct ovsdb_idl *);
const struct nbrec_connection *nbrec_connection_next(const struct nbrec_connection *);
#define NBREC_CONNECTION_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_connection_first(IDL); \
             (ROW); \
             (ROW) = nbrec_connection_next(ROW))
#define NBREC_CONNECTION_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_connection_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_connection_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_connection_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_connection_row_get_seqno(const struct nbrec_connection *row, enum ovsdb_idl_change change);
const struct nbrec_connection *nbrec_connection_track_get_first(const struct ovsdb_idl *);
const struct nbrec_connection *nbrec_connection_track_get_next(const struct nbrec_connection *);
#define NBREC_CONNECTION_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_connection_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_connection_track_get_next(ROW))

const struct nbrec_connection *nbrec_connection_table_track_get_first(const struct nbrec_connection_table *);
#define NBREC_CONNECTION_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_connection_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_connection_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_connection_is_new(const struct nbrec_connection *row)
{
    return nbrec_connection_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_connection_is_deleted(const struct nbrec_connection *row)
{
    return nbrec_connection_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_connection_index_destroy_row(const struct nbrec_connection *);

struct nbrec_connection *nbrec_connection_index_find(struct ovsdb_idl_index *, const struct nbrec_connection *);

int nbrec_connection_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_connection *, 
    const struct nbrec_connection *);
struct ovsdb_idl_cursor nbrec_connection_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_connection_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_connection *);
struct ovsdb_idl_cursor nbrec_connection_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_connection *);

struct nbrec_connection *nbrec_connection_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_CONNECTION_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_connection_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_connection_cursor_data(&cursor__), \
                  !(TO) || nbrec_connection_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_CONNECTION_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_connection_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_connection_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_CONNECTION_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_connection_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_connection_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_connection_init(struct nbrec_connection *);
void nbrec_connection_delete(const struct nbrec_connection *);
struct nbrec_connection *nbrec_connection_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_connection_column_id' of
 * the row referenced by 'struct nbrec_connection *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_connection_is_updated(const struct nbrec_connection *, enum nbrec_connection_column_id);

void nbrec_connection_verify_external_ids(const struct nbrec_connection *);
void nbrec_connection_verify_inactivity_probe(const struct nbrec_connection *);
void nbrec_connection_verify_is_connected(const struct nbrec_connection *);
void nbrec_connection_verify_max_backoff(const struct nbrec_connection *);
void nbrec_connection_verify_other_config(const struct nbrec_connection *);
void nbrec_connection_verify_status(const struct nbrec_connection *);
void nbrec_connection_verify_target(const struct nbrec_connection *);

const struct ovsdb_datum *nbrec_connection_get_external_ids(const struct nbrec_connection *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_connection_get_inactivity_probe(const struct nbrec_connection *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_connection_get_is_connected(const struct nbrec_connection *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_connection_get_max_backoff(const struct nbrec_connection *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_connection_get_other_config(const struct nbrec_connection *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_connection_get_status(const struct nbrec_connection *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_connection_get_target(const struct nbrec_connection *, enum ovsdb_atomic_type key_type);

void nbrec_connection_set_external_ids(const struct nbrec_connection *, const struct smap *);
void nbrec_connection_set_inactivity_probe(const struct nbrec_connection *, const int64_t *inactivity_probe, size_t n_inactivity_probe);
void nbrec_connection_set_is_connected(const struct nbrec_connection *, bool is_connected);
void nbrec_connection_set_max_backoff(const struct nbrec_connection *, const int64_t *max_backoff, size_t n_max_backoff);
void nbrec_connection_set_other_config(const struct nbrec_connection *, const struct smap *);
void nbrec_connection_set_status(const struct nbrec_connection *, const struct smap *);
void nbrec_connection_set_target(const struct nbrec_connection *, const char *target);

void nbrec_connection_update_external_ids_setkey(const struct nbrec_connection *,  const char *, const char *);
void nbrec_connection_update_external_ids_delkey(const struct nbrec_connection *,  const char *);
void nbrec_connection_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_connection_update_inactivity_probe_addvalue(const struct nbrec_connection *,  int64_t );
void nbrec_connection_update_inactivity_probe_delvalue(const struct nbrec_connection *,  int64_t );
void nbrec_connection_add_clause_inactivity_probe(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *inactivity_probe, size_t n_inactivity_probe);
unsigned int nbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_connection_add_clause_is_connected(struct ovsdb_idl_condition *, enum ovsdb_function function, bool is_connected);
unsigned int nbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_connection_update_max_backoff_addvalue(const struct nbrec_connection *,  int64_t );
void nbrec_connection_update_max_backoff_delvalue(const struct nbrec_connection *,  int64_t );
void nbrec_connection_add_clause_max_backoff(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *max_backoff, size_t n_max_backoff);
unsigned int nbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_connection_update_other_config_setkey(const struct nbrec_connection *,  const char *, const char *);
void nbrec_connection_update_other_config_delkey(const struct nbrec_connection *,  const char *);
void nbrec_connection_add_clause_other_config(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_connection_update_status_setkey(const struct nbrec_connection *,  const char *, const char *);
void nbrec_connection_update_status_delkey(const struct nbrec_connection *,  const char *);
void nbrec_connection_add_clause_status(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_connection_add_clause_target(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *target);
unsigned int nbrec_connection_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_connection *nbrec_connection_index_init_row(struct ovsdb_idl_index *);
void nbrec_connection_index_set_external_ids(const struct nbrec_connection *,
const struct smap *);
void nbrec_connection_index_set_inactivity_probe(const struct nbrec_connection *,
const int64_t *inactivity_probe, size_t n_inactivity_probe);
void nbrec_connection_index_set_is_connected(const struct nbrec_connection *,
bool is_connected);
void nbrec_connection_index_set_max_backoff(const struct nbrec_connection *,
const int64_t *max_backoff, size_t n_max_backoff);
void nbrec_connection_index_set_other_config(const struct nbrec_connection *,
const struct smap *);
void nbrec_connection_index_set_status(const struct nbrec_connection *,
const struct smap *);
void nbrec_connection_index_set_target(const struct nbrec_connection *,
const char *target);

/* DHCP_Options table. */
struct nbrec_dhcp_options {
	struct ovsdb_idl_row header_;

	/* cidr column. */
	char *cidr;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* options column. */
	struct smap options;
};

enum nbrec_dhcp_options_column_id {
    NBREC_DHCP_OPTIONS_COL_CIDR,
    NBREC_DHCP_OPTIONS_COL_EXTERNAL_IDS,
    NBREC_DHCP_OPTIONS_COL_OPTIONS,
    NBREC_DHCP_OPTIONS_N_COLUMNS
};

#define nbrec_dhcp_options_col_cidr (nbrec_dhcp_options_columns[NBREC_DHCP_OPTIONS_COL_CIDR])
#define nbrec_dhcp_options_col_external_ids (nbrec_dhcp_options_columns[NBREC_DHCP_OPTIONS_COL_EXTERNAL_IDS])
#define nbrec_dhcp_options_col_options (nbrec_dhcp_options_columns[NBREC_DHCP_OPTIONS_COL_OPTIONS])

extern struct ovsdb_idl_column nbrec_dhcp_options_columns[NBREC_DHCP_OPTIONS_N_COLUMNS];

const struct nbrec_dhcp_options_table *nbrec_dhcp_options_table_get(const struct ovsdb_idl *);
const struct nbrec_dhcp_options *nbrec_dhcp_options_table_first(const struct nbrec_dhcp_options_table *);

#define NBREC_DHCP_OPTIONS_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_dhcp_options_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_dhcp_options_next(ROW))
#define NBREC_DHCP_OPTIONS_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_dhcp_options_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_dhcp_options_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_dhcp_options *nbrec_dhcp_options_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_dhcp_options *nbrec_dhcp_options_table_get_for_uuid(const struct nbrec_dhcp_options_table *, const struct uuid *);
const struct nbrec_dhcp_options *nbrec_dhcp_options_first(const struct ovsdb_idl *);
const struct nbrec_dhcp_options *nbrec_dhcp_options_next(const struct nbrec_dhcp_options *);
#define NBREC_DHCP_OPTIONS_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_dhcp_options_first(IDL); \
             (ROW); \
             (ROW) = nbrec_dhcp_options_next(ROW))
#define NBREC_DHCP_OPTIONS_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_dhcp_options_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_dhcp_options_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_dhcp_options_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_dhcp_options_row_get_seqno(const struct nbrec_dhcp_options *row, enum ovsdb_idl_change change);
const struct nbrec_dhcp_options *nbrec_dhcp_options_track_get_first(const struct ovsdb_idl *);
const struct nbrec_dhcp_options *nbrec_dhcp_options_track_get_next(const struct nbrec_dhcp_options *);
#define NBREC_DHCP_OPTIONS_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_dhcp_options_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_dhcp_options_track_get_next(ROW))

const struct nbrec_dhcp_options *nbrec_dhcp_options_table_track_get_first(const struct nbrec_dhcp_options_table *);
#define NBREC_DHCP_OPTIONS_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_dhcp_options_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_dhcp_options_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_dhcp_options_is_new(const struct nbrec_dhcp_options *row)
{
    return nbrec_dhcp_options_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_dhcp_options_is_deleted(const struct nbrec_dhcp_options *row)
{
    return nbrec_dhcp_options_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_dhcp_options_index_destroy_row(const struct nbrec_dhcp_options *);

struct nbrec_dhcp_options *nbrec_dhcp_options_index_find(struct ovsdb_idl_index *, const struct nbrec_dhcp_options *);

int nbrec_dhcp_options_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_dhcp_options *, 
    const struct nbrec_dhcp_options *);
struct ovsdb_idl_cursor nbrec_dhcp_options_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_dhcp_options_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_dhcp_options *);
struct ovsdb_idl_cursor nbrec_dhcp_options_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_dhcp_options *);

struct nbrec_dhcp_options *nbrec_dhcp_options_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_DHCP_OPTIONS_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_dhcp_options_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_dhcp_options_cursor_data(&cursor__), \
                  !(TO) || nbrec_dhcp_options_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_DHCP_OPTIONS_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_dhcp_options_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_dhcp_options_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_DHCP_OPTIONS_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_dhcp_options_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_dhcp_options_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_dhcp_options_init(struct nbrec_dhcp_options *);
void nbrec_dhcp_options_delete(const struct nbrec_dhcp_options *);
struct nbrec_dhcp_options *nbrec_dhcp_options_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_dhcp_options_column_id' of
 * the row referenced by 'struct nbrec_dhcp_options *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_dhcp_options_is_updated(const struct nbrec_dhcp_options *, enum nbrec_dhcp_options_column_id);

void nbrec_dhcp_options_verify_cidr(const struct nbrec_dhcp_options *);
void nbrec_dhcp_options_verify_external_ids(const struct nbrec_dhcp_options *);
void nbrec_dhcp_options_verify_options(const struct nbrec_dhcp_options *);

const struct ovsdb_datum *nbrec_dhcp_options_get_cidr(const struct nbrec_dhcp_options *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_dhcp_options_get_external_ids(const struct nbrec_dhcp_options *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_dhcp_options_get_options(const struct nbrec_dhcp_options *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);

void nbrec_dhcp_options_set_cidr(const struct nbrec_dhcp_options *, const char *cidr);
void nbrec_dhcp_options_set_external_ids(const struct nbrec_dhcp_options *, const struct smap *);
void nbrec_dhcp_options_set_options(const struct nbrec_dhcp_options *, const struct smap *);

void nbrec_dhcp_options_add_clause_cidr(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *cidr);
unsigned int nbrec_dhcp_options_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_dhcp_options_update_external_ids_setkey(const struct nbrec_dhcp_options *,  const char *, const char *);
void nbrec_dhcp_options_update_external_ids_delkey(const struct nbrec_dhcp_options *,  const char *);
void nbrec_dhcp_options_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_dhcp_options_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_dhcp_options_update_options_setkey(const struct nbrec_dhcp_options *,  const char *, const char *);
void nbrec_dhcp_options_update_options_delkey(const struct nbrec_dhcp_options *,  const char *);
void nbrec_dhcp_options_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_dhcp_options_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_dhcp_options *nbrec_dhcp_options_index_init_row(struct ovsdb_idl_index *);
void nbrec_dhcp_options_index_set_cidr(const struct nbrec_dhcp_options *,
const char *cidr);
void nbrec_dhcp_options_index_set_external_ids(const struct nbrec_dhcp_options *,
const struct smap *);
void nbrec_dhcp_options_index_set_options(const struct nbrec_dhcp_options *,
const struct smap *);

/* DNS table. */
struct nbrec_dns {
	struct ovsdb_idl_row header_;

	/* external_ids column. */
	struct smap external_ids;

	/* records column. */
	struct smap records;
};

enum nbrec_dns_column_id {
    NBREC_DNS_COL_EXTERNAL_IDS,
    NBREC_DNS_COL_RECORDS,
    NBREC_DNS_N_COLUMNS
};

#define nbrec_dns_col_external_ids (nbrec_dns_columns[NBREC_DNS_COL_EXTERNAL_IDS])
#define nbrec_dns_col_records (nbrec_dns_columns[NBREC_DNS_COL_RECORDS])

extern struct ovsdb_idl_column nbrec_dns_columns[NBREC_DNS_N_COLUMNS];

const struct nbrec_dns_table *nbrec_dns_table_get(const struct ovsdb_idl *);
const struct nbrec_dns *nbrec_dns_table_first(const struct nbrec_dns_table *);

#define NBREC_DNS_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_dns_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_dns_next(ROW))
#define NBREC_DNS_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_dns_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_dns_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_dns *nbrec_dns_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_dns *nbrec_dns_table_get_for_uuid(const struct nbrec_dns_table *, const struct uuid *);
const struct nbrec_dns *nbrec_dns_first(const struct ovsdb_idl *);
const struct nbrec_dns *nbrec_dns_next(const struct nbrec_dns *);
#define NBREC_DNS_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_dns_first(IDL); \
             (ROW); \
             (ROW) = nbrec_dns_next(ROW))
#define NBREC_DNS_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_dns_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_dns_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_dns_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_dns_row_get_seqno(const struct nbrec_dns *row, enum ovsdb_idl_change change);
const struct nbrec_dns *nbrec_dns_track_get_first(const struct ovsdb_idl *);
const struct nbrec_dns *nbrec_dns_track_get_next(const struct nbrec_dns *);
#define NBREC_DNS_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_dns_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_dns_track_get_next(ROW))

const struct nbrec_dns *nbrec_dns_table_track_get_first(const struct nbrec_dns_table *);
#define NBREC_DNS_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_dns_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_dns_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_dns_is_new(const struct nbrec_dns *row)
{
    return nbrec_dns_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_dns_is_deleted(const struct nbrec_dns *row)
{
    return nbrec_dns_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_dns_index_destroy_row(const struct nbrec_dns *);

struct nbrec_dns *nbrec_dns_index_find(struct ovsdb_idl_index *, const struct nbrec_dns *);

int nbrec_dns_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_dns *, 
    const struct nbrec_dns *);
struct ovsdb_idl_cursor nbrec_dns_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_dns_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_dns *);
struct ovsdb_idl_cursor nbrec_dns_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_dns *);

struct nbrec_dns *nbrec_dns_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_DNS_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_dns_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_dns_cursor_data(&cursor__), \
                  !(TO) || nbrec_dns_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_DNS_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_dns_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_dns_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_DNS_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_dns_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_dns_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_dns_init(struct nbrec_dns *);
void nbrec_dns_delete(const struct nbrec_dns *);
struct nbrec_dns *nbrec_dns_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_dns_column_id' of
 * the row referenced by 'struct nbrec_dns *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_dns_is_updated(const struct nbrec_dns *, enum nbrec_dns_column_id);

void nbrec_dns_verify_external_ids(const struct nbrec_dns *);
void nbrec_dns_verify_records(const struct nbrec_dns *);

const struct ovsdb_datum *nbrec_dns_get_external_ids(const struct nbrec_dns *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_dns_get_records(const struct nbrec_dns *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);

void nbrec_dns_set_external_ids(const struct nbrec_dns *, const struct smap *);
void nbrec_dns_set_records(const struct nbrec_dns *, const struct smap *);

void nbrec_dns_update_external_ids_setkey(const struct nbrec_dns *,  const char *, const char *);
void nbrec_dns_update_external_ids_delkey(const struct nbrec_dns *,  const char *);
void nbrec_dns_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_dns_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_dns_update_records_setkey(const struct nbrec_dns *,  const char *, const char *);
void nbrec_dns_update_records_delkey(const struct nbrec_dns *,  const char *);
void nbrec_dns_add_clause_records(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_dns_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_dns *nbrec_dns_index_init_row(struct ovsdb_idl_index *);
void nbrec_dns_index_set_external_ids(const struct nbrec_dns *,
const struct smap *);
void nbrec_dns_index_set_records(const struct nbrec_dns *,
const struct smap *);

/* Forwarding_Group table. */
struct nbrec_forwarding_group {
	struct ovsdb_idl_row header_;

	/* child_port column. */
	char **child_port;
	size_t n_child_port;

	/* external_ids column. */
	struct smap external_ids;

	/* liveness column. */
	bool liveness;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* vip column. */
	char *vip;	/* Always nonnull. */

	/* vmac column. */
	char *vmac;	/* Always nonnull. */
};

enum nbrec_forwarding_group_column_id {
    NBREC_FORWARDING_GROUP_COL_CHILD_PORT,
    NBREC_FORWARDING_GROUP_COL_EXTERNAL_IDS,
    NBREC_FORWARDING_GROUP_COL_LIVENESS,
    NBREC_FORWARDING_GROUP_COL_NAME,
    NBREC_FORWARDING_GROUP_COL_VIP,
    NBREC_FORWARDING_GROUP_COL_VMAC,
    NBREC_FORWARDING_GROUP_N_COLUMNS
};

#define nbrec_forwarding_group_col_child_port (nbrec_forwarding_group_columns[NBREC_FORWARDING_GROUP_COL_CHILD_PORT])
#define nbrec_forwarding_group_col_external_ids (nbrec_forwarding_group_columns[NBREC_FORWARDING_GROUP_COL_EXTERNAL_IDS])
#define nbrec_forwarding_group_col_liveness (nbrec_forwarding_group_columns[NBREC_FORWARDING_GROUP_COL_LIVENESS])
#define nbrec_forwarding_group_col_name (nbrec_forwarding_group_columns[NBREC_FORWARDING_GROUP_COL_NAME])
#define nbrec_forwarding_group_col_vip (nbrec_forwarding_group_columns[NBREC_FORWARDING_GROUP_COL_VIP])
#define nbrec_forwarding_group_col_vmac (nbrec_forwarding_group_columns[NBREC_FORWARDING_GROUP_COL_VMAC])

extern struct ovsdb_idl_column nbrec_forwarding_group_columns[NBREC_FORWARDING_GROUP_N_COLUMNS];

const struct nbrec_forwarding_group_table *nbrec_forwarding_group_table_get(const struct ovsdb_idl *);
const struct nbrec_forwarding_group *nbrec_forwarding_group_table_first(const struct nbrec_forwarding_group_table *);

#define NBREC_FORWARDING_GROUP_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_forwarding_group_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_forwarding_group_next(ROW))
#define NBREC_FORWARDING_GROUP_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_forwarding_group_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_forwarding_group_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_forwarding_group *nbrec_forwarding_group_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_forwarding_group *nbrec_forwarding_group_table_get_for_uuid(const struct nbrec_forwarding_group_table *, const struct uuid *);
const struct nbrec_forwarding_group *nbrec_forwarding_group_first(const struct ovsdb_idl *);
const struct nbrec_forwarding_group *nbrec_forwarding_group_next(const struct nbrec_forwarding_group *);
#define NBREC_FORWARDING_GROUP_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_forwarding_group_first(IDL); \
             (ROW); \
             (ROW) = nbrec_forwarding_group_next(ROW))
#define NBREC_FORWARDING_GROUP_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_forwarding_group_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_forwarding_group_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_forwarding_group_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_forwarding_group_row_get_seqno(const struct nbrec_forwarding_group *row, enum ovsdb_idl_change change);
const struct nbrec_forwarding_group *nbrec_forwarding_group_track_get_first(const struct ovsdb_idl *);
const struct nbrec_forwarding_group *nbrec_forwarding_group_track_get_next(const struct nbrec_forwarding_group *);
#define NBREC_FORWARDING_GROUP_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_forwarding_group_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_forwarding_group_track_get_next(ROW))

const struct nbrec_forwarding_group *nbrec_forwarding_group_table_track_get_first(const struct nbrec_forwarding_group_table *);
#define NBREC_FORWARDING_GROUP_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_forwarding_group_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_forwarding_group_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_forwarding_group_is_new(const struct nbrec_forwarding_group *row)
{
    return nbrec_forwarding_group_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_forwarding_group_is_deleted(const struct nbrec_forwarding_group *row)
{
    return nbrec_forwarding_group_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_forwarding_group_index_destroy_row(const struct nbrec_forwarding_group *);

struct nbrec_forwarding_group *nbrec_forwarding_group_index_find(struct ovsdb_idl_index *, const struct nbrec_forwarding_group *);

int nbrec_forwarding_group_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_forwarding_group *, 
    const struct nbrec_forwarding_group *);
struct ovsdb_idl_cursor nbrec_forwarding_group_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_forwarding_group_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_forwarding_group *);
struct ovsdb_idl_cursor nbrec_forwarding_group_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_forwarding_group *);

struct nbrec_forwarding_group *nbrec_forwarding_group_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_FORWARDING_GROUP_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_forwarding_group_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_forwarding_group_cursor_data(&cursor__), \
                  !(TO) || nbrec_forwarding_group_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_FORWARDING_GROUP_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_forwarding_group_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_forwarding_group_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_FORWARDING_GROUP_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_forwarding_group_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_forwarding_group_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_forwarding_group_init(struct nbrec_forwarding_group *);
void nbrec_forwarding_group_delete(const struct nbrec_forwarding_group *);
struct nbrec_forwarding_group *nbrec_forwarding_group_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_forwarding_group_column_id' of
 * the row referenced by 'struct nbrec_forwarding_group *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_forwarding_group_is_updated(const struct nbrec_forwarding_group *, enum nbrec_forwarding_group_column_id);

void nbrec_forwarding_group_verify_child_port(const struct nbrec_forwarding_group *);
void nbrec_forwarding_group_verify_external_ids(const struct nbrec_forwarding_group *);
void nbrec_forwarding_group_verify_liveness(const struct nbrec_forwarding_group *);
void nbrec_forwarding_group_verify_name(const struct nbrec_forwarding_group *);
void nbrec_forwarding_group_verify_vip(const struct nbrec_forwarding_group *);
void nbrec_forwarding_group_verify_vmac(const struct nbrec_forwarding_group *);

const struct ovsdb_datum *nbrec_forwarding_group_get_child_port(const struct nbrec_forwarding_group *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_forwarding_group_get_external_ids(const struct nbrec_forwarding_group *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_forwarding_group_get_liveness(const struct nbrec_forwarding_group *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_forwarding_group_get_name(const struct nbrec_forwarding_group *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_forwarding_group_get_vip(const struct nbrec_forwarding_group *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_forwarding_group_get_vmac(const struct nbrec_forwarding_group *, enum ovsdb_atomic_type key_type);

void nbrec_forwarding_group_set_child_port(const struct nbrec_forwarding_group *, const char **child_port, size_t n_child_port);
void nbrec_forwarding_group_set_external_ids(const struct nbrec_forwarding_group *, const struct smap *);
void nbrec_forwarding_group_set_liveness(const struct nbrec_forwarding_group *, bool liveness);
void nbrec_forwarding_group_set_name(const struct nbrec_forwarding_group *, const char *name);
void nbrec_forwarding_group_set_vip(const struct nbrec_forwarding_group *, const char *vip);
void nbrec_forwarding_group_set_vmac(const struct nbrec_forwarding_group *, const char *vmac);

void nbrec_forwarding_group_update_child_port_addvalue(const struct nbrec_forwarding_group *,  const char *);
void nbrec_forwarding_group_update_child_port_delvalue(const struct nbrec_forwarding_group *,  const char *);
void nbrec_forwarding_group_add_clause_child_port(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **child_port, size_t n_child_port);
unsigned int nbrec_forwarding_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_forwarding_group_update_external_ids_setkey(const struct nbrec_forwarding_group *,  const char *, const char *);
void nbrec_forwarding_group_update_external_ids_delkey(const struct nbrec_forwarding_group *,  const char *);
void nbrec_forwarding_group_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_forwarding_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_forwarding_group_add_clause_liveness(struct ovsdb_idl_condition *, enum ovsdb_function function, bool liveness);
unsigned int nbrec_forwarding_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_forwarding_group_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_forwarding_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_forwarding_group_add_clause_vip(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *vip);
unsigned int nbrec_forwarding_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_forwarding_group_add_clause_vmac(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *vmac);
unsigned int nbrec_forwarding_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_forwarding_group *nbrec_forwarding_group_index_init_row(struct ovsdb_idl_index *);
void nbrec_forwarding_group_index_set_child_port(const struct nbrec_forwarding_group *,
const char **child_port, size_t n_child_port);
void nbrec_forwarding_group_index_set_external_ids(const struct nbrec_forwarding_group *,
const struct smap *);
void nbrec_forwarding_group_index_set_liveness(const struct nbrec_forwarding_group *,
bool liveness);
void nbrec_forwarding_group_index_set_name(const struct nbrec_forwarding_group *,
const char *name);
void nbrec_forwarding_group_index_set_vip(const struct nbrec_forwarding_group *,
const char *vip);
void nbrec_forwarding_group_index_set_vmac(const struct nbrec_forwarding_group *,
const char *vmac);

/* Gateway_Chassis table. */
struct nbrec_gateway_chassis {
	struct ovsdb_idl_row header_;

	/* chassis_name column. */
	char *chassis_name;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* options column. */
	struct smap options;

	/* priority column. */
	int64_t priority;
};

enum nbrec_gateway_chassis_column_id {
    NBREC_GATEWAY_CHASSIS_COL_CHASSIS_NAME,
    NBREC_GATEWAY_CHASSIS_COL_EXTERNAL_IDS,
    NBREC_GATEWAY_CHASSIS_COL_NAME,
    NBREC_GATEWAY_CHASSIS_COL_OPTIONS,
    NBREC_GATEWAY_CHASSIS_COL_PRIORITY,
    NBREC_GATEWAY_CHASSIS_N_COLUMNS
};

#define nbrec_gateway_chassis_col_chassis_name (nbrec_gateway_chassis_columns[NBREC_GATEWAY_CHASSIS_COL_CHASSIS_NAME])
#define nbrec_gateway_chassis_col_external_ids (nbrec_gateway_chassis_columns[NBREC_GATEWAY_CHASSIS_COL_EXTERNAL_IDS])
#define nbrec_gateway_chassis_col_name (nbrec_gateway_chassis_columns[NBREC_GATEWAY_CHASSIS_COL_NAME])
#define nbrec_gateway_chassis_col_options (nbrec_gateway_chassis_columns[NBREC_GATEWAY_CHASSIS_COL_OPTIONS])
#define nbrec_gateway_chassis_col_priority (nbrec_gateway_chassis_columns[NBREC_GATEWAY_CHASSIS_COL_PRIORITY])

extern struct ovsdb_idl_column nbrec_gateway_chassis_columns[NBREC_GATEWAY_CHASSIS_N_COLUMNS];

const struct nbrec_gateway_chassis_table *nbrec_gateway_chassis_table_get(const struct ovsdb_idl *);
const struct nbrec_gateway_chassis *nbrec_gateway_chassis_table_first(const struct nbrec_gateway_chassis_table *);

#define NBREC_GATEWAY_CHASSIS_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_gateway_chassis_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_gateway_chassis_next(ROW))
#define NBREC_GATEWAY_CHASSIS_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_gateway_chassis_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_gateway_chassis_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_gateway_chassis *nbrec_gateway_chassis_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_gateway_chassis *nbrec_gateway_chassis_table_get_for_uuid(const struct nbrec_gateway_chassis_table *, const struct uuid *);
const struct nbrec_gateway_chassis *nbrec_gateway_chassis_first(const struct ovsdb_idl *);
const struct nbrec_gateway_chassis *nbrec_gateway_chassis_next(const struct nbrec_gateway_chassis *);
#define NBREC_GATEWAY_CHASSIS_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_gateway_chassis_first(IDL); \
             (ROW); \
             (ROW) = nbrec_gateway_chassis_next(ROW))
#define NBREC_GATEWAY_CHASSIS_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_gateway_chassis_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_gateway_chassis_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_gateway_chassis_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_gateway_chassis_row_get_seqno(const struct nbrec_gateway_chassis *row, enum ovsdb_idl_change change);
const struct nbrec_gateway_chassis *nbrec_gateway_chassis_track_get_first(const struct ovsdb_idl *);
const struct nbrec_gateway_chassis *nbrec_gateway_chassis_track_get_next(const struct nbrec_gateway_chassis *);
#define NBREC_GATEWAY_CHASSIS_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_gateway_chassis_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_gateway_chassis_track_get_next(ROW))

const struct nbrec_gateway_chassis *nbrec_gateway_chassis_table_track_get_first(const struct nbrec_gateway_chassis_table *);
#define NBREC_GATEWAY_CHASSIS_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_gateway_chassis_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_gateway_chassis_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_gateway_chassis_is_new(const struct nbrec_gateway_chassis *row)
{
    return nbrec_gateway_chassis_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_gateway_chassis_is_deleted(const struct nbrec_gateway_chassis *row)
{
    return nbrec_gateway_chassis_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_gateway_chassis_index_destroy_row(const struct nbrec_gateway_chassis *);

struct nbrec_gateway_chassis *nbrec_gateway_chassis_index_find(struct ovsdb_idl_index *, const struct nbrec_gateway_chassis *);

int nbrec_gateway_chassis_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_gateway_chassis *, 
    const struct nbrec_gateway_chassis *);
struct ovsdb_idl_cursor nbrec_gateway_chassis_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_gateway_chassis_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_gateway_chassis *);
struct ovsdb_idl_cursor nbrec_gateway_chassis_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_gateway_chassis *);

struct nbrec_gateway_chassis *nbrec_gateway_chassis_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_GATEWAY_CHASSIS_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_gateway_chassis_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_gateway_chassis_cursor_data(&cursor__), \
                  !(TO) || nbrec_gateway_chassis_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_GATEWAY_CHASSIS_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_gateway_chassis_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_gateway_chassis_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_GATEWAY_CHASSIS_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_gateway_chassis_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_gateway_chassis_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_gateway_chassis_init(struct nbrec_gateway_chassis *);
void nbrec_gateway_chassis_delete(const struct nbrec_gateway_chassis *);
struct nbrec_gateway_chassis *nbrec_gateway_chassis_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_gateway_chassis_column_id' of
 * the row referenced by 'struct nbrec_gateway_chassis *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_gateway_chassis_is_updated(const struct nbrec_gateway_chassis *, enum nbrec_gateway_chassis_column_id);

void nbrec_gateway_chassis_verify_chassis_name(const struct nbrec_gateway_chassis *);
void nbrec_gateway_chassis_verify_external_ids(const struct nbrec_gateway_chassis *);
void nbrec_gateway_chassis_verify_name(const struct nbrec_gateway_chassis *);
void nbrec_gateway_chassis_verify_options(const struct nbrec_gateway_chassis *);
void nbrec_gateway_chassis_verify_priority(const struct nbrec_gateway_chassis *);

const struct ovsdb_datum *nbrec_gateway_chassis_get_chassis_name(const struct nbrec_gateway_chassis *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_gateway_chassis_get_external_ids(const struct nbrec_gateway_chassis *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_gateway_chassis_get_name(const struct nbrec_gateway_chassis *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_gateway_chassis_get_options(const struct nbrec_gateway_chassis *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_gateway_chassis_get_priority(const struct nbrec_gateway_chassis *, enum ovsdb_atomic_type key_type);

void nbrec_gateway_chassis_set_chassis_name(const struct nbrec_gateway_chassis *, const char *chassis_name);
void nbrec_gateway_chassis_set_external_ids(const struct nbrec_gateway_chassis *, const struct smap *);
void nbrec_gateway_chassis_set_name(const struct nbrec_gateway_chassis *, const char *name);
void nbrec_gateway_chassis_set_options(const struct nbrec_gateway_chassis *, const struct smap *);
void nbrec_gateway_chassis_set_priority(const struct nbrec_gateway_chassis *, int64_t priority);

void nbrec_gateway_chassis_add_clause_chassis_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *chassis_name);
unsigned int nbrec_gateway_chassis_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_gateway_chassis_update_external_ids_setkey(const struct nbrec_gateway_chassis *,  const char *, const char *);
void nbrec_gateway_chassis_update_external_ids_delkey(const struct nbrec_gateway_chassis *,  const char *);
void nbrec_gateway_chassis_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_gateway_chassis_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_gateway_chassis_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_gateway_chassis_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_gateway_chassis_update_options_setkey(const struct nbrec_gateway_chassis *,  const char *, const char *);
void nbrec_gateway_chassis_update_options_delkey(const struct nbrec_gateway_chassis *,  const char *);
void nbrec_gateway_chassis_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_gateway_chassis_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_gateway_chassis_add_clause_priority(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t priority);
unsigned int nbrec_gateway_chassis_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_gateway_chassis *nbrec_gateway_chassis_index_init_row(struct ovsdb_idl_index *);
void nbrec_gateway_chassis_index_set_chassis_name(const struct nbrec_gateway_chassis *,
const char *chassis_name);
void nbrec_gateway_chassis_index_set_external_ids(const struct nbrec_gateway_chassis *,
const struct smap *);
void nbrec_gateway_chassis_index_set_name(const struct nbrec_gateway_chassis *,
const char *name);
void nbrec_gateway_chassis_index_set_options(const struct nbrec_gateway_chassis *,
const struct smap *);
void nbrec_gateway_chassis_index_set_priority(const struct nbrec_gateway_chassis *,
int64_t priority);

/* HA_Chassis table. */
struct nbrec_ha_chassis {
	struct ovsdb_idl_row header_;

	/* chassis_name column. */
	char *chassis_name;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* priority column. */
	int64_t priority;
};

enum nbrec_ha_chassis_column_id {
    NBREC_HA_CHASSIS_COL_CHASSIS_NAME,
    NBREC_HA_CHASSIS_COL_EXTERNAL_IDS,
    NBREC_HA_CHASSIS_COL_PRIORITY,
    NBREC_HA_CHASSIS_N_COLUMNS
};

#define nbrec_ha_chassis_col_chassis_name (nbrec_ha_chassis_columns[NBREC_HA_CHASSIS_COL_CHASSIS_NAME])
#define nbrec_ha_chassis_col_external_ids (nbrec_ha_chassis_columns[NBREC_HA_CHASSIS_COL_EXTERNAL_IDS])
#define nbrec_ha_chassis_col_priority (nbrec_ha_chassis_columns[NBREC_HA_CHASSIS_COL_PRIORITY])

extern struct ovsdb_idl_column nbrec_ha_chassis_columns[NBREC_HA_CHASSIS_N_COLUMNS];

const struct nbrec_ha_chassis_table *nbrec_ha_chassis_table_get(const struct ovsdb_idl *);
const struct nbrec_ha_chassis *nbrec_ha_chassis_table_first(const struct nbrec_ha_chassis_table *);

#define NBREC_HA_CHASSIS_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_ha_chassis_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_ha_chassis_next(ROW))
#define NBREC_HA_CHASSIS_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_ha_chassis_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_ha_chassis_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_ha_chassis *nbrec_ha_chassis_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_ha_chassis *nbrec_ha_chassis_table_get_for_uuid(const struct nbrec_ha_chassis_table *, const struct uuid *);
const struct nbrec_ha_chassis *nbrec_ha_chassis_first(const struct ovsdb_idl *);
const struct nbrec_ha_chassis *nbrec_ha_chassis_next(const struct nbrec_ha_chassis *);
#define NBREC_HA_CHASSIS_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_ha_chassis_first(IDL); \
             (ROW); \
             (ROW) = nbrec_ha_chassis_next(ROW))
#define NBREC_HA_CHASSIS_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_ha_chassis_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_ha_chassis_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_ha_chassis_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_ha_chassis_row_get_seqno(const struct nbrec_ha_chassis *row, enum ovsdb_idl_change change);
const struct nbrec_ha_chassis *nbrec_ha_chassis_track_get_first(const struct ovsdb_idl *);
const struct nbrec_ha_chassis *nbrec_ha_chassis_track_get_next(const struct nbrec_ha_chassis *);
#define NBREC_HA_CHASSIS_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_ha_chassis_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_ha_chassis_track_get_next(ROW))

const struct nbrec_ha_chassis *nbrec_ha_chassis_table_track_get_first(const struct nbrec_ha_chassis_table *);
#define NBREC_HA_CHASSIS_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_ha_chassis_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_ha_chassis_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_ha_chassis_is_new(const struct nbrec_ha_chassis *row)
{
    return nbrec_ha_chassis_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_ha_chassis_is_deleted(const struct nbrec_ha_chassis *row)
{
    return nbrec_ha_chassis_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_ha_chassis_index_destroy_row(const struct nbrec_ha_chassis *);

struct nbrec_ha_chassis *nbrec_ha_chassis_index_find(struct ovsdb_idl_index *, const struct nbrec_ha_chassis *);

int nbrec_ha_chassis_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_ha_chassis *, 
    const struct nbrec_ha_chassis *);
struct ovsdb_idl_cursor nbrec_ha_chassis_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_ha_chassis_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_ha_chassis *);
struct ovsdb_idl_cursor nbrec_ha_chassis_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_ha_chassis *);

struct nbrec_ha_chassis *nbrec_ha_chassis_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_HA_CHASSIS_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ha_chassis_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_ha_chassis_cursor_data(&cursor__), \
                  !(TO) || nbrec_ha_chassis_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_HA_CHASSIS_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ha_chassis_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_ha_chassis_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_HA_CHASSIS_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ha_chassis_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_ha_chassis_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_ha_chassis_init(struct nbrec_ha_chassis *);
void nbrec_ha_chassis_delete(const struct nbrec_ha_chassis *);
struct nbrec_ha_chassis *nbrec_ha_chassis_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_ha_chassis_column_id' of
 * the row referenced by 'struct nbrec_ha_chassis *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_ha_chassis_is_updated(const struct nbrec_ha_chassis *, enum nbrec_ha_chassis_column_id);

void nbrec_ha_chassis_verify_chassis_name(const struct nbrec_ha_chassis *);
void nbrec_ha_chassis_verify_external_ids(const struct nbrec_ha_chassis *);
void nbrec_ha_chassis_verify_priority(const struct nbrec_ha_chassis *);

const struct ovsdb_datum *nbrec_ha_chassis_get_chassis_name(const struct nbrec_ha_chassis *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_ha_chassis_get_external_ids(const struct nbrec_ha_chassis *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_ha_chassis_get_priority(const struct nbrec_ha_chassis *, enum ovsdb_atomic_type key_type);

void nbrec_ha_chassis_set_chassis_name(const struct nbrec_ha_chassis *, const char *chassis_name);
void nbrec_ha_chassis_set_external_ids(const struct nbrec_ha_chassis *, const struct smap *);
void nbrec_ha_chassis_set_priority(const struct nbrec_ha_chassis *, int64_t priority);

void nbrec_ha_chassis_add_clause_chassis_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *chassis_name);
unsigned int nbrec_ha_chassis_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ha_chassis_update_external_ids_setkey(const struct nbrec_ha_chassis *,  const char *, const char *);
void nbrec_ha_chassis_update_external_ids_delkey(const struct nbrec_ha_chassis *,  const char *);
void nbrec_ha_chassis_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_ha_chassis_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ha_chassis_add_clause_priority(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t priority);
unsigned int nbrec_ha_chassis_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_ha_chassis *nbrec_ha_chassis_index_init_row(struct ovsdb_idl_index *);
void nbrec_ha_chassis_index_set_chassis_name(const struct nbrec_ha_chassis *,
const char *chassis_name);
void nbrec_ha_chassis_index_set_external_ids(const struct nbrec_ha_chassis *,
const struct smap *);
void nbrec_ha_chassis_index_set_priority(const struct nbrec_ha_chassis *,
int64_t priority);

/* HA_Chassis_Group table. */
struct nbrec_ha_chassis_group {
	struct ovsdb_idl_row header_;

	/* external_ids column. */
	struct smap external_ids;

	/* ha_chassis column. */
	struct nbrec_ha_chassis **ha_chassis;
	size_t n_ha_chassis;

	/* name column. */
	char *name;	/* Always nonnull. */
};

enum nbrec_ha_chassis_group_column_id {
    NBREC_HA_CHASSIS_GROUP_COL_EXTERNAL_IDS,
    NBREC_HA_CHASSIS_GROUP_COL_HA_CHASSIS,
    NBREC_HA_CHASSIS_GROUP_COL_NAME,
    NBREC_HA_CHASSIS_GROUP_N_COLUMNS
};

#define nbrec_ha_chassis_group_col_external_ids (nbrec_ha_chassis_group_columns[NBREC_HA_CHASSIS_GROUP_COL_EXTERNAL_IDS])
#define nbrec_ha_chassis_group_col_ha_chassis (nbrec_ha_chassis_group_columns[NBREC_HA_CHASSIS_GROUP_COL_HA_CHASSIS])
#define nbrec_ha_chassis_group_col_name (nbrec_ha_chassis_group_columns[NBREC_HA_CHASSIS_GROUP_COL_NAME])

extern struct ovsdb_idl_column nbrec_ha_chassis_group_columns[NBREC_HA_CHASSIS_GROUP_N_COLUMNS];

const struct nbrec_ha_chassis_group_table *nbrec_ha_chassis_group_table_get(const struct ovsdb_idl *);
const struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_table_first(const struct nbrec_ha_chassis_group_table *);

#define NBREC_HA_CHASSIS_GROUP_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_ha_chassis_group_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_ha_chassis_group_next(ROW))
#define NBREC_HA_CHASSIS_GROUP_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_ha_chassis_group_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_ha_chassis_group_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_table_get_for_uuid(const struct nbrec_ha_chassis_group_table *, const struct uuid *);
const struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_first(const struct ovsdb_idl *);
const struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_next(const struct nbrec_ha_chassis_group *);
#define NBREC_HA_CHASSIS_GROUP_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_ha_chassis_group_first(IDL); \
             (ROW); \
             (ROW) = nbrec_ha_chassis_group_next(ROW))
#define NBREC_HA_CHASSIS_GROUP_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_ha_chassis_group_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_ha_chassis_group_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_ha_chassis_group_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_ha_chassis_group_row_get_seqno(const struct nbrec_ha_chassis_group *row, enum ovsdb_idl_change change);
const struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_track_get_first(const struct ovsdb_idl *);
const struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_track_get_next(const struct nbrec_ha_chassis_group *);
#define NBREC_HA_CHASSIS_GROUP_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_ha_chassis_group_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_ha_chassis_group_track_get_next(ROW))

const struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_table_track_get_first(const struct nbrec_ha_chassis_group_table *);
#define NBREC_HA_CHASSIS_GROUP_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_ha_chassis_group_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_ha_chassis_group_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_ha_chassis_group_is_new(const struct nbrec_ha_chassis_group *row)
{
    return nbrec_ha_chassis_group_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_ha_chassis_group_is_deleted(const struct nbrec_ha_chassis_group *row)
{
    return nbrec_ha_chassis_group_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_ha_chassis_group_index_destroy_row(const struct nbrec_ha_chassis_group *);

struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_index_find(struct ovsdb_idl_index *, const struct nbrec_ha_chassis_group *);

int nbrec_ha_chassis_group_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_ha_chassis_group *, 
    const struct nbrec_ha_chassis_group *);
struct ovsdb_idl_cursor nbrec_ha_chassis_group_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_ha_chassis_group_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_ha_chassis_group *);
struct ovsdb_idl_cursor nbrec_ha_chassis_group_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_ha_chassis_group *);

struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_HA_CHASSIS_GROUP_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ha_chassis_group_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_ha_chassis_group_cursor_data(&cursor__), \
                  !(TO) || nbrec_ha_chassis_group_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_HA_CHASSIS_GROUP_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ha_chassis_group_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_ha_chassis_group_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_HA_CHASSIS_GROUP_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ha_chassis_group_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_ha_chassis_group_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_ha_chassis_group_init(struct nbrec_ha_chassis_group *);
void nbrec_ha_chassis_group_delete(const struct nbrec_ha_chassis_group *);
struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_ha_chassis_group_column_id' of
 * the row referenced by 'struct nbrec_ha_chassis_group *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_ha_chassis_group_is_updated(const struct nbrec_ha_chassis_group *, enum nbrec_ha_chassis_group_column_id);

void nbrec_ha_chassis_group_verify_external_ids(const struct nbrec_ha_chassis_group *);
void nbrec_ha_chassis_group_verify_ha_chassis(const struct nbrec_ha_chassis_group *);
void nbrec_ha_chassis_group_verify_name(const struct nbrec_ha_chassis_group *);

const struct ovsdb_datum *nbrec_ha_chassis_group_get_external_ids(const struct nbrec_ha_chassis_group *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_ha_chassis_group_get_ha_chassis(const struct nbrec_ha_chassis_group *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_ha_chassis_group_get_name(const struct nbrec_ha_chassis_group *, enum ovsdb_atomic_type key_type);

void nbrec_ha_chassis_group_set_external_ids(const struct nbrec_ha_chassis_group *, const struct smap *);
void nbrec_ha_chassis_group_set_ha_chassis(const struct nbrec_ha_chassis_group *, struct nbrec_ha_chassis **ha_chassis, size_t n_ha_chassis);
void nbrec_ha_chassis_group_set_name(const struct nbrec_ha_chassis_group *, const char *name);

void nbrec_ha_chassis_group_update_external_ids_setkey(const struct nbrec_ha_chassis_group *,  const char *, const char *);
void nbrec_ha_chassis_group_update_external_ids_delkey(const struct nbrec_ha_chassis_group *,  const char *);
void nbrec_ha_chassis_group_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_ha_chassis_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ha_chassis_group_update_ha_chassis_addvalue(const struct nbrec_ha_chassis_group *,  const struct nbrec_ha_chassis *);
void nbrec_ha_chassis_group_update_ha_chassis_delvalue(const struct nbrec_ha_chassis_group *,  const struct nbrec_ha_chassis *);
void nbrec_ha_chassis_group_add_clause_ha_chassis(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **ha_chassis, size_t n_ha_chassis);
unsigned int nbrec_ha_chassis_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ha_chassis_group_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_ha_chassis_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_ha_chassis_group *nbrec_ha_chassis_group_index_init_row(struct ovsdb_idl_index *);
void nbrec_ha_chassis_group_index_set_external_ids(const struct nbrec_ha_chassis_group *,
const struct smap *);
void nbrec_ha_chassis_group_index_set_ha_chassis(const struct nbrec_ha_chassis_group *,
struct nbrec_ha_chassis **ha_chassis, size_t n_ha_chassis);
void nbrec_ha_chassis_group_index_set_name(const struct nbrec_ha_chassis_group *,
const char *name);

/* Load_Balancer table. */
struct nbrec_load_balancer {
	struct ovsdb_idl_row header_;

	/* external_ids column. */
	struct smap external_ids;

	/* health_check column. */
	struct nbrec_load_balancer_health_check **health_check;
	size_t n_health_check;

	/* ip_port_mappings column. */
	struct smap ip_port_mappings;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* options column. */
	struct smap options;

	/* protocol column. */
	char *protocol;

	/* selection_fields column. */
	char **selection_fields;
	size_t n_selection_fields;

	/* vips column. */
	struct smap vips;
};

enum nbrec_load_balancer_column_id {
    NBREC_LOAD_BALANCER_COL_EXTERNAL_IDS,
    NBREC_LOAD_BALANCER_COL_HEALTH_CHECK,
    NBREC_LOAD_BALANCER_COL_IP_PORT_MAPPINGS,
    NBREC_LOAD_BALANCER_COL_NAME,
    NBREC_LOAD_BALANCER_COL_OPTIONS,
    NBREC_LOAD_BALANCER_COL_PROTOCOL,
    NBREC_LOAD_BALANCER_COL_SELECTION_FIELDS,
    NBREC_LOAD_BALANCER_COL_VIPS,
    NBREC_LOAD_BALANCER_N_COLUMNS
};

#define nbrec_load_balancer_col_external_ids (nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_COL_EXTERNAL_IDS])
#define nbrec_load_balancer_col_health_check (nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_COL_HEALTH_CHECK])
#define nbrec_load_balancer_col_ip_port_mappings (nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_COL_IP_PORT_MAPPINGS])
#define nbrec_load_balancer_col_name (nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_COL_NAME])
#define nbrec_load_balancer_col_options (nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_COL_OPTIONS])
#define nbrec_load_balancer_col_protocol (nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_COL_PROTOCOL])
#define nbrec_load_balancer_col_selection_fields (nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_COL_SELECTION_FIELDS])
#define nbrec_load_balancer_col_vips (nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_COL_VIPS])

extern struct ovsdb_idl_column nbrec_load_balancer_columns[NBREC_LOAD_BALANCER_N_COLUMNS];

const struct nbrec_load_balancer_table *nbrec_load_balancer_table_get(const struct ovsdb_idl *);
const struct nbrec_load_balancer *nbrec_load_balancer_table_first(const struct nbrec_load_balancer_table *);

#define NBREC_LOAD_BALANCER_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_load_balancer_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_load_balancer_next(ROW))
#define NBREC_LOAD_BALANCER_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_load_balancer_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_load_balancer_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_load_balancer *nbrec_load_balancer_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_load_balancer *nbrec_load_balancer_table_get_for_uuid(const struct nbrec_load_balancer_table *, const struct uuid *);
const struct nbrec_load_balancer *nbrec_load_balancer_first(const struct ovsdb_idl *);
const struct nbrec_load_balancer *nbrec_load_balancer_next(const struct nbrec_load_balancer *);
#define NBREC_LOAD_BALANCER_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_load_balancer_first(IDL); \
             (ROW); \
             (ROW) = nbrec_load_balancer_next(ROW))
#define NBREC_LOAD_BALANCER_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_load_balancer_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_load_balancer_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_load_balancer_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_load_balancer_row_get_seqno(const struct nbrec_load_balancer *row, enum ovsdb_idl_change change);
const struct nbrec_load_balancer *nbrec_load_balancer_track_get_first(const struct ovsdb_idl *);
const struct nbrec_load_balancer *nbrec_load_balancer_track_get_next(const struct nbrec_load_balancer *);
#define NBREC_LOAD_BALANCER_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_load_balancer_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_load_balancer_track_get_next(ROW))

const struct nbrec_load_balancer *nbrec_load_balancer_table_track_get_first(const struct nbrec_load_balancer_table *);
#define NBREC_LOAD_BALANCER_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_load_balancer_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_load_balancer_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_load_balancer_is_new(const struct nbrec_load_balancer *row)
{
    return nbrec_load_balancer_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_load_balancer_is_deleted(const struct nbrec_load_balancer *row)
{
    return nbrec_load_balancer_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_load_balancer_index_destroy_row(const struct nbrec_load_balancer *);

struct nbrec_load_balancer *nbrec_load_balancer_index_find(struct ovsdb_idl_index *, const struct nbrec_load_balancer *);

int nbrec_load_balancer_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_load_balancer *, 
    const struct nbrec_load_balancer *);
struct ovsdb_idl_cursor nbrec_load_balancer_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_load_balancer_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_load_balancer *);
struct ovsdb_idl_cursor nbrec_load_balancer_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_load_balancer *);

struct nbrec_load_balancer *nbrec_load_balancer_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_LOAD_BALANCER_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_load_balancer_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_load_balancer_cursor_data(&cursor__), \
                  !(TO) || nbrec_load_balancer_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_LOAD_BALANCER_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_load_balancer_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_load_balancer_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_LOAD_BALANCER_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_load_balancer_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_load_balancer_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_load_balancer_init(struct nbrec_load_balancer *);
void nbrec_load_balancer_delete(const struct nbrec_load_balancer *);
struct nbrec_load_balancer *nbrec_load_balancer_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_load_balancer_column_id' of
 * the row referenced by 'struct nbrec_load_balancer *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_load_balancer_is_updated(const struct nbrec_load_balancer *, enum nbrec_load_balancer_column_id);

void nbrec_load_balancer_verify_external_ids(const struct nbrec_load_balancer *);
void nbrec_load_balancer_verify_health_check(const struct nbrec_load_balancer *);
void nbrec_load_balancer_verify_ip_port_mappings(const struct nbrec_load_balancer *);
void nbrec_load_balancer_verify_name(const struct nbrec_load_balancer *);
void nbrec_load_balancer_verify_options(const struct nbrec_load_balancer *);
void nbrec_load_balancer_verify_protocol(const struct nbrec_load_balancer *);
void nbrec_load_balancer_verify_selection_fields(const struct nbrec_load_balancer *);
void nbrec_load_balancer_verify_vips(const struct nbrec_load_balancer *);

const struct ovsdb_datum *nbrec_load_balancer_get_external_ids(const struct nbrec_load_balancer *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_load_balancer_get_health_check(const struct nbrec_load_balancer *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_load_balancer_get_ip_port_mappings(const struct nbrec_load_balancer *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_load_balancer_get_name(const struct nbrec_load_balancer *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_load_balancer_get_options(const struct nbrec_load_balancer *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_load_balancer_get_protocol(const struct nbrec_load_balancer *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_load_balancer_get_selection_fields(const struct nbrec_load_balancer *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_load_balancer_get_vips(const struct nbrec_load_balancer *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);

void nbrec_load_balancer_set_external_ids(const struct nbrec_load_balancer *, const struct smap *);
void nbrec_load_balancer_set_health_check(const struct nbrec_load_balancer *, struct nbrec_load_balancer_health_check **health_check, size_t n_health_check);
void nbrec_load_balancer_set_ip_port_mappings(const struct nbrec_load_balancer *, const struct smap *);
void nbrec_load_balancer_set_name(const struct nbrec_load_balancer *, const char *name);
void nbrec_load_balancer_set_options(const struct nbrec_load_balancer *, const struct smap *);
void nbrec_load_balancer_set_protocol(const struct nbrec_load_balancer *, const char *protocol);
void nbrec_load_balancer_set_selection_fields(const struct nbrec_load_balancer *, const char **selection_fields, size_t n_selection_fields);
void nbrec_load_balancer_set_vips(const struct nbrec_load_balancer *, const struct smap *);

void nbrec_load_balancer_update_external_ids_setkey(const struct nbrec_load_balancer *,  const char *, const char *);
void nbrec_load_balancer_update_external_ids_delkey(const struct nbrec_load_balancer *,  const char *);
void nbrec_load_balancer_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_load_balancer_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_update_health_check_addvalue(const struct nbrec_load_balancer *,  const struct nbrec_load_balancer_health_check *);
void nbrec_load_balancer_update_health_check_delvalue(const struct nbrec_load_balancer *,  const struct nbrec_load_balancer_health_check *);
void nbrec_load_balancer_add_clause_health_check(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **health_check, size_t n_health_check);
unsigned int nbrec_load_balancer_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_update_ip_port_mappings_setkey(const struct nbrec_load_balancer *,  const char *, const char *);
void nbrec_load_balancer_update_ip_port_mappings_delkey(const struct nbrec_load_balancer *,  const char *);
void nbrec_load_balancer_add_clause_ip_port_mappings(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_load_balancer_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_load_balancer_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_update_options_setkey(const struct nbrec_load_balancer *,  const char *, const char *);
void nbrec_load_balancer_update_options_delkey(const struct nbrec_load_balancer *,  const char *);
void nbrec_load_balancer_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_load_balancer_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_update_protocol_addvalue(const struct nbrec_load_balancer *,  const char *);
void nbrec_load_balancer_update_protocol_delvalue(const struct nbrec_load_balancer *,  const char *);
void nbrec_load_balancer_add_clause_protocol(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *protocol);
unsigned int nbrec_load_balancer_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_update_selection_fields_addvalue(const struct nbrec_load_balancer *,  const char *);
void nbrec_load_balancer_update_selection_fields_delvalue(const struct nbrec_load_balancer *,  const char *);
void nbrec_load_balancer_add_clause_selection_fields(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **selection_fields, size_t n_selection_fields);
unsigned int nbrec_load_balancer_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_update_vips_setkey(const struct nbrec_load_balancer *,  const char *, const char *);
void nbrec_load_balancer_update_vips_delkey(const struct nbrec_load_balancer *,  const char *);
void nbrec_load_balancer_add_clause_vips(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_load_balancer_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_load_balancer *nbrec_load_balancer_index_init_row(struct ovsdb_idl_index *);
void nbrec_load_balancer_index_set_external_ids(const struct nbrec_load_balancer *,
const struct smap *);
void nbrec_load_balancer_index_set_health_check(const struct nbrec_load_balancer *,
struct nbrec_load_balancer_health_check **health_check, size_t n_health_check);
void nbrec_load_balancer_index_set_ip_port_mappings(const struct nbrec_load_balancer *,
const struct smap *);
void nbrec_load_balancer_index_set_name(const struct nbrec_load_balancer *,
const char *name);
void nbrec_load_balancer_index_set_options(const struct nbrec_load_balancer *,
const struct smap *);
void nbrec_load_balancer_index_set_protocol(const struct nbrec_load_balancer *,
const char *protocol);
void nbrec_load_balancer_index_set_selection_fields(const struct nbrec_load_balancer *,
const char **selection_fields, size_t n_selection_fields);
void nbrec_load_balancer_index_set_vips(const struct nbrec_load_balancer *,
const struct smap *);

/* Load_Balancer_Health_Check table. */
struct nbrec_load_balancer_health_check {
	struct ovsdb_idl_row header_;

	/* external_ids column. */
	struct smap external_ids;

	/* options column. */
	struct smap options;

	/* vip column. */
	char *vip;	/* Always nonnull. */
};

enum nbrec_load_balancer_health_check_column_id {
    NBREC_LOAD_BALANCER_HEALTH_CHECK_COL_EXTERNAL_IDS,
    NBREC_LOAD_BALANCER_HEALTH_CHECK_COL_OPTIONS,
    NBREC_LOAD_BALANCER_HEALTH_CHECK_COL_VIP,
    NBREC_LOAD_BALANCER_HEALTH_CHECK_N_COLUMNS
};

#define nbrec_load_balancer_health_check_col_external_ids (nbrec_load_balancer_health_check_columns[NBREC_LOAD_BALANCER_HEALTH_CHECK_COL_EXTERNAL_IDS])
#define nbrec_load_balancer_health_check_col_options (nbrec_load_balancer_health_check_columns[NBREC_LOAD_BALANCER_HEALTH_CHECK_COL_OPTIONS])
#define nbrec_load_balancer_health_check_col_vip (nbrec_load_balancer_health_check_columns[NBREC_LOAD_BALANCER_HEALTH_CHECK_COL_VIP])

extern struct ovsdb_idl_column nbrec_load_balancer_health_check_columns[NBREC_LOAD_BALANCER_HEALTH_CHECK_N_COLUMNS];

const struct nbrec_load_balancer_health_check_table *nbrec_load_balancer_health_check_table_get(const struct ovsdb_idl *);
const struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_table_first(const struct nbrec_load_balancer_health_check_table *);

#define NBREC_LOAD_BALANCER_HEALTH_CHECK_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_load_balancer_health_check_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_load_balancer_health_check_next(ROW))
#define NBREC_LOAD_BALANCER_HEALTH_CHECK_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_load_balancer_health_check_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_load_balancer_health_check_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_table_get_for_uuid(const struct nbrec_load_balancer_health_check_table *, const struct uuid *);
const struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_first(const struct ovsdb_idl *);
const struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_next(const struct nbrec_load_balancer_health_check *);
#define NBREC_LOAD_BALANCER_HEALTH_CHECK_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_load_balancer_health_check_first(IDL); \
             (ROW); \
             (ROW) = nbrec_load_balancer_health_check_next(ROW))
#define NBREC_LOAD_BALANCER_HEALTH_CHECK_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_load_balancer_health_check_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_load_balancer_health_check_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_load_balancer_health_check_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_load_balancer_health_check_row_get_seqno(const struct nbrec_load_balancer_health_check *row, enum ovsdb_idl_change change);
const struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_track_get_first(const struct ovsdb_idl *);
const struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_track_get_next(const struct nbrec_load_balancer_health_check *);
#define NBREC_LOAD_BALANCER_HEALTH_CHECK_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_load_balancer_health_check_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_load_balancer_health_check_track_get_next(ROW))

const struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_table_track_get_first(const struct nbrec_load_balancer_health_check_table *);
#define NBREC_LOAD_BALANCER_HEALTH_CHECK_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_load_balancer_health_check_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_load_balancer_health_check_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_load_balancer_health_check_is_new(const struct nbrec_load_balancer_health_check *row)
{
    return nbrec_load_balancer_health_check_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_load_balancer_health_check_is_deleted(const struct nbrec_load_balancer_health_check *row)
{
    return nbrec_load_balancer_health_check_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_load_balancer_health_check_index_destroy_row(const struct nbrec_load_balancer_health_check *);

struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_index_find(struct ovsdb_idl_index *, const struct nbrec_load_balancer_health_check *);

int nbrec_load_balancer_health_check_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_load_balancer_health_check *, 
    const struct nbrec_load_balancer_health_check *);
struct ovsdb_idl_cursor nbrec_load_balancer_health_check_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_load_balancer_health_check_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_load_balancer_health_check *);
struct ovsdb_idl_cursor nbrec_load_balancer_health_check_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_load_balancer_health_check *);

struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_LOAD_BALANCER_HEALTH_CHECK_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_load_balancer_health_check_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_load_balancer_health_check_cursor_data(&cursor__), \
                  !(TO) || nbrec_load_balancer_health_check_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_LOAD_BALANCER_HEALTH_CHECK_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_load_balancer_health_check_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_load_balancer_health_check_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_LOAD_BALANCER_HEALTH_CHECK_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_load_balancer_health_check_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_load_balancer_health_check_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_load_balancer_health_check_init(struct nbrec_load_balancer_health_check *);
void nbrec_load_balancer_health_check_delete(const struct nbrec_load_balancer_health_check *);
struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_load_balancer_health_check_column_id' of
 * the row referenced by 'struct nbrec_load_balancer_health_check *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_load_balancer_health_check_is_updated(const struct nbrec_load_balancer_health_check *, enum nbrec_load_balancer_health_check_column_id);

void nbrec_load_balancer_health_check_verify_external_ids(const struct nbrec_load_balancer_health_check *);
void nbrec_load_balancer_health_check_verify_options(const struct nbrec_load_balancer_health_check *);
void nbrec_load_balancer_health_check_verify_vip(const struct nbrec_load_balancer_health_check *);

const struct ovsdb_datum *nbrec_load_balancer_health_check_get_external_ids(const struct nbrec_load_balancer_health_check *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_load_balancer_health_check_get_options(const struct nbrec_load_balancer_health_check *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_load_balancer_health_check_get_vip(const struct nbrec_load_balancer_health_check *, enum ovsdb_atomic_type key_type);

void nbrec_load_balancer_health_check_set_external_ids(const struct nbrec_load_balancer_health_check *, const struct smap *);
void nbrec_load_balancer_health_check_set_options(const struct nbrec_load_balancer_health_check *, const struct smap *);
void nbrec_load_balancer_health_check_set_vip(const struct nbrec_load_balancer_health_check *, const char *vip);

void nbrec_load_balancer_health_check_update_external_ids_setkey(const struct nbrec_load_balancer_health_check *,  const char *, const char *);
void nbrec_load_balancer_health_check_update_external_ids_delkey(const struct nbrec_load_balancer_health_check *,  const char *);
void nbrec_load_balancer_health_check_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_load_balancer_health_check_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_health_check_update_options_setkey(const struct nbrec_load_balancer_health_check *,  const char *, const char *);
void nbrec_load_balancer_health_check_update_options_delkey(const struct nbrec_load_balancer_health_check *,  const char *);
void nbrec_load_balancer_health_check_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_load_balancer_health_check_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_load_balancer_health_check_add_clause_vip(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *vip);
unsigned int nbrec_load_balancer_health_check_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_load_balancer_health_check *nbrec_load_balancer_health_check_index_init_row(struct ovsdb_idl_index *);
void nbrec_load_balancer_health_check_index_set_external_ids(const struct nbrec_load_balancer_health_check *,
const struct smap *);
void nbrec_load_balancer_health_check_index_set_options(const struct nbrec_load_balancer_health_check *,
const struct smap *);
void nbrec_load_balancer_health_check_index_set_vip(const struct nbrec_load_balancer_health_check *,
const char *vip);

/* Logical_Router table. */
struct nbrec_logical_router {
	struct ovsdb_idl_row header_;

	/* enabled column. */
	bool *enabled;
	size_t n_enabled;

	/* external_ids column. */
	struct smap external_ids;

	/* load_balancer column. */
	struct nbrec_load_balancer **load_balancer;
	size_t n_load_balancer;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* nat column. */
	struct nbrec_nat **nat;
	size_t n_nat;

	/* options column. */
	struct smap options;

	/* policies column. */
	struct nbrec_logical_router_policy **policies;
	size_t n_policies;

	/* ports column. */
	struct nbrec_logical_router_port **ports;
	size_t n_ports;

	/* static_routes column. */
	struct nbrec_logical_router_static_route **static_routes;
	size_t n_static_routes;
};

enum nbrec_logical_router_column_id {
    NBREC_LOGICAL_ROUTER_COL_ENABLED,
    NBREC_LOGICAL_ROUTER_COL_EXTERNAL_IDS,
    NBREC_LOGICAL_ROUTER_COL_LOAD_BALANCER,
    NBREC_LOGICAL_ROUTER_COL_NAME,
    NBREC_LOGICAL_ROUTER_COL_NAT,
    NBREC_LOGICAL_ROUTER_COL_OPTIONS,
    NBREC_LOGICAL_ROUTER_COL_POLICIES,
    NBREC_LOGICAL_ROUTER_COL_PORTS,
    NBREC_LOGICAL_ROUTER_COL_STATIC_ROUTES,
    NBREC_LOGICAL_ROUTER_N_COLUMNS
};

#define nbrec_logical_router_col_enabled (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_ENABLED])
#define nbrec_logical_router_col_external_ids (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_EXTERNAL_IDS])
#define nbrec_logical_router_col_load_balancer (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_LOAD_BALANCER])
#define nbrec_logical_router_col_name (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_NAME])
#define nbrec_logical_router_col_nat (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_NAT])
#define nbrec_logical_router_col_options (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_OPTIONS])
#define nbrec_logical_router_col_policies (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_POLICIES])
#define nbrec_logical_router_col_ports (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_PORTS])
#define nbrec_logical_router_col_static_routes (nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_COL_STATIC_ROUTES])

extern struct ovsdb_idl_column nbrec_logical_router_columns[NBREC_LOGICAL_ROUTER_N_COLUMNS];

const struct nbrec_logical_router_table *nbrec_logical_router_table_get(const struct ovsdb_idl *);
const struct nbrec_logical_router *nbrec_logical_router_table_first(const struct nbrec_logical_router_table *);

#define NBREC_LOGICAL_ROUTER_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_logical_router_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_router_next(ROW))
#define NBREC_LOGICAL_ROUTER_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_logical_router_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_logical_router_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_logical_router *nbrec_logical_router_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_logical_router *nbrec_logical_router_table_get_for_uuid(const struct nbrec_logical_router_table *, const struct uuid *);
const struct nbrec_logical_router *nbrec_logical_router_first(const struct ovsdb_idl *);
const struct nbrec_logical_router *nbrec_logical_router_next(const struct nbrec_logical_router *);
#define NBREC_LOGICAL_ROUTER_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_logical_router_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_router_next(ROW))
#define NBREC_LOGICAL_ROUTER_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_logical_router_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_logical_router_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_logical_router_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_logical_router_row_get_seqno(const struct nbrec_logical_router *row, enum ovsdb_idl_change change);
const struct nbrec_logical_router *nbrec_logical_router_track_get_first(const struct ovsdb_idl *);
const struct nbrec_logical_router *nbrec_logical_router_track_get_next(const struct nbrec_logical_router *);
#define NBREC_LOGICAL_ROUTER_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_logical_router_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_router_track_get_next(ROW))

const struct nbrec_logical_router *nbrec_logical_router_table_track_get_first(const struct nbrec_logical_router_table *);
#define NBREC_LOGICAL_ROUTER_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_logical_router_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_router_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_logical_router_is_new(const struct nbrec_logical_router *row)
{
    return nbrec_logical_router_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_logical_router_is_deleted(const struct nbrec_logical_router *row)
{
    return nbrec_logical_router_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_logical_router_index_destroy_row(const struct nbrec_logical_router *);

struct nbrec_logical_router *nbrec_logical_router_index_find(struct ovsdb_idl_index *, const struct nbrec_logical_router *);

int nbrec_logical_router_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_logical_router *, 
    const struct nbrec_logical_router *);
struct ovsdb_idl_cursor nbrec_logical_router_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_logical_router_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_logical_router *);
struct ovsdb_idl_cursor nbrec_logical_router_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_logical_router *);

struct nbrec_logical_router *nbrec_logical_router_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_LOGICAL_ROUTER_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_logical_router_cursor_data(&cursor__), \
                  !(TO) || nbrec_logical_router_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_LOGICAL_ROUTER_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_router_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_LOGICAL_ROUTER_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_router_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_logical_router_init(struct nbrec_logical_router *);
void nbrec_logical_router_delete(const struct nbrec_logical_router *);
struct nbrec_logical_router *nbrec_logical_router_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_logical_router_column_id' of
 * the row referenced by 'struct nbrec_logical_router *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_logical_router_is_updated(const struct nbrec_logical_router *, enum nbrec_logical_router_column_id);

void nbrec_logical_router_verify_enabled(const struct nbrec_logical_router *);
void nbrec_logical_router_verify_external_ids(const struct nbrec_logical_router *);
void nbrec_logical_router_verify_load_balancer(const struct nbrec_logical_router *);
void nbrec_logical_router_verify_name(const struct nbrec_logical_router *);
void nbrec_logical_router_verify_nat(const struct nbrec_logical_router *);
void nbrec_logical_router_verify_options(const struct nbrec_logical_router *);
void nbrec_logical_router_verify_policies(const struct nbrec_logical_router *);
void nbrec_logical_router_verify_ports(const struct nbrec_logical_router *);
void nbrec_logical_router_verify_static_routes(const struct nbrec_logical_router *);

const struct ovsdb_datum *nbrec_logical_router_get_enabled(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_get_external_ids(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_get_load_balancer(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_get_name(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_get_nat(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_get_options(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_get_policies(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_get_ports(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_get_static_routes(const struct nbrec_logical_router *, enum ovsdb_atomic_type key_type);

void nbrec_logical_router_set_enabled(const struct nbrec_logical_router *, const bool *enabled, size_t n_enabled);
void nbrec_logical_router_set_external_ids(const struct nbrec_logical_router *, const struct smap *);
void nbrec_logical_router_set_load_balancer(const struct nbrec_logical_router *, struct nbrec_load_balancer **load_balancer, size_t n_load_balancer);
void nbrec_logical_router_set_name(const struct nbrec_logical_router *, const char *name);
void nbrec_logical_router_set_nat(const struct nbrec_logical_router *, struct nbrec_nat **nat, size_t n_nat);
void nbrec_logical_router_set_options(const struct nbrec_logical_router *, const struct smap *);
void nbrec_logical_router_set_policies(const struct nbrec_logical_router *, struct nbrec_logical_router_policy **policies, size_t n_policies);
void nbrec_logical_router_set_ports(const struct nbrec_logical_router *, struct nbrec_logical_router_port **ports, size_t n_ports);
void nbrec_logical_router_set_static_routes(const struct nbrec_logical_router *, struct nbrec_logical_router_static_route **static_routes, size_t n_static_routes);

void nbrec_logical_router_update_enabled_addvalue(const struct nbrec_logical_router *,  bool );
void nbrec_logical_router_update_enabled_delvalue(const struct nbrec_logical_router *,  bool );
void nbrec_logical_router_add_clause_enabled(struct ovsdb_idl_condition *, enum ovsdb_function function, const bool *enabled, size_t n_enabled);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_update_external_ids_setkey(const struct nbrec_logical_router *,  const char *, const char *);
void nbrec_logical_router_update_external_ids_delkey(const struct nbrec_logical_router *,  const char *);
void nbrec_logical_router_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_update_load_balancer_addvalue(const struct nbrec_logical_router *,  const struct nbrec_load_balancer *);
void nbrec_logical_router_update_load_balancer_delvalue(const struct nbrec_logical_router *,  const struct nbrec_load_balancer *);
void nbrec_logical_router_add_clause_load_balancer(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **load_balancer, size_t n_load_balancer);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_update_nat_addvalue(const struct nbrec_logical_router *,  const struct nbrec_nat *);
void nbrec_logical_router_update_nat_delvalue(const struct nbrec_logical_router *,  const struct nbrec_nat *);
void nbrec_logical_router_add_clause_nat(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **nat, size_t n_nat);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_update_options_setkey(const struct nbrec_logical_router *,  const char *, const char *);
void nbrec_logical_router_update_options_delkey(const struct nbrec_logical_router *,  const char *);
void nbrec_logical_router_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_update_policies_addvalue(const struct nbrec_logical_router *,  const struct nbrec_logical_router_policy *);
void nbrec_logical_router_update_policies_delvalue(const struct nbrec_logical_router *,  const struct nbrec_logical_router_policy *);
void nbrec_logical_router_add_clause_policies(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **policies, size_t n_policies);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_update_ports_addvalue(const struct nbrec_logical_router *,  const struct nbrec_logical_router_port *);
void nbrec_logical_router_update_ports_delvalue(const struct nbrec_logical_router *,  const struct nbrec_logical_router_port *);
void nbrec_logical_router_add_clause_ports(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **ports, size_t n_ports);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_update_static_routes_addvalue(const struct nbrec_logical_router *,  const struct nbrec_logical_router_static_route *);
void nbrec_logical_router_update_static_routes_delvalue(const struct nbrec_logical_router *,  const struct nbrec_logical_router_static_route *);
void nbrec_logical_router_add_clause_static_routes(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **static_routes, size_t n_static_routes);
unsigned int nbrec_logical_router_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_logical_router *nbrec_logical_router_index_init_row(struct ovsdb_idl_index *);
void nbrec_logical_router_index_set_enabled(const struct nbrec_logical_router *,
const bool *enabled, size_t n_enabled);
void nbrec_logical_router_index_set_external_ids(const struct nbrec_logical_router *,
const struct smap *);
void nbrec_logical_router_index_set_load_balancer(const struct nbrec_logical_router *,
struct nbrec_load_balancer **load_balancer, size_t n_load_balancer);
void nbrec_logical_router_index_set_name(const struct nbrec_logical_router *,
const char *name);
void nbrec_logical_router_index_set_nat(const struct nbrec_logical_router *,
struct nbrec_nat **nat, size_t n_nat);
void nbrec_logical_router_index_set_options(const struct nbrec_logical_router *,
const struct smap *);
void nbrec_logical_router_index_set_policies(const struct nbrec_logical_router *,
struct nbrec_logical_router_policy **policies, size_t n_policies);
void nbrec_logical_router_index_set_ports(const struct nbrec_logical_router *,
struct nbrec_logical_router_port **ports, size_t n_ports);
void nbrec_logical_router_index_set_static_routes(const struct nbrec_logical_router *,
struct nbrec_logical_router_static_route **static_routes, size_t n_static_routes);

/* Logical_Router_Policy table. */
struct nbrec_logical_router_policy {
	struct ovsdb_idl_row header_;

	/* action column. */
	char *action;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* match column. */
	char *match;	/* Always nonnull. */

	/* nexthop column. */
	char *nexthop;

	/* nexthops column. */
	char **nexthops;
	size_t n_nexthops;

	/* options column. */
	struct smap options;

	/* priority column. */
	int64_t priority;
};

enum nbrec_logical_router_policy_column_id {
    NBREC_LOGICAL_ROUTER_POLICY_COL_ACTION,
    NBREC_LOGICAL_ROUTER_POLICY_COL_EXTERNAL_IDS,
    NBREC_LOGICAL_ROUTER_POLICY_COL_MATCH,
    NBREC_LOGICAL_ROUTER_POLICY_COL_NEXTHOP,
    NBREC_LOGICAL_ROUTER_POLICY_COL_NEXTHOPS,
    NBREC_LOGICAL_ROUTER_POLICY_COL_OPTIONS,
    NBREC_LOGICAL_ROUTER_POLICY_COL_PRIORITY,
    NBREC_LOGICAL_ROUTER_POLICY_N_COLUMNS
};

#define nbrec_logical_router_policy_col_action (nbrec_logical_router_policy_columns[NBREC_LOGICAL_ROUTER_POLICY_COL_ACTION])
#define nbrec_logical_router_policy_col_external_ids (nbrec_logical_router_policy_columns[NBREC_LOGICAL_ROUTER_POLICY_COL_EXTERNAL_IDS])
#define nbrec_logical_router_policy_col_match (nbrec_logical_router_policy_columns[NBREC_LOGICAL_ROUTER_POLICY_COL_MATCH])
#define nbrec_logical_router_policy_col_nexthop (nbrec_logical_router_policy_columns[NBREC_LOGICAL_ROUTER_POLICY_COL_NEXTHOP])
#define nbrec_logical_router_policy_col_nexthops (nbrec_logical_router_policy_columns[NBREC_LOGICAL_ROUTER_POLICY_COL_NEXTHOPS])
#define nbrec_logical_router_policy_col_options (nbrec_logical_router_policy_columns[NBREC_LOGICAL_ROUTER_POLICY_COL_OPTIONS])
#define nbrec_logical_router_policy_col_priority (nbrec_logical_router_policy_columns[NBREC_LOGICAL_ROUTER_POLICY_COL_PRIORITY])

extern struct ovsdb_idl_column nbrec_logical_router_policy_columns[NBREC_LOGICAL_ROUTER_POLICY_N_COLUMNS];

const struct nbrec_logical_router_policy_table *nbrec_logical_router_policy_table_get(const struct ovsdb_idl *);
const struct nbrec_logical_router_policy *nbrec_logical_router_policy_table_first(const struct nbrec_logical_router_policy_table *);

#define NBREC_LOGICAL_ROUTER_POLICY_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_logical_router_policy_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_router_policy_next(ROW))
#define NBREC_LOGICAL_ROUTER_POLICY_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_logical_router_policy_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_logical_router_policy_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_logical_router_policy *nbrec_logical_router_policy_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_logical_router_policy *nbrec_logical_router_policy_table_get_for_uuid(const struct nbrec_logical_router_policy_table *, const struct uuid *);
const struct nbrec_logical_router_policy *nbrec_logical_router_policy_first(const struct ovsdb_idl *);
const struct nbrec_logical_router_policy *nbrec_logical_router_policy_next(const struct nbrec_logical_router_policy *);
#define NBREC_LOGICAL_ROUTER_POLICY_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_logical_router_policy_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_router_policy_next(ROW))
#define NBREC_LOGICAL_ROUTER_POLICY_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_logical_router_policy_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_logical_router_policy_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_logical_router_policy_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_logical_router_policy_row_get_seqno(const struct nbrec_logical_router_policy *row, enum ovsdb_idl_change change);
const struct nbrec_logical_router_policy *nbrec_logical_router_policy_track_get_first(const struct ovsdb_idl *);
const struct nbrec_logical_router_policy *nbrec_logical_router_policy_track_get_next(const struct nbrec_logical_router_policy *);
#define NBREC_LOGICAL_ROUTER_POLICY_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_logical_router_policy_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_router_policy_track_get_next(ROW))

const struct nbrec_logical_router_policy *nbrec_logical_router_policy_table_track_get_first(const struct nbrec_logical_router_policy_table *);
#define NBREC_LOGICAL_ROUTER_POLICY_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_logical_router_policy_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_router_policy_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_logical_router_policy_is_new(const struct nbrec_logical_router_policy *row)
{
    return nbrec_logical_router_policy_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_logical_router_policy_is_deleted(const struct nbrec_logical_router_policy *row)
{
    return nbrec_logical_router_policy_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_logical_router_policy_index_destroy_row(const struct nbrec_logical_router_policy *);

struct nbrec_logical_router_policy *nbrec_logical_router_policy_index_find(struct ovsdb_idl_index *, const struct nbrec_logical_router_policy *);

int nbrec_logical_router_policy_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_logical_router_policy *, 
    const struct nbrec_logical_router_policy *);
struct ovsdb_idl_cursor nbrec_logical_router_policy_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_logical_router_policy_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_logical_router_policy *);
struct ovsdb_idl_cursor nbrec_logical_router_policy_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_logical_router_policy *);

struct nbrec_logical_router_policy *nbrec_logical_router_policy_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_LOGICAL_ROUTER_POLICY_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_policy_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_logical_router_policy_cursor_data(&cursor__), \
                  !(TO) || nbrec_logical_router_policy_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_LOGICAL_ROUTER_POLICY_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_policy_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_router_policy_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_LOGICAL_ROUTER_POLICY_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_policy_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_router_policy_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_logical_router_policy_init(struct nbrec_logical_router_policy *);
void nbrec_logical_router_policy_delete(const struct nbrec_logical_router_policy *);
struct nbrec_logical_router_policy *nbrec_logical_router_policy_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_logical_router_policy_column_id' of
 * the row referenced by 'struct nbrec_logical_router_policy *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_logical_router_policy_is_updated(const struct nbrec_logical_router_policy *, enum nbrec_logical_router_policy_column_id);

void nbrec_logical_router_policy_verify_action(const struct nbrec_logical_router_policy *);
void nbrec_logical_router_policy_verify_external_ids(const struct nbrec_logical_router_policy *);
void nbrec_logical_router_policy_verify_match(const struct nbrec_logical_router_policy *);
void nbrec_logical_router_policy_verify_nexthop(const struct nbrec_logical_router_policy *);
void nbrec_logical_router_policy_verify_nexthops(const struct nbrec_logical_router_policy *);
void nbrec_logical_router_policy_verify_options(const struct nbrec_logical_router_policy *);
void nbrec_logical_router_policy_verify_priority(const struct nbrec_logical_router_policy *);

const struct ovsdb_datum *nbrec_logical_router_policy_get_action(const struct nbrec_logical_router_policy *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_policy_get_external_ids(const struct nbrec_logical_router_policy *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_policy_get_match(const struct nbrec_logical_router_policy *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_policy_get_nexthop(const struct nbrec_logical_router_policy *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_policy_get_nexthops(const struct nbrec_logical_router_policy *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_policy_get_options(const struct nbrec_logical_router_policy *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_policy_get_priority(const struct nbrec_logical_router_policy *, enum ovsdb_atomic_type key_type);

void nbrec_logical_router_policy_set_action(const struct nbrec_logical_router_policy *, const char *action);
void nbrec_logical_router_policy_set_external_ids(const struct nbrec_logical_router_policy *, const struct smap *);
void nbrec_logical_router_policy_set_match(const struct nbrec_logical_router_policy *, const char *match);
void nbrec_logical_router_policy_set_nexthop(const struct nbrec_logical_router_policy *, const char *nexthop);
void nbrec_logical_router_policy_set_nexthops(const struct nbrec_logical_router_policy *, const char **nexthops, size_t n_nexthops);
void nbrec_logical_router_policy_set_options(const struct nbrec_logical_router_policy *, const struct smap *);
void nbrec_logical_router_policy_set_priority(const struct nbrec_logical_router_policy *, int64_t priority);

void nbrec_logical_router_policy_add_clause_action(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *action);
unsigned int nbrec_logical_router_policy_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_policy_update_external_ids_setkey(const struct nbrec_logical_router_policy *,  const char *, const char *);
void nbrec_logical_router_policy_update_external_ids_delkey(const struct nbrec_logical_router_policy *,  const char *);
void nbrec_logical_router_policy_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_policy_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_policy_add_clause_match(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *match);
unsigned int nbrec_logical_router_policy_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_policy_update_nexthop_addvalue(const struct nbrec_logical_router_policy *,  const char *);
void nbrec_logical_router_policy_update_nexthop_delvalue(const struct nbrec_logical_router_policy *,  const char *);
void nbrec_logical_router_policy_add_clause_nexthop(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *nexthop);
unsigned int nbrec_logical_router_policy_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_policy_update_nexthops_addvalue(const struct nbrec_logical_router_policy *,  const char *);
void nbrec_logical_router_policy_update_nexthops_delvalue(const struct nbrec_logical_router_policy *,  const char *);
void nbrec_logical_router_policy_add_clause_nexthops(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **nexthops, size_t n_nexthops);
unsigned int nbrec_logical_router_policy_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_policy_update_options_setkey(const struct nbrec_logical_router_policy *,  const char *, const char *);
void nbrec_logical_router_policy_update_options_delkey(const struct nbrec_logical_router_policy *,  const char *);
void nbrec_logical_router_policy_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_policy_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_policy_add_clause_priority(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t priority);
unsigned int nbrec_logical_router_policy_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_logical_router_policy *nbrec_logical_router_policy_index_init_row(struct ovsdb_idl_index *);
void nbrec_logical_router_policy_index_set_action(const struct nbrec_logical_router_policy *,
const char *action);
void nbrec_logical_router_policy_index_set_external_ids(const struct nbrec_logical_router_policy *,
const struct smap *);
void nbrec_logical_router_policy_index_set_match(const struct nbrec_logical_router_policy *,
const char *match);
void nbrec_logical_router_policy_index_set_nexthop(const struct nbrec_logical_router_policy *,
const char *nexthop);
void nbrec_logical_router_policy_index_set_nexthops(const struct nbrec_logical_router_policy *,
const char **nexthops, size_t n_nexthops);
void nbrec_logical_router_policy_index_set_options(const struct nbrec_logical_router_policy *,
const struct smap *);
void nbrec_logical_router_policy_index_set_priority(const struct nbrec_logical_router_policy *,
int64_t priority);

/* Logical_Router_Port table. */
struct nbrec_logical_router_port {
	struct ovsdb_idl_row header_;

	/* enabled column. */
	bool *enabled;
	size_t n_enabled;

	/* external_ids column. */
	struct smap external_ids;

	/* gateway_chassis column. */
	struct nbrec_gateway_chassis **gateway_chassis;
	size_t n_gateway_chassis;

	/* ha_chassis_group column. */
	struct nbrec_ha_chassis_group *ha_chassis_group;

	/* ipv6_prefix column. */
	char **ipv6_prefix;
	size_t n_ipv6_prefix;

	/* ipv6_ra_configs column. */
	struct smap ipv6_ra_configs;

	/* mac column. */
	char *mac;	/* Always nonnull. */

	/* name column. */
	char *name;	/* Always nonnull. */

	/* networks column. */
	char **networks;
	size_t n_networks;

	/* options column. */
	struct smap options;

	/* peer column. */
	char *peer;
};

enum nbrec_logical_router_port_column_id {
    NBREC_LOGICAL_ROUTER_PORT_COL_ENABLED,
    NBREC_LOGICAL_ROUTER_PORT_COL_EXTERNAL_IDS,
    NBREC_LOGICAL_ROUTER_PORT_COL_GATEWAY_CHASSIS,
    NBREC_LOGICAL_ROUTER_PORT_COL_HA_CHASSIS_GROUP,
    NBREC_LOGICAL_ROUTER_PORT_COL_IPV6_PREFIX,
    NBREC_LOGICAL_ROUTER_PORT_COL_IPV6_RA_CONFIGS,
    NBREC_LOGICAL_ROUTER_PORT_COL_MAC,
    NBREC_LOGICAL_ROUTER_PORT_COL_NAME,
    NBREC_LOGICAL_ROUTER_PORT_COL_NETWORKS,
    NBREC_LOGICAL_ROUTER_PORT_COL_OPTIONS,
    NBREC_LOGICAL_ROUTER_PORT_COL_PEER,
    NBREC_LOGICAL_ROUTER_PORT_N_COLUMNS
};

#define nbrec_logical_router_port_col_enabled (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_ENABLED])
#define nbrec_logical_router_port_col_external_ids (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_EXTERNAL_IDS])
#define nbrec_logical_router_port_col_gateway_chassis (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_GATEWAY_CHASSIS])
#define nbrec_logical_router_port_col_ha_chassis_group (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_HA_CHASSIS_GROUP])
#define nbrec_logical_router_port_col_ipv6_prefix (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_IPV6_PREFIX])
#define nbrec_logical_router_port_col_ipv6_ra_configs (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_IPV6_RA_CONFIGS])
#define nbrec_logical_router_port_col_mac (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_MAC])
#define nbrec_logical_router_port_col_name (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_NAME])
#define nbrec_logical_router_port_col_networks (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_NETWORKS])
#define nbrec_logical_router_port_col_options (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_OPTIONS])
#define nbrec_logical_router_port_col_peer (nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_COL_PEER])

extern struct ovsdb_idl_column nbrec_logical_router_port_columns[NBREC_LOGICAL_ROUTER_PORT_N_COLUMNS];

const struct nbrec_logical_router_port_table *nbrec_logical_router_port_table_get(const struct ovsdb_idl *);
const struct nbrec_logical_router_port *nbrec_logical_router_port_table_first(const struct nbrec_logical_router_port_table *);

#define NBREC_LOGICAL_ROUTER_PORT_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_logical_router_port_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_router_port_next(ROW))
#define NBREC_LOGICAL_ROUTER_PORT_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_logical_router_port_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_logical_router_port_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_logical_router_port *nbrec_logical_router_port_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_logical_router_port *nbrec_logical_router_port_table_get_for_uuid(const struct nbrec_logical_router_port_table *, const struct uuid *);
const struct nbrec_logical_router_port *nbrec_logical_router_port_first(const struct ovsdb_idl *);
const struct nbrec_logical_router_port *nbrec_logical_router_port_next(const struct nbrec_logical_router_port *);
#define NBREC_LOGICAL_ROUTER_PORT_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_logical_router_port_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_router_port_next(ROW))
#define NBREC_LOGICAL_ROUTER_PORT_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_logical_router_port_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_logical_router_port_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_logical_router_port_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_logical_router_port_row_get_seqno(const struct nbrec_logical_router_port *row, enum ovsdb_idl_change change);
const struct nbrec_logical_router_port *nbrec_logical_router_port_track_get_first(const struct ovsdb_idl *);
const struct nbrec_logical_router_port *nbrec_logical_router_port_track_get_next(const struct nbrec_logical_router_port *);
#define NBREC_LOGICAL_ROUTER_PORT_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_logical_router_port_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_router_port_track_get_next(ROW))

const struct nbrec_logical_router_port *nbrec_logical_router_port_table_track_get_first(const struct nbrec_logical_router_port_table *);
#define NBREC_LOGICAL_ROUTER_PORT_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_logical_router_port_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_router_port_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_logical_router_port_is_new(const struct nbrec_logical_router_port *row)
{
    return nbrec_logical_router_port_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_logical_router_port_is_deleted(const struct nbrec_logical_router_port *row)
{
    return nbrec_logical_router_port_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_logical_router_port_index_destroy_row(const struct nbrec_logical_router_port *);

struct nbrec_logical_router_port *nbrec_logical_router_port_index_find(struct ovsdb_idl_index *, const struct nbrec_logical_router_port *);

int nbrec_logical_router_port_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_logical_router_port *, 
    const struct nbrec_logical_router_port *);
struct ovsdb_idl_cursor nbrec_logical_router_port_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_logical_router_port_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_logical_router_port *);
struct ovsdb_idl_cursor nbrec_logical_router_port_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_logical_router_port *);

struct nbrec_logical_router_port *nbrec_logical_router_port_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_LOGICAL_ROUTER_PORT_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_port_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_logical_router_port_cursor_data(&cursor__), \
                  !(TO) || nbrec_logical_router_port_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_LOGICAL_ROUTER_PORT_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_port_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_router_port_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_LOGICAL_ROUTER_PORT_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_port_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_router_port_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_logical_router_port_init(struct nbrec_logical_router_port *);
void nbrec_logical_router_port_delete(const struct nbrec_logical_router_port *);
struct nbrec_logical_router_port *nbrec_logical_router_port_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_logical_router_port_column_id' of
 * the row referenced by 'struct nbrec_logical_router_port *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_logical_router_port_is_updated(const struct nbrec_logical_router_port *, enum nbrec_logical_router_port_column_id);

void nbrec_logical_router_port_verify_enabled(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_external_ids(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_gateway_chassis(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_ha_chassis_group(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_ipv6_prefix(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_ipv6_ra_configs(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_mac(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_name(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_networks(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_options(const struct nbrec_logical_router_port *);
void nbrec_logical_router_port_verify_peer(const struct nbrec_logical_router_port *);

const struct ovsdb_datum *nbrec_logical_router_port_get_enabled(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_external_ids(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_gateway_chassis(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_ha_chassis_group(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_ipv6_prefix(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_ipv6_ra_configs(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_mac(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_name(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_networks(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_options(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_port_get_peer(const struct nbrec_logical_router_port *, enum ovsdb_atomic_type key_type);

void nbrec_logical_router_port_set_enabled(const struct nbrec_logical_router_port *, const bool *enabled, size_t n_enabled);
void nbrec_logical_router_port_set_external_ids(const struct nbrec_logical_router_port *, const struct smap *);
void nbrec_logical_router_port_set_gateway_chassis(const struct nbrec_logical_router_port *, struct nbrec_gateway_chassis **gateway_chassis, size_t n_gateway_chassis);
void nbrec_logical_router_port_set_ha_chassis_group(const struct nbrec_logical_router_port *, const struct nbrec_ha_chassis_group *ha_chassis_group);
void nbrec_logical_router_port_set_ipv6_prefix(const struct nbrec_logical_router_port *, const char **ipv6_prefix, size_t n_ipv6_prefix);
void nbrec_logical_router_port_set_ipv6_ra_configs(const struct nbrec_logical_router_port *, const struct smap *);
void nbrec_logical_router_port_set_mac(const struct nbrec_logical_router_port *, const char *mac);
void nbrec_logical_router_port_set_name(const struct nbrec_logical_router_port *, const char *name);
void nbrec_logical_router_port_set_networks(const struct nbrec_logical_router_port *, const char **networks, size_t n_networks);
void nbrec_logical_router_port_set_options(const struct nbrec_logical_router_port *, const struct smap *);
void nbrec_logical_router_port_set_peer(const struct nbrec_logical_router_port *, const char *peer);

void nbrec_logical_router_port_update_enabled_addvalue(const struct nbrec_logical_router_port *,  bool );
void nbrec_logical_router_port_update_enabled_delvalue(const struct nbrec_logical_router_port *,  bool );
void nbrec_logical_router_port_add_clause_enabled(struct ovsdb_idl_condition *, enum ovsdb_function function, const bool *enabled, size_t n_enabled);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_update_external_ids_setkey(const struct nbrec_logical_router_port *,  const char *, const char *);
void nbrec_logical_router_port_update_external_ids_delkey(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_update_gateway_chassis_addvalue(const struct nbrec_logical_router_port *,  const struct nbrec_gateway_chassis *);
void nbrec_logical_router_port_update_gateway_chassis_delvalue(const struct nbrec_logical_router_port *,  const struct nbrec_gateway_chassis *);
void nbrec_logical_router_port_add_clause_gateway_chassis(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **gateway_chassis, size_t n_gateway_chassis);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_update_ha_chassis_group_addvalue(const struct nbrec_logical_router_port *,  const struct nbrec_ha_chassis_group *);
void nbrec_logical_router_port_update_ha_chassis_group_delvalue(const struct nbrec_logical_router_port *,  const struct nbrec_ha_chassis_group *);
void nbrec_logical_router_port_add_clause_ha_chassis_group(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *ha_chassis_group);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_update_ipv6_prefix_addvalue(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_update_ipv6_prefix_delvalue(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_add_clause_ipv6_prefix(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **ipv6_prefix, size_t n_ipv6_prefix);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_update_ipv6_ra_configs_setkey(const struct nbrec_logical_router_port *,  const char *, const char *);
void nbrec_logical_router_port_update_ipv6_ra_configs_delkey(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_add_clause_ipv6_ra_configs(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_add_clause_mac(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *mac);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_update_networks_addvalue(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_update_networks_delvalue(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_add_clause_networks(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **networks, size_t n_networks);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_update_options_setkey(const struct nbrec_logical_router_port *,  const char *, const char *);
void nbrec_logical_router_port_update_options_delkey(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_port_update_peer_addvalue(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_update_peer_delvalue(const struct nbrec_logical_router_port *,  const char *);
void nbrec_logical_router_port_add_clause_peer(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *peer);
unsigned int nbrec_logical_router_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_logical_router_port *nbrec_logical_router_port_index_init_row(struct ovsdb_idl_index *);
void nbrec_logical_router_port_index_set_enabled(const struct nbrec_logical_router_port *,
const bool *enabled, size_t n_enabled);
void nbrec_logical_router_port_index_set_external_ids(const struct nbrec_logical_router_port *,
const struct smap *);
void nbrec_logical_router_port_index_set_gateway_chassis(const struct nbrec_logical_router_port *,
struct nbrec_gateway_chassis **gateway_chassis, size_t n_gateway_chassis);
void nbrec_logical_router_port_index_set_ha_chassis_group(const struct nbrec_logical_router_port *,
const struct nbrec_ha_chassis_group *ha_chassis_group);
void nbrec_logical_router_port_index_set_ipv6_prefix(const struct nbrec_logical_router_port *,
const char **ipv6_prefix, size_t n_ipv6_prefix);
void nbrec_logical_router_port_index_set_ipv6_ra_configs(const struct nbrec_logical_router_port *,
const struct smap *);
void nbrec_logical_router_port_index_set_mac(const struct nbrec_logical_router_port *,
const char *mac);
void nbrec_logical_router_port_index_set_name(const struct nbrec_logical_router_port *,
const char *name);
void nbrec_logical_router_port_index_set_networks(const struct nbrec_logical_router_port *,
const char **networks, size_t n_networks);
void nbrec_logical_router_port_index_set_options(const struct nbrec_logical_router_port *,
const struct smap *);
void nbrec_logical_router_port_index_set_peer(const struct nbrec_logical_router_port *,
const char *peer);

/* Logical_Router_Static_Route table. */
struct nbrec_logical_router_static_route {
	struct ovsdb_idl_row header_;

	/* bfd column. */
	struct nbrec_bfd *bfd;

	/* external_ids column. */
	struct smap external_ids;

	/* ip_prefix column. */
	char *ip_prefix;	/* Always nonnull. */

	/* nexthop column. */
	char *nexthop;	/* Always nonnull. */

	/* options column. */
	struct smap options;

	/* output_port column. */
	char *output_port;

	/* policy column. */
	char *policy;
};

enum nbrec_logical_router_static_route_column_id {
    NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_BFD,
    NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_EXTERNAL_IDS,
    NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_IP_PREFIX,
    NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_NEXTHOP,
    NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_OPTIONS,
    NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_OUTPUT_PORT,
    NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_POLICY,
    NBREC_LOGICAL_ROUTER_STATIC_ROUTE_N_COLUMNS
};

#define nbrec_logical_router_static_route_col_bfd (nbrec_logical_router_static_route_columns[NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_BFD])
#define nbrec_logical_router_static_route_col_external_ids (nbrec_logical_router_static_route_columns[NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_EXTERNAL_IDS])
#define nbrec_logical_router_static_route_col_ip_prefix (nbrec_logical_router_static_route_columns[NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_IP_PREFIX])
#define nbrec_logical_router_static_route_col_nexthop (nbrec_logical_router_static_route_columns[NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_NEXTHOP])
#define nbrec_logical_router_static_route_col_options (nbrec_logical_router_static_route_columns[NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_OPTIONS])
#define nbrec_logical_router_static_route_col_output_port (nbrec_logical_router_static_route_columns[NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_OUTPUT_PORT])
#define nbrec_logical_router_static_route_col_policy (nbrec_logical_router_static_route_columns[NBREC_LOGICAL_ROUTER_STATIC_ROUTE_COL_POLICY])

extern struct ovsdb_idl_column nbrec_logical_router_static_route_columns[NBREC_LOGICAL_ROUTER_STATIC_ROUTE_N_COLUMNS];

const struct nbrec_logical_router_static_route_table *nbrec_logical_router_static_route_table_get(const struct ovsdb_idl *);
const struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_table_first(const struct nbrec_logical_router_static_route_table *);

#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_logical_router_static_route_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_router_static_route_next(ROW))
#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_logical_router_static_route_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_logical_router_static_route_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_table_get_for_uuid(const struct nbrec_logical_router_static_route_table *, const struct uuid *);
const struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_first(const struct ovsdb_idl *);
const struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_next(const struct nbrec_logical_router_static_route *);
#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_logical_router_static_route_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_router_static_route_next(ROW))
#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_logical_router_static_route_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_logical_router_static_route_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_logical_router_static_route_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_logical_router_static_route_row_get_seqno(const struct nbrec_logical_router_static_route *row, enum ovsdb_idl_change change);
const struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_track_get_first(const struct ovsdb_idl *);
const struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_track_get_next(const struct nbrec_logical_router_static_route *);
#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_logical_router_static_route_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_router_static_route_track_get_next(ROW))

const struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_table_track_get_first(const struct nbrec_logical_router_static_route_table *);
#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_logical_router_static_route_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_router_static_route_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_logical_router_static_route_is_new(const struct nbrec_logical_router_static_route *row)
{
    return nbrec_logical_router_static_route_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_logical_router_static_route_is_deleted(const struct nbrec_logical_router_static_route *row)
{
    return nbrec_logical_router_static_route_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_logical_router_static_route_index_destroy_row(const struct nbrec_logical_router_static_route *);

struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_index_find(struct ovsdb_idl_index *, const struct nbrec_logical_router_static_route *);

int nbrec_logical_router_static_route_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_logical_router_static_route *, 
    const struct nbrec_logical_router_static_route *);
struct ovsdb_idl_cursor nbrec_logical_router_static_route_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_logical_router_static_route_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_logical_router_static_route *);
struct ovsdb_idl_cursor nbrec_logical_router_static_route_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_logical_router_static_route *);

struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_static_route_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_logical_router_static_route_cursor_data(&cursor__), \
                  !(TO) || nbrec_logical_router_static_route_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_static_route_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_router_static_route_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_LOGICAL_ROUTER_STATIC_ROUTE_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_router_static_route_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_router_static_route_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_logical_router_static_route_init(struct nbrec_logical_router_static_route *);
void nbrec_logical_router_static_route_delete(const struct nbrec_logical_router_static_route *);
struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_logical_router_static_route_column_id' of
 * the row referenced by 'struct nbrec_logical_router_static_route *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_logical_router_static_route_is_updated(const struct nbrec_logical_router_static_route *, enum nbrec_logical_router_static_route_column_id);

void nbrec_logical_router_static_route_verify_bfd(const struct nbrec_logical_router_static_route *);
void nbrec_logical_router_static_route_verify_external_ids(const struct nbrec_logical_router_static_route *);
void nbrec_logical_router_static_route_verify_ip_prefix(const struct nbrec_logical_router_static_route *);
void nbrec_logical_router_static_route_verify_nexthop(const struct nbrec_logical_router_static_route *);
void nbrec_logical_router_static_route_verify_options(const struct nbrec_logical_router_static_route *);
void nbrec_logical_router_static_route_verify_output_port(const struct nbrec_logical_router_static_route *);
void nbrec_logical_router_static_route_verify_policy(const struct nbrec_logical_router_static_route *);

const struct ovsdb_datum *nbrec_logical_router_static_route_get_bfd(const struct nbrec_logical_router_static_route *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_static_route_get_external_ids(const struct nbrec_logical_router_static_route *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_static_route_get_ip_prefix(const struct nbrec_logical_router_static_route *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_static_route_get_nexthop(const struct nbrec_logical_router_static_route *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_static_route_get_options(const struct nbrec_logical_router_static_route *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_router_static_route_get_output_port(const struct nbrec_logical_router_static_route *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_router_static_route_get_policy(const struct nbrec_logical_router_static_route *, enum ovsdb_atomic_type key_type);

void nbrec_logical_router_static_route_set_bfd(const struct nbrec_logical_router_static_route *, const struct nbrec_bfd *bfd);
void nbrec_logical_router_static_route_set_external_ids(const struct nbrec_logical_router_static_route *, const struct smap *);
void nbrec_logical_router_static_route_set_ip_prefix(const struct nbrec_logical_router_static_route *, const char *ip_prefix);
void nbrec_logical_router_static_route_set_nexthop(const struct nbrec_logical_router_static_route *, const char *nexthop);
void nbrec_logical_router_static_route_set_options(const struct nbrec_logical_router_static_route *, const struct smap *);
void nbrec_logical_router_static_route_set_output_port(const struct nbrec_logical_router_static_route *, const char *output_port);
void nbrec_logical_router_static_route_set_policy(const struct nbrec_logical_router_static_route *, const char *policy);

void nbrec_logical_router_static_route_update_bfd_addvalue(const struct nbrec_logical_router_static_route *,  const struct nbrec_bfd *);
void nbrec_logical_router_static_route_update_bfd_delvalue(const struct nbrec_logical_router_static_route *,  const struct nbrec_bfd *);
void nbrec_logical_router_static_route_add_clause_bfd(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *bfd);
unsigned int nbrec_logical_router_static_route_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_static_route_update_external_ids_setkey(const struct nbrec_logical_router_static_route *,  const char *, const char *);
void nbrec_logical_router_static_route_update_external_ids_delkey(const struct nbrec_logical_router_static_route *,  const char *);
void nbrec_logical_router_static_route_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_static_route_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_static_route_add_clause_ip_prefix(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *ip_prefix);
unsigned int nbrec_logical_router_static_route_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_static_route_add_clause_nexthop(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *nexthop);
unsigned int nbrec_logical_router_static_route_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_static_route_update_options_setkey(const struct nbrec_logical_router_static_route *,  const char *, const char *);
void nbrec_logical_router_static_route_update_options_delkey(const struct nbrec_logical_router_static_route *,  const char *);
void nbrec_logical_router_static_route_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_router_static_route_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_static_route_update_output_port_addvalue(const struct nbrec_logical_router_static_route *,  const char *);
void nbrec_logical_router_static_route_update_output_port_delvalue(const struct nbrec_logical_router_static_route *,  const char *);
void nbrec_logical_router_static_route_add_clause_output_port(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *output_port);
unsigned int nbrec_logical_router_static_route_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_router_static_route_update_policy_addvalue(const struct nbrec_logical_router_static_route *,  const char *);
void nbrec_logical_router_static_route_update_policy_delvalue(const struct nbrec_logical_router_static_route *,  const char *);
void nbrec_logical_router_static_route_add_clause_policy(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *policy);
unsigned int nbrec_logical_router_static_route_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_logical_router_static_route *nbrec_logical_router_static_route_index_init_row(struct ovsdb_idl_index *);
void nbrec_logical_router_static_route_index_set_bfd(const struct nbrec_logical_router_static_route *,
const struct nbrec_bfd *bfd);
void nbrec_logical_router_static_route_index_set_external_ids(const struct nbrec_logical_router_static_route *,
const struct smap *);
void nbrec_logical_router_static_route_index_set_ip_prefix(const struct nbrec_logical_router_static_route *,
const char *ip_prefix);
void nbrec_logical_router_static_route_index_set_nexthop(const struct nbrec_logical_router_static_route *,
const char *nexthop);
void nbrec_logical_router_static_route_index_set_options(const struct nbrec_logical_router_static_route *,
const struct smap *);
void nbrec_logical_router_static_route_index_set_output_port(const struct nbrec_logical_router_static_route *,
const char *output_port);
void nbrec_logical_router_static_route_index_set_policy(const struct nbrec_logical_router_static_route *,
const char *policy);

/* Logical_Switch table. */
struct nbrec_logical_switch {
	struct ovsdb_idl_row header_;

	/* acls column. */
	struct nbrec_acl **acls;
	size_t n_acls;

	/* dns_records column. */
	struct nbrec_dns **dns_records;
	size_t n_dns_records;

	/* external_ids column. */
	struct smap external_ids;

	/* forwarding_groups column. */
	struct nbrec_forwarding_group **forwarding_groups;
	size_t n_forwarding_groups;

	/* load_balancer column. */
	struct nbrec_load_balancer **load_balancer;
	size_t n_load_balancer;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* other_config column. */
	struct smap other_config;

	/* ports column. */
	struct nbrec_logical_switch_port **ports;
	size_t n_ports;

	/* qos_rules column. */
	struct nbrec_qos **qos_rules;
	size_t n_qos_rules;
};

enum nbrec_logical_switch_column_id {
    NBREC_LOGICAL_SWITCH_COL_ACLS,
    NBREC_LOGICAL_SWITCH_COL_DNS_RECORDS,
    NBREC_LOGICAL_SWITCH_COL_EXTERNAL_IDS,
    NBREC_LOGICAL_SWITCH_COL_FORWARDING_GROUPS,
    NBREC_LOGICAL_SWITCH_COL_LOAD_BALANCER,
    NBREC_LOGICAL_SWITCH_COL_NAME,
    NBREC_LOGICAL_SWITCH_COL_OTHER_CONFIG,
    NBREC_LOGICAL_SWITCH_COL_PORTS,
    NBREC_LOGICAL_SWITCH_COL_QOS_RULES,
    NBREC_LOGICAL_SWITCH_N_COLUMNS
};

#define nbrec_logical_switch_col_acls (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_ACLS])
#define nbrec_logical_switch_col_dns_records (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_DNS_RECORDS])
#define nbrec_logical_switch_col_external_ids (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_EXTERNAL_IDS])
#define nbrec_logical_switch_col_forwarding_groups (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_FORWARDING_GROUPS])
#define nbrec_logical_switch_col_load_balancer (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_LOAD_BALANCER])
#define nbrec_logical_switch_col_name (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_NAME])
#define nbrec_logical_switch_col_other_config (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_OTHER_CONFIG])
#define nbrec_logical_switch_col_ports (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_PORTS])
#define nbrec_logical_switch_col_qos_rules (nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_COL_QOS_RULES])

extern struct ovsdb_idl_column nbrec_logical_switch_columns[NBREC_LOGICAL_SWITCH_N_COLUMNS];

const struct nbrec_logical_switch_table *nbrec_logical_switch_table_get(const struct ovsdb_idl *);
const struct nbrec_logical_switch *nbrec_logical_switch_table_first(const struct nbrec_logical_switch_table *);

#define NBREC_LOGICAL_SWITCH_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_logical_switch_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_switch_next(ROW))
#define NBREC_LOGICAL_SWITCH_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_logical_switch_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_logical_switch_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_logical_switch *nbrec_logical_switch_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_logical_switch *nbrec_logical_switch_table_get_for_uuid(const struct nbrec_logical_switch_table *, const struct uuid *);
const struct nbrec_logical_switch *nbrec_logical_switch_first(const struct ovsdb_idl *);
const struct nbrec_logical_switch *nbrec_logical_switch_next(const struct nbrec_logical_switch *);
#define NBREC_LOGICAL_SWITCH_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_logical_switch_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_switch_next(ROW))
#define NBREC_LOGICAL_SWITCH_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_logical_switch_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_logical_switch_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_logical_switch_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_logical_switch_row_get_seqno(const struct nbrec_logical_switch *row, enum ovsdb_idl_change change);
const struct nbrec_logical_switch *nbrec_logical_switch_track_get_first(const struct ovsdb_idl *);
const struct nbrec_logical_switch *nbrec_logical_switch_track_get_next(const struct nbrec_logical_switch *);
#define NBREC_LOGICAL_SWITCH_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_logical_switch_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_switch_track_get_next(ROW))

const struct nbrec_logical_switch *nbrec_logical_switch_table_track_get_first(const struct nbrec_logical_switch_table *);
#define NBREC_LOGICAL_SWITCH_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_logical_switch_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_switch_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_logical_switch_is_new(const struct nbrec_logical_switch *row)
{
    return nbrec_logical_switch_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_logical_switch_is_deleted(const struct nbrec_logical_switch *row)
{
    return nbrec_logical_switch_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_logical_switch_index_destroy_row(const struct nbrec_logical_switch *);

struct nbrec_logical_switch *nbrec_logical_switch_index_find(struct ovsdb_idl_index *, const struct nbrec_logical_switch *);

int nbrec_logical_switch_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_logical_switch *, 
    const struct nbrec_logical_switch *);
struct ovsdb_idl_cursor nbrec_logical_switch_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_logical_switch_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_logical_switch *);
struct ovsdb_idl_cursor nbrec_logical_switch_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_logical_switch *);

struct nbrec_logical_switch *nbrec_logical_switch_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_LOGICAL_SWITCH_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_switch_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_logical_switch_cursor_data(&cursor__), \
                  !(TO) || nbrec_logical_switch_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_LOGICAL_SWITCH_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_switch_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_switch_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_LOGICAL_SWITCH_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_switch_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_switch_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_logical_switch_init(struct nbrec_logical_switch *);
void nbrec_logical_switch_delete(const struct nbrec_logical_switch *);
struct nbrec_logical_switch *nbrec_logical_switch_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_logical_switch_column_id' of
 * the row referenced by 'struct nbrec_logical_switch *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_logical_switch_is_updated(const struct nbrec_logical_switch *, enum nbrec_logical_switch_column_id);

void nbrec_logical_switch_verify_acls(const struct nbrec_logical_switch *);
void nbrec_logical_switch_verify_dns_records(const struct nbrec_logical_switch *);
void nbrec_logical_switch_verify_external_ids(const struct nbrec_logical_switch *);
void nbrec_logical_switch_verify_forwarding_groups(const struct nbrec_logical_switch *);
void nbrec_logical_switch_verify_load_balancer(const struct nbrec_logical_switch *);
void nbrec_logical_switch_verify_name(const struct nbrec_logical_switch *);
void nbrec_logical_switch_verify_other_config(const struct nbrec_logical_switch *);
void nbrec_logical_switch_verify_ports(const struct nbrec_logical_switch *);
void nbrec_logical_switch_verify_qos_rules(const struct nbrec_logical_switch *);

const struct ovsdb_datum *nbrec_logical_switch_get_acls(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_get_dns_records(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_get_external_ids(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_switch_get_forwarding_groups(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_get_load_balancer(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_get_name(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_get_other_config(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_switch_get_ports(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_get_qos_rules(const struct nbrec_logical_switch *, enum ovsdb_atomic_type key_type);

void nbrec_logical_switch_set_acls(const struct nbrec_logical_switch *, struct nbrec_acl **acls, size_t n_acls);
void nbrec_logical_switch_set_dns_records(const struct nbrec_logical_switch *, struct nbrec_dns **dns_records, size_t n_dns_records);
void nbrec_logical_switch_set_external_ids(const struct nbrec_logical_switch *, const struct smap *);
void nbrec_logical_switch_set_forwarding_groups(const struct nbrec_logical_switch *, struct nbrec_forwarding_group **forwarding_groups, size_t n_forwarding_groups);
void nbrec_logical_switch_set_load_balancer(const struct nbrec_logical_switch *, struct nbrec_load_balancer **load_balancer, size_t n_load_balancer);
void nbrec_logical_switch_set_name(const struct nbrec_logical_switch *, const char *name);
void nbrec_logical_switch_set_other_config(const struct nbrec_logical_switch *, const struct smap *);
void nbrec_logical_switch_set_ports(const struct nbrec_logical_switch *, struct nbrec_logical_switch_port **ports, size_t n_ports);
void nbrec_logical_switch_set_qos_rules(const struct nbrec_logical_switch *, struct nbrec_qos **qos_rules, size_t n_qos_rules);

void nbrec_logical_switch_update_acls_addvalue(const struct nbrec_logical_switch *,  const struct nbrec_acl *);
void nbrec_logical_switch_update_acls_delvalue(const struct nbrec_logical_switch *,  const struct nbrec_acl *);
void nbrec_logical_switch_add_clause_acls(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **acls, size_t n_acls);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_update_dns_records_addvalue(const struct nbrec_logical_switch *,  const struct nbrec_dns *);
void nbrec_logical_switch_update_dns_records_delvalue(const struct nbrec_logical_switch *,  const struct nbrec_dns *);
void nbrec_logical_switch_add_clause_dns_records(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **dns_records, size_t n_dns_records);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_update_external_ids_setkey(const struct nbrec_logical_switch *,  const char *, const char *);
void nbrec_logical_switch_update_external_ids_delkey(const struct nbrec_logical_switch *,  const char *);
void nbrec_logical_switch_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_update_forwarding_groups_addvalue(const struct nbrec_logical_switch *,  const struct nbrec_forwarding_group *);
void nbrec_logical_switch_update_forwarding_groups_delvalue(const struct nbrec_logical_switch *,  const struct nbrec_forwarding_group *);
void nbrec_logical_switch_add_clause_forwarding_groups(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **forwarding_groups, size_t n_forwarding_groups);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_update_load_balancer_addvalue(const struct nbrec_logical_switch *,  const struct nbrec_load_balancer *);
void nbrec_logical_switch_update_load_balancer_delvalue(const struct nbrec_logical_switch *,  const struct nbrec_load_balancer *);
void nbrec_logical_switch_add_clause_load_balancer(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **load_balancer, size_t n_load_balancer);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_update_other_config_setkey(const struct nbrec_logical_switch *,  const char *, const char *);
void nbrec_logical_switch_update_other_config_delkey(const struct nbrec_logical_switch *,  const char *);
void nbrec_logical_switch_add_clause_other_config(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_update_ports_addvalue(const struct nbrec_logical_switch *,  const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_update_ports_delvalue(const struct nbrec_logical_switch *,  const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_add_clause_ports(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **ports, size_t n_ports);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_update_qos_rules_addvalue(const struct nbrec_logical_switch *,  const struct nbrec_qos *);
void nbrec_logical_switch_update_qos_rules_delvalue(const struct nbrec_logical_switch *,  const struct nbrec_qos *);
void nbrec_logical_switch_add_clause_qos_rules(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **qos_rules, size_t n_qos_rules);
unsigned int nbrec_logical_switch_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_logical_switch *nbrec_logical_switch_index_init_row(struct ovsdb_idl_index *);
void nbrec_logical_switch_index_set_acls(const struct nbrec_logical_switch *,
struct nbrec_acl **acls, size_t n_acls);
void nbrec_logical_switch_index_set_dns_records(const struct nbrec_logical_switch *,
struct nbrec_dns **dns_records, size_t n_dns_records);
void nbrec_logical_switch_index_set_external_ids(const struct nbrec_logical_switch *,
const struct smap *);
void nbrec_logical_switch_index_set_forwarding_groups(const struct nbrec_logical_switch *,
struct nbrec_forwarding_group **forwarding_groups, size_t n_forwarding_groups);
void nbrec_logical_switch_index_set_load_balancer(const struct nbrec_logical_switch *,
struct nbrec_load_balancer **load_balancer, size_t n_load_balancer);
void nbrec_logical_switch_index_set_name(const struct nbrec_logical_switch *,
const char *name);
void nbrec_logical_switch_index_set_other_config(const struct nbrec_logical_switch *,
const struct smap *);
void nbrec_logical_switch_index_set_ports(const struct nbrec_logical_switch *,
struct nbrec_logical_switch_port **ports, size_t n_ports);
void nbrec_logical_switch_index_set_qos_rules(const struct nbrec_logical_switch *,
struct nbrec_qos **qos_rules, size_t n_qos_rules);

/* Logical_Switch_Port table. */
struct nbrec_logical_switch_port {
	struct ovsdb_idl_row header_;

	/* addresses column. */
	char **addresses;
	size_t n_addresses;

	/* dhcpv4_options column. */
	struct nbrec_dhcp_options *dhcpv4_options;

	/* dhcpv6_options column. */
	struct nbrec_dhcp_options *dhcpv6_options;

	/* dynamic_addresses column. */
	char *dynamic_addresses;

	/* enabled column. */
	bool *enabled;
	size_t n_enabled;

	/* external_ids column. */
	struct smap external_ids;

	/* ha_chassis_group column. */
	struct nbrec_ha_chassis_group *ha_chassis_group;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* options column. */
	struct smap options;

	/* parent_name column. */
	char *parent_name;

	/* port_security column. */
	char **port_security;
	size_t n_port_security;

	/* tag column. */
	int64_t *tag;
	size_t n_tag;

	/* tag_request column. */
	int64_t *tag_request;
	size_t n_tag_request;

	/* type column. */
	char *type;	/* Always nonnull. */

	/* up column. */
	bool *up;
	size_t n_up;
};

enum nbrec_logical_switch_port_column_id {
    NBREC_LOGICAL_SWITCH_PORT_COL_ADDRESSES,
    NBREC_LOGICAL_SWITCH_PORT_COL_DHCPV4_OPTIONS,
    NBREC_LOGICAL_SWITCH_PORT_COL_DHCPV6_OPTIONS,
    NBREC_LOGICAL_SWITCH_PORT_COL_DYNAMIC_ADDRESSES,
    NBREC_LOGICAL_SWITCH_PORT_COL_ENABLED,
    NBREC_LOGICAL_SWITCH_PORT_COL_EXTERNAL_IDS,
    NBREC_LOGICAL_SWITCH_PORT_COL_HA_CHASSIS_GROUP,
    NBREC_LOGICAL_SWITCH_PORT_COL_NAME,
    NBREC_LOGICAL_SWITCH_PORT_COL_OPTIONS,
    NBREC_LOGICAL_SWITCH_PORT_COL_PARENT_NAME,
    NBREC_LOGICAL_SWITCH_PORT_COL_PORT_SECURITY,
    NBREC_LOGICAL_SWITCH_PORT_COL_TAG,
    NBREC_LOGICAL_SWITCH_PORT_COL_TAG_REQUEST,
    NBREC_LOGICAL_SWITCH_PORT_COL_TYPE,
    NBREC_LOGICAL_SWITCH_PORT_COL_UP,
    NBREC_LOGICAL_SWITCH_PORT_N_COLUMNS
};

#define nbrec_logical_switch_port_col_addresses (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_ADDRESSES])
#define nbrec_logical_switch_port_col_dhcpv4_options (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_DHCPV4_OPTIONS])
#define nbrec_logical_switch_port_col_dhcpv6_options (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_DHCPV6_OPTIONS])
#define nbrec_logical_switch_port_col_dynamic_addresses (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_DYNAMIC_ADDRESSES])
#define nbrec_logical_switch_port_col_enabled (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_ENABLED])
#define nbrec_logical_switch_port_col_external_ids (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_EXTERNAL_IDS])
#define nbrec_logical_switch_port_col_ha_chassis_group (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_HA_CHASSIS_GROUP])
#define nbrec_logical_switch_port_col_name (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_NAME])
#define nbrec_logical_switch_port_col_options (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_OPTIONS])
#define nbrec_logical_switch_port_col_parent_name (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_PARENT_NAME])
#define nbrec_logical_switch_port_col_port_security (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_PORT_SECURITY])
#define nbrec_logical_switch_port_col_tag (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_TAG])
#define nbrec_logical_switch_port_col_tag_request (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_TAG_REQUEST])
#define nbrec_logical_switch_port_col_type (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_TYPE])
#define nbrec_logical_switch_port_col_up (nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_COL_UP])

extern struct ovsdb_idl_column nbrec_logical_switch_port_columns[NBREC_LOGICAL_SWITCH_PORT_N_COLUMNS];

const struct nbrec_logical_switch_port_table *nbrec_logical_switch_port_table_get(const struct ovsdb_idl *);
const struct nbrec_logical_switch_port *nbrec_logical_switch_port_table_first(const struct nbrec_logical_switch_port_table *);

#define NBREC_LOGICAL_SWITCH_PORT_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_logical_switch_port_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_switch_port_next(ROW))
#define NBREC_LOGICAL_SWITCH_PORT_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_logical_switch_port_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_logical_switch_port_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_logical_switch_port *nbrec_logical_switch_port_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_logical_switch_port *nbrec_logical_switch_port_table_get_for_uuid(const struct nbrec_logical_switch_port_table *, const struct uuid *);
const struct nbrec_logical_switch_port *nbrec_logical_switch_port_first(const struct ovsdb_idl *);
const struct nbrec_logical_switch_port *nbrec_logical_switch_port_next(const struct nbrec_logical_switch_port *);
#define NBREC_LOGICAL_SWITCH_PORT_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_logical_switch_port_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_switch_port_next(ROW))
#define NBREC_LOGICAL_SWITCH_PORT_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_logical_switch_port_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_logical_switch_port_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_logical_switch_port_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_logical_switch_port_row_get_seqno(const struct nbrec_logical_switch_port *row, enum ovsdb_idl_change change);
const struct nbrec_logical_switch_port *nbrec_logical_switch_port_track_get_first(const struct ovsdb_idl *);
const struct nbrec_logical_switch_port *nbrec_logical_switch_port_track_get_next(const struct nbrec_logical_switch_port *);
#define NBREC_LOGICAL_SWITCH_PORT_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_logical_switch_port_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_logical_switch_port_track_get_next(ROW))

const struct nbrec_logical_switch_port *nbrec_logical_switch_port_table_track_get_first(const struct nbrec_logical_switch_port_table *);
#define NBREC_LOGICAL_SWITCH_PORT_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_logical_switch_port_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_logical_switch_port_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_logical_switch_port_is_new(const struct nbrec_logical_switch_port *row)
{
    return nbrec_logical_switch_port_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_logical_switch_port_is_deleted(const struct nbrec_logical_switch_port *row)
{
    return nbrec_logical_switch_port_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_logical_switch_port_index_destroy_row(const struct nbrec_logical_switch_port *);

struct nbrec_logical_switch_port *nbrec_logical_switch_port_index_find(struct ovsdb_idl_index *, const struct nbrec_logical_switch_port *);

int nbrec_logical_switch_port_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_logical_switch_port *, 
    const struct nbrec_logical_switch_port *);
struct ovsdb_idl_cursor nbrec_logical_switch_port_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_logical_switch_port_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_logical_switch_port *);
struct ovsdb_idl_cursor nbrec_logical_switch_port_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_logical_switch_port *);

struct nbrec_logical_switch_port *nbrec_logical_switch_port_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_LOGICAL_SWITCH_PORT_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_switch_port_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_logical_switch_port_cursor_data(&cursor__), \
                  !(TO) || nbrec_logical_switch_port_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_LOGICAL_SWITCH_PORT_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_switch_port_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_switch_port_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_LOGICAL_SWITCH_PORT_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_logical_switch_port_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_logical_switch_port_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_logical_switch_port_init(struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_delete(const struct nbrec_logical_switch_port *);
struct nbrec_logical_switch_port *nbrec_logical_switch_port_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_logical_switch_port_column_id' of
 * the row referenced by 'struct nbrec_logical_switch_port *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_logical_switch_port_is_updated(const struct nbrec_logical_switch_port *, enum nbrec_logical_switch_port_column_id);

void nbrec_logical_switch_port_verify_addresses(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_dhcpv4_options(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_dhcpv6_options(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_dynamic_addresses(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_enabled(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_external_ids(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_ha_chassis_group(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_name(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_options(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_parent_name(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_port_security(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_tag(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_tag_request(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_type(const struct nbrec_logical_switch_port *);
void nbrec_logical_switch_port_verify_up(const struct nbrec_logical_switch_port *);

const struct ovsdb_datum *nbrec_logical_switch_port_get_addresses(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_dhcpv4_options(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_dhcpv6_options(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_dynamic_addresses(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_enabled(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_external_ids(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_ha_chassis_group(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_name(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_options(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_parent_name(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_port_security(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_tag(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_tag_request(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_type(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_logical_switch_port_get_up(const struct nbrec_logical_switch_port *, enum ovsdb_atomic_type key_type);

void nbrec_logical_switch_port_set_addresses(const struct nbrec_logical_switch_port *, const char **addresses, size_t n_addresses);
void nbrec_logical_switch_port_set_dhcpv4_options(const struct nbrec_logical_switch_port *, const struct nbrec_dhcp_options *dhcpv4_options);
void nbrec_logical_switch_port_set_dhcpv6_options(const struct nbrec_logical_switch_port *, const struct nbrec_dhcp_options *dhcpv6_options);
void nbrec_logical_switch_port_set_dynamic_addresses(const struct nbrec_logical_switch_port *, const char *dynamic_addresses);
void nbrec_logical_switch_port_set_enabled(const struct nbrec_logical_switch_port *, const bool *enabled, size_t n_enabled);
void nbrec_logical_switch_port_set_external_ids(const struct nbrec_logical_switch_port *, const struct smap *);
void nbrec_logical_switch_port_set_ha_chassis_group(const struct nbrec_logical_switch_port *, const struct nbrec_ha_chassis_group *ha_chassis_group);
void nbrec_logical_switch_port_set_name(const struct nbrec_logical_switch_port *, const char *name);
void nbrec_logical_switch_port_set_options(const struct nbrec_logical_switch_port *, const struct smap *);
void nbrec_logical_switch_port_set_parent_name(const struct nbrec_logical_switch_port *, const char *parent_name);
void nbrec_logical_switch_port_set_port_security(const struct nbrec_logical_switch_port *, const char **port_security, size_t n_port_security);
void nbrec_logical_switch_port_set_tag(const struct nbrec_logical_switch_port *, const int64_t *tag, size_t n_tag);
void nbrec_logical_switch_port_set_tag_request(const struct nbrec_logical_switch_port *, const int64_t *tag_request, size_t n_tag_request);
void nbrec_logical_switch_port_set_type(const struct nbrec_logical_switch_port *, const char *type);
void nbrec_logical_switch_port_set_up(const struct nbrec_logical_switch_port *, const bool *up, size_t n_up);

void nbrec_logical_switch_port_update_addresses_addvalue(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_update_addresses_delvalue(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_add_clause_addresses(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **addresses, size_t n_addresses);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_dhcpv4_options_addvalue(const struct nbrec_logical_switch_port *,  const struct nbrec_dhcp_options *);
void nbrec_logical_switch_port_update_dhcpv4_options_delvalue(const struct nbrec_logical_switch_port *,  const struct nbrec_dhcp_options *);
void nbrec_logical_switch_port_add_clause_dhcpv4_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *dhcpv4_options);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_dhcpv6_options_addvalue(const struct nbrec_logical_switch_port *,  const struct nbrec_dhcp_options *);
void nbrec_logical_switch_port_update_dhcpv6_options_delvalue(const struct nbrec_logical_switch_port *,  const struct nbrec_dhcp_options *);
void nbrec_logical_switch_port_add_clause_dhcpv6_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *dhcpv6_options);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_dynamic_addresses_addvalue(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_update_dynamic_addresses_delvalue(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_add_clause_dynamic_addresses(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *dynamic_addresses);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_enabled_addvalue(const struct nbrec_logical_switch_port *,  bool );
void nbrec_logical_switch_port_update_enabled_delvalue(const struct nbrec_logical_switch_port *,  bool );
void nbrec_logical_switch_port_add_clause_enabled(struct ovsdb_idl_condition *, enum ovsdb_function function, const bool *enabled, size_t n_enabled);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_external_ids_setkey(const struct nbrec_logical_switch_port *,  const char *, const char *);
void nbrec_logical_switch_port_update_external_ids_delkey(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_ha_chassis_group_addvalue(const struct nbrec_logical_switch_port *,  const struct nbrec_ha_chassis_group *);
void nbrec_logical_switch_port_update_ha_chassis_group_delvalue(const struct nbrec_logical_switch_port *,  const struct nbrec_ha_chassis_group *);
void nbrec_logical_switch_port_add_clause_ha_chassis_group(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *ha_chassis_group);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_options_setkey(const struct nbrec_logical_switch_port *,  const char *, const char *);
void nbrec_logical_switch_port_update_options_delkey(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_parent_name_addvalue(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_update_parent_name_delvalue(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_add_clause_parent_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *parent_name);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_port_security_addvalue(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_update_port_security_delvalue(const struct nbrec_logical_switch_port *,  const char *);
void nbrec_logical_switch_port_add_clause_port_security(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **port_security, size_t n_port_security);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_tag_addvalue(const struct nbrec_logical_switch_port *,  int64_t );
void nbrec_logical_switch_port_update_tag_delvalue(const struct nbrec_logical_switch_port *,  int64_t );
void nbrec_logical_switch_port_add_clause_tag(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *tag, size_t n_tag);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_tag_request_addvalue(const struct nbrec_logical_switch_port *,  int64_t );
void nbrec_logical_switch_port_update_tag_request_delvalue(const struct nbrec_logical_switch_port *,  int64_t );
void nbrec_logical_switch_port_add_clause_tag_request(struct ovsdb_idl_condition *, enum ovsdb_function function, const int64_t *tag_request, size_t n_tag_request);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_add_clause_type(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *type);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_logical_switch_port_update_up_addvalue(const struct nbrec_logical_switch_port *,  bool );
void nbrec_logical_switch_port_update_up_delvalue(const struct nbrec_logical_switch_port *,  bool );
void nbrec_logical_switch_port_add_clause_up(struct ovsdb_idl_condition *, enum ovsdb_function function, const bool *up, size_t n_up);
unsigned int nbrec_logical_switch_port_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_logical_switch_port *nbrec_logical_switch_port_index_init_row(struct ovsdb_idl_index *);
void nbrec_logical_switch_port_index_set_addresses(const struct nbrec_logical_switch_port *,
const char **addresses, size_t n_addresses);
void nbrec_logical_switch_port_index_set_dhcpv4_options(const struct nbrec_logical_switch_port *,
const struct nbrec_dhcp_options *dhcpv4_options);
void nbrec_logical_switch_port_index_set_dhcpv6_options(const struct nbrec_logical_switch_port *,
const struct nbrec_dhcp_options *dhcpv6_options);
void nbrec_logical_switch_port_index_set_dynamic_addresses(const struct nbrec_logical_switch_port *,
const char *dynamic_addresses);
void nbrec_logical_switch_port_index_set_enabled(const struct nbrec_logical_switch_port *,
const bool *enabled, size_t n_enabled);
void nbrec_logical_switch_port_index_set_external_ids(const struct nbrec_logical_switch_port *,
const struct smap *);
void nbrec_logical_switch_port_index_set_ha_chassis_group(const struct nbrec_logical_switch_port *,
const struct nbrec_ha_chassis_group *ha_chassis_group);
void nbrec_logical_switch_port_index_set_name(const struct nbrec_logical_switch_port *,
const char *name);
void nbrec_logical_switch_port_index_set_options(const struct nbrec_logical_switch_port *,
const struct smap *);
void nbrec_logical_switch_port_index_set_parent_name(const struct nbrec_logical_switch_port *,
const char *parent_name);
void nbrec_logical_switch_port_index_set_port_security(const struct nbrec_logical_switch_port *,
const char **port_security, size_t n_port_security);
void nbrec_logical_switch_port_index_set_tag(const struct nbrec_logical_switch_port *,
const int64_t *tag, size_t n_tag);
void nbrec_logical_switch_port_index_set_tag_request(const struct nbrec_logical_switch_port *,
const int64_t *tag_request, size_t n_tag_request);
void nbrec_logical_switch_port_index_set_type(const struct nbrec_logical_switch_port *,
const char *type);
void nbrec_logical_switch_port_index_set_up(const struct nbrec_logical_switch_port *,
const bool *up, size_t n_up);

/* Meter table. */
struct nbrec_meter {
	struct ovsdb_idl_row header_;

	/* bands column. */
	struct nbrec_meter_band **bands;
	size_t n_bands;

	/* external_ids column. */
	struct smap external_ids;

	/* fair column. */
	bool *fair;
	size_t n_fair;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* unit column. */
	char *unit;	/* Always nonnull. */
};

enum nbrec_meter_column_id {
    NBREC_METER_COL_BANDS,
    NBREC_METER_COL_EXTERNAL_IDS,
    NBREC_METER_COL_FAIR,
    NBREC_METER_COL_NAME,
    NBREC_METER_COL_UNIT,
    NBREC_METER_N_COLUMNS
};

#define nbrec_meter_col_bands (nbrec_meter_columns[NBREC_METER_COL_BANDS])
#define nbrec_meter_col_external_ids (nbrec_meter_columns[NBREC_METER_COL_EXTERNAL_IDS])
#define nbrec_meter_col_fair (nbrec_meter_columns[NBREC_METER_COL_FAIR])
#define nbrec_meter_col_name (nbrec_meter_columns[NBREC_METER_COL_NAME])
#define nbrec_meter_col_unit (nbrec_meter_columns[NBREC_METER_COL_UNIT])

extern struct ovsdb_idl_column nbrec_meter_columns[NBREC_METER_N_COLUMNS];

const struct nbrec_meter_table *nbrec_meter_table_get(const struct ovsdb_idl *);
const struct nbrec_meter *nbrec_meter_table_first(const struct nbrec_meter_table *);

#define NBREC_METER_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_meter_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_meter_next(ROW))
#define NBREC_METER_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_meter_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_meter_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_meter *nbrec_meter_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_meter *nbrec_meter_table_get_for_uuid(const struct nbrec_meter_table *, const struct uuid *);
const struct nbrec_meter *nbrec_meter_first(const struct ovsdb_idl *);
const struct nbrec_meter *nbrec_meter_next(const struct nbrec_meter *);
#define NBREC_METER_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_meter_first(IDL); \
             (ROW); \
             (ROW) = nbrec_meter_next(ROW))
#define NBREC_METER_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_meter_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_meter_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_meter_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_meter_row_get_seqno(const struct nbrec_meter *row, enum ovsdb_idl_change change);
const struct nbrec_meter *nbrec_meter_track_get_first(const struct ovsdb_idl *);
const struct nbrec_meter *nbrec_meter_track_get_next(const struct nbrec_meter *);
#define NBREC_METER_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_meter_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_meter_track_get_next(ROW))

const struct nbrec_meter *nbrec_meter_table_track_get_first(const struct nbrec_meter_table *);
#define NBREC_METER_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_meter_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_meter_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_meter_is_new(const struct nbrec_meter *row)
{
    return nbrec_meter_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_meter_is_deleted(const struct nbrec_meter *row)
{
    return nbrec_meter_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_meter_index_destroy_row(const struct nbrec_meter *);

struct nbrec_meter *nbrec_meter_index_find(struct ovsdb_idl_index *, const struct nbrec_meter *);

int nbrec_meter_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_meter *, 
    const struct nbrec_meter *);
struct ovsdb_idl_cursor nbrec_meter_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_meter_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_meter *);
struct ovsdb_idl_cursor nbrec_meter_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_meter *);

struct nbrec_meter *nbrec_meter_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_METER_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_meter_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_meter_cursor_data(&cursor__), \
                  !(TO) || nbrec_meter_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_METER_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_meter_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_meter_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_METER_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_meter_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_meter_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_meter_init(struct nbrec_meter *);
void nbrec_meter_delete(const struct nbrec_meter *);
struct nbrec_meter *nbrec_meter_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_meter_column_id' of
 * the row referenced by 'struct nbrec_meter *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_meter_is_updated(const struct nbrec_meter *, enum nbrec_meter_column_id);

void nbrec_meter_verify_bands(const struct nbrec_meter *);
void nbrec_meter_verify_external_ids(const struct nbrec_meter *);
void nbrec_meter_verify_fair(const struct nbrec_meter *);
void nbrec_meter_verify_name(const struct nbrec_meter *);
void nbrec_meter_verify_unit(const struct nbrec_meter *);

const struct ovsdb_datum *nbrec_meter_get_bands(const struct nbrec_meter *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_meter_get_external_ids(const struct nbrec_meter *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_meter_get_fair(const struct nbrec_meter *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_meter_get_name(const struct nbrec_meter *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_meter_get_unit(const struct nbrec_meter *, enum ovsdb_atomic_type key_type);

void nbrec_meter_set_bands(const struct nbrec_meter *, struct nbrec_meter_band **bands, size_t n_bands);
void nbrec_meter_set_external_ids(const struct nbrec_meter *, const struct smap *);
void nbrec_meter_set_fair(const struct nbrec_meter *, const bool *fair, size_t n_fair);
void nbrec_meter_set_name(const struct nbrec_meter *, const char *name);
void nbrec_meter_set_unit(const struct nbrec_meter *, const char *unit);

void nbrec_meter_update_bands_addvalue(const struct nbrec_meter *,  const struct nbrec_meter_band *);
void nbrec_meter_update_bands_delvalue(const struct nbrec_meter *,  const struct nbrec_meter_band *);
void nbrec_meter_add_clause_bands(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **bands, size_t n_bands);
unsigned int nbrec_meter_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_meter_update_external_ids_setkey(const struct nbrec_meter *,  const char *, const char *);
void nbrec_meter_update_external_ids_delkey(const struct nbrec_meter *,  const char *);
void nbrec_meter_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_meter_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_meter_update_fair_addvalue(const struct nbrec_meter *,  bool );
void nbrec_meter_update_fair_delvalue(const struct nbrec_meter *,  bool );
void nbrec_meter_add_clause_fair(struct ovsdb_idl_condition *, enum ovsdb_function function, const bool *fair, size_t n_fair);
unsigned int nbrec_meter_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_meter_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_meter_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_meter_add_clause_unit(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *unit);
unsigned int nbrec_meter_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_meter *nbrec_meter_index_init_row(struct ovsdb_idl_index *);
void nbrec_meter_index_set_bands(const struct nbrec_meter *,
struct nbrec_meter_band **bands, size_t n_bands);
void nbrec_meter_index_set_external_ids(const struct nbrec_meter *,
const struct smap *);
void nbrec_meter_index_set_fair(const struct nbrec_meter *,
const bool *fair, size_t n_fair);
void nbrec_meter_index_set_name(const struct nbrec_meter *,
const char *name);
void nbrec_meter_index_set_unit(const struct nbrec_meter *,
const char *unit);

/* Meter_Band table. */
struct nbrec_meter_band {
	struct ovsdb_idl_row header_;

	/* action column. */
	char *action;	/* Always nonnull. */

	/* burst_size column. */
	int64_t burst_size;

	/* external_ids column. */
	struct smap external_ids;

	/* rate column. */
	int64_t rate;
};

enum nbrec_meter_band_column_id {
    NBREC_METER_BAND_COL_ACTION,
    NBREC_METER_BAND_COL_BURST_SIZE,
    NBREC_METER_BAND_COL_EXTERNAL_IDS,
    NBREC_METER_BAND_COL_RATE,
    NBREC_METER_BAND_N_COLUMNS
};

#define nbrec_meter_band_col_action (nbrec_meter_band_columns[NBREC_METER_BAND_COL_ACTION])
#define nbrec_meter_band_col_burst_size (nbrec_meter_band_columns[NBREC_METER_BAND_COL_BURST_SIZE])
#define nbrec_meter_band_col_external_ids (nbrec_meter_band_columns[NBREC_METER_BAND_COL_EXTERNAL_IDS])
#define nbrec_meter_band_col_rate (nbrec_meter_band_columns[NBREC_METER_BAND_COL_RATE])

extern struct ovsdb_idl_column nbrec_meter_band_columns[NBREC_METER_BAND_N_COLUMNS];

const struct nbrec_meter_band_table *nbrec_meter_band_table_get(const struct ovsdb_idl *);
const struct nbrec_meter_band *nbrec_meter_band_table_first(const struct nbrec_meter_band_table *);

#define NBREC_METER_BAND_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_meter_band_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_meter_band_next(ROW))
#define NBREC_METER_BAND_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_meter_band_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_meter_band_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_meter_band *nbrec_meter_band_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_meter_band *nbrec_meter_band_table_get_for_uuid(const struct nbrec_meter_band_table *, const struct uuid *);
const struct nbrec_meter_band *nbrec_meter_band_first(const struct ovsdb_idl *);
const struct nbrec_meter_band *nbrec_meter_band_next(const struct nbrec_meter_band *);
#define NBREC_METER_BAND_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_meter_band_first(IDL); \
             (ROW); \
             (ROW) = nbrec_meter_band_next(ROW))
#define NBREC_METER_BAND_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_meter_band_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_meter_band_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_meter_band_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_meter_band_row_get_seqno(const struct nbrec_meter_band *row, enum ovsdb_idl_change change);
const struct nbrec_meter_band *nbrec_meter_band_track_get_first(const struct ovsdb_idl *);
const struct nbrec_meter_band *nbrec_meter_band_track_get_next(const struct nbrec_meter_band *);
#define NBREC_METER_BAND_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_meter_band_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_meter_band_track_get_next(ROW))

const struct nbrec_meter_band *nbrec_meter_band_table_track_get_first(const struct nbrec_meter_band_table *);
#define NBREC_METER_BAND_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_meter_band_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_meter_band_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_meter_band_is_new(const struct nbrec_meter_band *row)
{
    return nbrec_meter_band_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_meter_band_is_deleted(const struct nbrec_meter_band *row)
{
    return nbrec_meter_band_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_meter_band_index_destroy_row(const struct nbrec_meter_band *);

struct nbrec_meter_band *nbrec_meter_band_index_find(struct ovsdb_idl_index *, const struct nbrec_meter_band *);

int nbrec_meter_band_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_meter_band *, 
    const struct nbrec_meter_band *);
struct ovsdb_idl_cursor nbrec_meter_band_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_meter_band_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_meter_band *);
struct ovsdb_idl_cursor nbrec_meter_band_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_meter_band *);

struct nbrec_meter_band *nbrec_meter_band_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_METER_BAND_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_meter_band_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_meter_band_cursor_data(&cursor__), \
                  !(TO) || nbrec_meter_band_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_METER_BAND_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_meter_band_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_meter_band_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_METER_BAND_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_meter_band_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_meter_band_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_meter_band_init(struct nbrec_meter_band *);
void nbrec_meter_band_delete(const struct nbrec_meter_band *);
struct nbrec_meter_band *nbrec_meter_band_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_meter_band_column_id' of
 * the row referenced by 'struct nbrec_meter_band *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_meter_band_is_updated(const struct nbrec_meter_band *, enum nbrec_meter_band_column_id);

void nbrec_meter_band_verify_action(const struct nbrec_meter_band *);
void nbrec_meter_band_verify_burst_size(const struct nbrec_meter_band *);
void nbrec_meter_band_verify_external_ids(const struct nbrec_meter_band *);
void nbrec_meter_band_verify_rate(const struct nbrec_meter_band *);

const struct ovsdb_datum *nbrec_meter_band_get_action(const struct nbrec_meter_band *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_meter_band_get_burst_size(const struct nbrec_meter_band *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_meter_band_get_external_ids(const struct nbrec_meter_band *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_meter_band_get_rate(const struct nbrec_meter_band *, enum ovsdb_atomic_type key_type);

void nbrec_meter_band_set_action(const struct nbrec_meter_band *, const char *action);
void nbrec_meter_band_set_burst_size(const struct nbrec_meter_band *, int64_t burst_size);
void nbrec_meter_band_set_external_ids(const struct nbrec_meter_band *, const struct smap *);
void nbrec_meter_band_set_rate(const struct nbrec_meter_band *, int64_t rate);

void nbrec_meter_band_add_clause_action(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *action);
unsigned int nbrec_meter_band_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_meter_band_add_clause_burst_size(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t burst_size);
unsigned int nbrec_meter_band_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_meter_band_update_external_ids_setkey(const struct nbrec_meter_band *,  const char *, const char *);
void nbrec_meter_band_update_external_ids_delkey(const struct nbrec_meter_band *,  const char *);
void nbrec_meter_band_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_meter_band_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_meter_band_add_clause_rate(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t rate);
unsigned int nbrec_meter_band_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_meter_band *nbrec_meter_band_index_init_row(struct ovsdb_idl_index *);
void nbrec_meter_band_index_set_action(const struct nbrec_meter_band *,
const char *action);
void nbrec_meter_band_index_set_burst_size(const struct nbrec_meter_band *,
int64_t burst_size);
void nbrec_meter_band_index_set_external_ids(const struct nbrec_meter_band *,
const struct smap *);
void nbrec_meter_band_index_set_rate(const struct nbrec_meter_band *,
int64_t rate);

/* NAT table. */
struct nbrec_nat {
	struct ovsdb_idl_row header_;

	/* allowed_ext_ips column. */
	struct nbrec_address_set *allowed_ext_ips;

	/* exempted_ext_ips column. */
	struct nbrec_address_set *exempted_ext_ips;

	/* external_ids column. */
	struct smap external_ids;

	/* external_ip column. */
	char *external_ip;	/* Always nonnull. */

	/* external_mac column. */
	char *external_mac;

	/* external_port_range column. */
	char *external_port_range;	/* Always nonnull. */

	/* logical_ip column. */
	char *logical_ip;	/* Always nonnull. */

	/* logical_port column. */
	char *logical_port;

	/* options column. */
	struct smap options;

	/* type column. */
	char *type;	/* Always nonnull. */
};

enum nbrec_nat_column_id {
    NBREC_NAT_COL_ALLOWED_EXT_IPS,
    NBREC_NAT_COL_EXEMPTED_EXT_IPS,
    NBREC_NAT_COL_EXTERNAL_IDS,
    NBREC_NAT_COL_EXTERNAL_IP,
    NBREC_NAT_COL_EXTERNAL_MAC,
    NBREC_NAT_COL_EXTERNAL_PORT_RANGE,
    NBREC_NAT_COL_LOGICAL_IP,
    NBREC_NAT_COL_LOGICAL_PORT,
    NBREC_NAT_COL_OPTIONS,
    NBREC_NAT_COL_TYPE,
    NBREC_NAT_N_COLUMNS
};

#define nbrec_nat_col_allowed_ext_ips (nbrec_nat_columns[NBREC_NAT_COL_ALLOWED_EXT_IPS])
#define nbrec_nat_col_exempted_ext_ips (nbrec_nat_columns[NBREC_NAT_COL_EXEMPTED_EXT_IPS])
#define nbrec_nat_col_external_ids (nbrec_nat_columns[NBREC_NAT_COL_EXTERNAL_IDS])
#define nbrec_nat_col_external_ip (nbrec_nat_columns[NBREC_NAT_COL_EXTERNAL_IP])
#define nbrec_nat_col_external_mac (nbrec_nat_columns[NBREC_NAT_COL_EXTERNAL_MAC])
#define nbrec_nat_col_external_port_range (nbrec_nat_columns[NBREC_NAT_COL_EXTERNAL_PORT_RANGE])
#define nbrec_nat_col_logical_ip (nbrec_nat_columns[NBREC_NAT_COL_LOGICAL_IP])
#define nbrec_nat_col_logical_port (nbrec_nat_columns[NBREC_NAT_COL_LOGICAL_PORT])
#define nbrec_nat_col_options (nbrec_nat_columns[NBREC_NAT_COL_OPTIONS])
#define nbrec_nat_col_type (nbrec_nat_columns[NBREC_NAT_COL_TYPE])

extern struct ovsdb_idl_column nbrec_nat_columns[NBREC_NAT_N_COLUMNS];

const struct nbrec_nat_table *nbrec_nat_table_get(const struct ovsdb_idl *);
const struct nbrec_nat *nbrec_nat_table_first(const struct nbrec_nat_table *);

#define NBREC_NAT_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_nat_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_nat_next(ROW))
#define NBREC_NAT_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_nat_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_nat_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_nat *nbrec_nat_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_nat *nbrec_nat_table_get_for_uuid(const struct nbrec_nat_table *, const struct uuid *);
const struct nbrec_nat *nbrec_nat_first(const struct ovsdb_idl *);
const struct nbrec_nat *nbrec_nat_next(const struct nbrec_nat *);
#define NBREC_NAT_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_nat_first(IDL); \
             (ROW); \
             (ROW) = nbrec_nat_next(ROW))
#define NBREC_NAT_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_nat_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_nat_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_nat_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_nat_row_get_seqno(const struct nbrec_nat *row, enum ovsdb_idl_change change);
const struct nbrec_nat *nbrec_nat_track_get_first(const struct ovsdb_idl *);
const struct nbrec_nat *nbrec_nat_track_get_next(const struct nbrec_nat *);
#define NBREC_NAT_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_nat_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_nat_track_get_next(ROW))

const struct nbrec_nat *nbrec_nat_table_track_get_first(const struct nbrec_nat_table *);
#define NBREC_NAT_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_nat_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_nat_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_nat_is_new(const struct nbrec_nat *row)
{
    return nbrec_nat_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_nat_is_deleted(const struct nbrec_nat *row)
{
    return nbrec_nat_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_nat_index_destroy_row(const struct nbrec_nat *);

struct nbrec_nat *nbrec_nat_index_find(struct ovsdb_idl_index *, const struct nbrec_nat *);

int nbrec_nat_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_nat *, 
    const struct nbrec_nat *);
struct ovsdb_idl_cursor nbrec_nat_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_nat_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_nat *);
struct ovsdb_idl_cursor nbrec_nat_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_nat *);

struct nbrec_nat *nbrec_nat_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_NAT_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_nat_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_nat_cursor_data(&cursor__), \
                  !(TO) || nbrec_nat_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_NAT_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_nat_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_nat_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_NAT_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_nat_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_nat_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_nat_init(struct nbrec_nat *);
void nbrec_nat_delete(const struct nbrec_nat *);
struct nbrec_nat *nbrec_nat_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_nat_column_id' of
 * the row referenced by 'struct nbrec_nat *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_nat_is_updated(const struct nbrec_nat *, enum nbrec_nat_column_id);

void nbrec_nat_verify_allowed_ext_ips(const struct nbrec_nat *);
void nbrec_nat_verify_exempted_ext_ips(const struct nbrec_nat *);
void nbrec_nat_verify_external_ids(const struct nbrec_nat *);
void nbrec_nat_verify_external_ip(const struct nbrec_nat *);
void nbrec_nat_verify_external_mac(const struct nbrec_nat *);
void nbrec_nat_verify_external_port_range(const struct nbrec_nat *);
void nbrec_nat_verify_logical_ip(const struct nbrec_nat *);
void nbrec_nat_verify_logical_port(const struct nbrec_nat *);
void nbrec_nat_verify_options(const struct nbrec_nat *);
void nbrec_nat_verify_type(const struct nbrec_nat *);

const struct ovsdb_datum *nbrec_nat_get_allowed_ext_ips(const struct nbrec_nat *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nat_get_exempted_ext_ips(const struct nbrec_nat *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nat_get_external_ids(const struct nbrec_nat *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_nat_get_external_ip(const struct nbrec_nat *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nat_get_external_mac(const struct nbrec_nat *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nat_get_external_port_range(const struct nbrec_nat *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nat_get_logical_ip(const struct nbrec_nat *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nat_get_logical_port(const struct nbrec_nat *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nat_get_options(const struct nbrec_nat *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_nat_get_type(const struct nbrec_nat *, enum ovsdb_atomic_type key_type);

void nbrec_nat_set_allowed_ext_ips(const struct nbrec_nat *, const struct nbrec_address_set *allowed_ext_ips);
void nbrec_nat_set_exempted_ext_ips(const struct nbrec_nat *, const struct nbrec_address_set *exempted_ext_ips);
void nbrec_nat_set_external_ids(const struct nbrec_nat *, const struct smap *);
void nbrec_nat_set_external_ip(const struct nbrec_nat *, const char *external_ip);
void nbrec_nat_set_external_mac(const struct nbrec_nat *, const char *external_mac);
void nbrec_nat_set_external_port_range(const struct nbrec_nat *, const char *external_port_range);
void nbrec_nat_set_logical_ip(const struct nbrec_nat *, const char *logical_ip);
void nbrec_nat_set_logical_port(const struct nbrec_nat *, const char *logical_port);
void nbrec_nat_set_options(const struct nbrec_nat *, const struct smap *);
void nbrec_nat_set_type(const struct nbrec_nat *, const char *type);

void nbrec_nat_update_allowed_ext_ips_addvalue(const struct nbrec_nat *,  const struct nbrec_address_set *);
void nbrec_nat_update_allowed_ext_ips_delvalue(const struct nbrec_nat *,  const struct nbrec_address_set *);
void nbrec_nat_add_clause_allowed_ext_ips(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *allowed_ext_ips);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_update_exempted_ext_ips_addvalue(const struct nbrec_nat *,  const struct nbrec_address_set *);
void nbrec_nat_update_exempted_ext_ips_delvalue(const struct nbrec_nat *,  const struct nbrec_address_set *);
void nbrec_nat_add_clause_exempted_ext_ips(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *exempted_ext_ips);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_update_external_ids_setkey(const struct nbrec_nat *,  const char *, const char *);
void nbrec_nat_update_external_ids_delkey(const struct nbrec_nat *,  const char *);
void nbrec_nat_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_add_clause_external_ip(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *external_ip);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_update_external_mac_addvalue(const struct nbrec_nat *,  const char *);
void nbrec_nat_update_external_mac_delvalue(const struct nbrec_nat *,  const char *);
void nbrec_nat_add_clause_external_mac(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *external_mac);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_add_clause_external_port_range(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *external_port_range);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_add_clause_logical_ip(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *logical_ip);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_update_logical_port_addvalue(const struct nbrec_nat *,  const char *);
void nbrec_nat_update_logical_port_delvalue(const struct nbrec_nat *,  const char *);
void nbrec_nat_add_clause_logical_port(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *logical_port);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_update_options_setkey(const struct nbrec_nat *,  const char *, const char *);
void nbrec_nat_update_options_delkey(const struct nbrec_nat *,  const char *);
void nbrec_nat_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nat_add_clause_type(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *type);
unsigned int nbrec_nat_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_nat *nbrec_nat_index_init_row(struct ovsdb_idl_index *);
void nbrec_nat_index_set_allowed_ext_ips(const struct nbrec_nat *,
const struct nbrec_address_set *allowed_ext_ips);
void nbrec_nat_index_set_exempted_ext_ips(const struct nbrec_nat *,
const struct nbrec_address_set *exempted_ext_ips);
void nbrec_nat_index_set_external_ids(const struct nbrec_nat *,
const struct smap *);
void nbrec_nat_index_set_external_ip(const struct nbrec_nat *,
const char *external_ip);
void nbrec_nat_index_set_external_mac(const struct nbrec_nat *,
const char *external_mac);
void nbrec_nat_index_set_external_port_range(const struct nbrec_nat *,
const char *external_port_range);
void nbrec_nat_index_set_logical_ip(const struct nbrec_nat *,
const char *logical_ip);
void nbrec_nat_index_set_logical_port(const struct nbrec_nat *,
const char *logical_port);
void nbrec_nat_index_set_options(const struct nbrec_nat *,
const struct smap *);
void nbrec_nat_index_set_type(const struct nbrec_nat *,
const char *type);

/* NB_Global table. */
struct nbrec_nb_global {
	struct ovsdb_idl_row header_;

	/* connections column. */
	struct nbrec_connection **connections;
	size_t n_connections;

	/* external_ids column. */
	struct smap external_ids;

	/* hv_cfg column. */
	int64_t hv_cfg;

	/* hv_cfg_timestamp column. */
	int64_t hv_cfg_timestamp;

	/* ipsec column. */
	bool ipsec;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* nb_cfg column. */
	int64_t nb_cfg;

	/* nb_cfg_timestamp column. */
	int64_t nb_cfg_timestamp;

	/* options column. */
	struct smap options;

	/* sb_cfg column. */
	int64_t sb_cfg;

	/* sb_cfg_timestamp column. */
	int64_t sb_cfg_timestamp;

	/* ssl column. */
	struct nbrec_ssl *ssl;
};

enum nbrec_nb_global_column_id {
    NBREC_NB_GLOBAL_COL_CONNECTIONS,
    NBREC_NB_GLOBAL_COL_EXTERNAL_IDS,
    NBREC_NB_GLOBAL_COL_HV_CFG,
    NBREC_NB_GLOBAL_COL_HV_CFG_TIMESTAMP,
    NBREC_NB_GLOBAL_COL_IPSEC,
    NBREC_NB_GLOBAL_COL_NAME,
    NBREC_NB_GLOBAL_COL_NB_CFG,
    NBREC_NB_GLOBAL_COL_NB_CFG_TIMESTAMP,
    NBREC_NB_GLOBAL_COL_OPTIONS,
    NBREC_NB_GLOBAL_COL_SB_CFG,
    NBREC_NB_GLOBAL_COL_SB_CFG_TIMESTAMP,
    NBREC_NB_GLOBAL_COL_SSL,
    NBREC_NB_GLOBAL_N_COLUMNS
};

#define nbrec_nb_global_col_connections (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_CONNECTIONS])
#define nbrec_nb_global_col_external_ids (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_EXTERNAL_IDS])
#define nbrec_nb_global_col_hv_cfg (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_HV_CFG])
#define nbrec_nb_global_col_hv_cfg_timestamp (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_HV_CFG_TIMESTAMP])
#define nbrec_nb_global_col_ipsec (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_IPSEC])
#define nbrec_nb_global_col_name (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_NAME])
#define nbrec_nb_global_col_nb_cfg (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_NB_CFG])
#define nbrec_nb_global_col_nb_cfg_timestamp (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_NB_CFG_TIMESTAMP])
#define nbrec_nb_global_col_options (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_OPTIONS])
#define nbrec_nb_global_col_sb_cfg (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_SB_CFG])
#define nbrec_nb_global_col_sb_cfg_timestamp (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_SB_CFG_TIMESTAMP])
#define nbrec_nb_global_col_ssl (nbrec_nb_global_columns[NBREC_NB_GLOBAL_COL_SSL])

extern struct ovsdb_idl_column nbrec_nb_global_columns[NBREC_NB_GLOBAL_N_COLUMNS];

const struct nbrec_nb_global_table *nbrec_nb_global_table_get(const struct ovsdb_idl *);
const struct nbrec_nb_global *nbrec_nb_global_table_first(const struct nbrec_nb_global_table *);

#define NBREC_NB_GLOBAL_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_nb_global_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_nb_global_next(ROW))
#define NBREC_NB_GLOBAL_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_nb_global_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_nb_global_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_nb_global *nbrec_nb_global_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_nb_global *nbrec_nb_global_table_get_for_uuid(const struct nbrec_nb_global_table *, const struct uuid *);
const struct nbrec_nb_global *nbrec_nb_global_first(const struct ovsdb_idl *);
const struct nbrec_nb_global *nbrec_nb_global_next(const struct nbrec_nb_global *);
#define NBREC_NB_GLOBAL_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_nb_global_first(IDL); \
             (ROW); \
             (ROW) = nbrec_nb_global_next(ROW))
#define NBREC_NB_GLOBAL_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_nb_global_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_nb_global_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_nb_global_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_nb_global_row_get_seqno(const struct nbrec_nb_global *row, enum ovsdb_idl_change change);
const struct nbrec_nb_global *nbrec_nb_global_track_get_first(const struct ovsdb_idl *);
const struct nbrec_nb_global *nbrec_nb_global_track_get_next(const struct nbrec_nb_global *);
#define NBREC_NB_GLOBAL_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_nb_global_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_nb_global_track_get_next(ROW))

const struct nbrec_nb_global *nbrec_nb_global_table_track_get_first(const struct nbrec_nb_global_table *);
#define NBREC_NB_GLOBAL_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_nb_global_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_nb_global_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_nb_global_is_new(const struct nbrec_nb_global *row)
{
    return nbrec_nb_global_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_nb_global_is_deleted(const struct nbrec_nb_global *row)
{
    return nbrec_nb_global_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_nb_global_index_destroy_row(const struct nbrec_nb_global *);

struct nbrec_nb_global *nbrec_nb_global_index_find(struct ovsdb_idl_index *, const struct nbrec_nb_global *);

int nbrec_nb_global_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_nb_global *, 
    const struct nbrec_nb_global *);
struct ovsdb_idl_cursor nbrec_nb_global_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_nb_global_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_nb_global *);
struct ovsdb_idl_cursor nbrec_nb_global_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_nb_global *);

struct nbrec_nb_global *nbrec_nb_global_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_NB_GLOBAL_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_nb_global_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_nb_global_cursor_data(&cursor__), \
                  !(TO) || nbrec_nb_global_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_NB_GLOBAL_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_nb_global_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_nb_global_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_NB_GLOBAL_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_nb_global_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_nb_global_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_nb_global_init(struct nbrec_nb_global *);
void nbrec_nb_global_delete(const struct nbrec_nb_global *);
struct nbrec_nb_global *nbrec_nb_global_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_nb_global_column_id' of
 * the row referenced by 'struct nbrec_nb_global *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_nb_global_is_updated(const struct nbrec_nb_global *, enum nbrec_nb_global_column_id);

void nbrec_nb_global_verify_connections(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_external_ids(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_hv_cfg(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_hv_cfg_timestamp(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_ipsec(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_name(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_nb_cfg(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_nb_cfg_timestamp(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_options(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_sb_cfg(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_sb_cfg_timestamp(const struct nbrec_nb_global *);
void nbrec_nb_global_verify_ssl(const struct nbrec_nb_global *);

const struct ovsdb_datum *nbrec_nb_global_get_connections(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_external_ids(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_nb_global_get_hv_cfg(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_hv_cfg_timestamp(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_ipsec(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_name(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_nb_cfg(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_nb_cfg_timestamp(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_options(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_nb_global_get_sb_cfg(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_sb_cfg_timestamp(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_nb_global_get_ssl(const struct nbrec_nb_global *, enum ovsdb_atomic_type key_type);

void nbrec_nb_global_set_connections(const struct nbrec_nb_global *, struct nbrec_connection **connections, size_t n_connections);
void nbrec_nb_global_set_external_ids(const struct nbrec_nb_global *, const struct smap *);
void nbrec_nb_global_set_hv_cfg(const struct nbrec_nb_global *, int64_t hv_cfg);
void nbrec_nb_global_set_hv_cfg_timestamp(const struct nbrec_nb_global *, int64_t hv_cfg_timestamp);
void nbrec_nb_global_set_ipsec(const struct nbrec_nb_global *, bool ipsec);
void nbrec_nb_global_set_name(const struct nbrec_nb_global *, const char *name);
void nbrec_nb_global_set_nb_cfg(const struct nbrec_nb_global *, int64_t nb_cfg);
void nbrec_nb_global_set_nb_cfg_timestamp(const struct nbrec_nb_global *, int64_t nb_cfg_timestamp);
void nbrec_nb_global_set_options(const struct nbrec_nb_global *, const struct smap *);
void nbrec_nb_global_set_sb_cfg(const struct nbrec_nb_global *, int64_t sb_cfg);
void nbrec_nb_global_set_sb_cfg_timestamp(const struct nbrec_nb_global *, int64_t sb_cfg_timestamp);
void nbrec_nb_global_set_ssl(const struct nbrec_nb_global *, const struct nbrec_ssl *ssl);

void nbrec_nb_global_update_connections_addvalue(const struct nbrec_nb_global *,  const struct nbrec_connection *);
void nbrec_nb_global_update_connections_delvalue(const struct nbrec_nb_global *,  const struct nbrec_connection *);
void nbrec_nb_global_add_clause_connections(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **connections, size_t n_connections);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_update_external_ids_setkey(const struct nbrec_nb_global *,  const char *, const char *);
void nbrec_nb_global_update_external_ids_delkey(const struct nbrec_nb_global *,  const char *);
void nbrec_nb_global_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_add_clause_hv_cfg(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t hv_cfg);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_add_clause_hv_cfg_timestamp(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t hv_cfg_timestamp);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_add_clause_ipsec(struct ovsdb_idl_condition *, enum ovsdb_function function, bool ipsec);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_add_clause_nb_cfg(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t nb_cfg);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_add_clause_nb_cfg_timestamp(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t nb_cfg_timestamp);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_update_options_setkey(const struct nbrec_nb_global *,  const char *, const char *);
void nbrec_nb_global_update_options_delkey(const struct nbrec_nb_global *,  const char *);
void nbrec_nb_global_add_clause_options(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_add_clause_sb_cfg(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t sb_cfg);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_add_clause_sb_cfg_timestamp(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t sb_cfg_timestamp);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_nb_global_update_ssl_addvalue(const struct nbrec_nb_global *,  const struct nbrec_ssl *);
void nbrec_nb_global_update_ssl_delvalue(const struct nbrec_nb_global *,  const struct nbrec_ssl *);
void nbrec_nb_global_add_clause_ssl(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct uuid *ssl);
unsigned int nbrec_nb_global_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_nb_global *nbrec_nb_global_index_init_row(struct ovsdb_idl_index *);
void nbrec_nb_global_index_set_connections(const struct nbrec_nb_global *,
struct nbrec_connection **connections, size_t n_connections);
void nbrec_nb_global_index_set_external_ids(const struct nbrec_nb_global *,
const struct smap *);
void nbrec_nb_global_index_set_hv_cfg(const struct nbrec_nb_global *,
int64_t hv_cfg);
void nbrec_nb_global_index_set_hv_cfg_timestamp(const struct nbrec_nb_global *,
int64_t hv_cfg_timestamp);
void nbrec_nb_global_index_set_ipsec(const struct nbrec_nb_global *,
bool ipsec);
void nbrec_nb_global_index_set_name(const struct nbrec_nb_global *,
const char *name);
void nbrec_nb_global_index_set_nb_cfg(const struct nbrec_nb_global *,
int64_t nb_cfg);
void nbrec_nb_global_index_set_nb_cfg_timestamp(const struct nbrec_nb_global *,
int64_t nb_cfg_timestamp);
void nbrec_nb_global_index_set_options(const struct nbrec_nb_global *,
const struct smap *);
void nbrec_nb_global_index_set_sb_cfg(const struct nbrec_nb_global *,
int64_t sb_cfg);
void nbrec_nb_global_index_set_sb_cfg_timestamp(const struct nbrec_nb_global *,
int64_t sb_cfg_timestamp);
void nbrec_nb_global_index_set_ssl(const struct nbrec_nb_global *,
const struct nbrec_ssl *ssl);

/* Port_Group table. */
struct nbrec_port_group {
	struct ovsdb_idl_row header_;

	/* acls column. */
	struct nbrec_acl **acls;
	size_t n_acls;

	/* external_ids column. */
	struct smap external_ids;

	/* name column. */
	char *name;	/* Always nonnull. */

	/* ports column. */
	struct nbrec_logical_switch_port **ports;
	size_t n_ports;
};

enum nbrec_port_group_column_id {
    NBREC_PORT_GROUP_COL_ACLS,
    NBREC_PORT_GROUP_COL_EXTERNAL_IDS,
    NBREC_PORT_GROUP_COL_NAME,
    NBREC_PORT_GROUP_COL_PORTS,
    NBREC_PORT_GROUP_N_COLUMNS
};

#define nbrec_port_group_col_acls (nbrec_port_group_columns[NBREC_PORT_GROUP_COL_ACLS])
#define nbrec_port_group_col_external_ids (nbrec_port_group_columns[NBREC_PORT_GROUP_COL_EXTERNAL_IDS])
#define nbrec_port_group_col_name (nbrec_port_group_columns[NBREC_PORT_GROUP_COL_NAME])
#define nbrec_port_group_col_ports (nbrec_port_group_columns[NBREC_PORT_GROUP_COL_PORTS])

extern struct ovsdb_idl_column nbrec_port_group_columns[NBREC_PORT_GROUP_N_COLUMNS];

const struct nbrec_port_group_table *nbrec_port_group_table_get(const struct ovsdb_idl *);
const struct nbrec_port_group *nbrec_port_group_table_first(const struct nbrec_port_group_table *);

#define NBREC_PORT_GROUP_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_port_group_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_port_group_next(ROW))
#define NBREC_PORT_GROUP_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_port_group_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_port_group_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_port_group *nbrec_port_group_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_port_group *nbrec_port_group_table_get_for_uuid(const struct nbrec_port_group_table *, const struct uuid *);
const struct nbrec_port_group *nbrec_port_group_first(const struct ovsdb_idl *);
const struct nbrec_port_group *nbrec_port_group_next(const struct nbrec_port_group *);
#define NBREC_PORT_GROUP_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_port_group_first(IDL); \
             (ROW); \
             (ROW) = nbrec_port_group_next(ROW))
#define NBREC_PORT_GROUP_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_port_group_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_port_group_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_port_group_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_port_group_row_get_seqno(const struct nbrec_port_group *row, enum ovsdb_idl_change change);
const struct nbrec_port_group *nbrec_port_group_track_get_first(const struct ovsdb_idl *);
const struct nbrec_port_group *nbrec_port_group_track_get_next(const struct nbrec_port_group *);
#define NBREC_PORT_GROUP_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_port_group_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_port_group_track_get_next(ROW))

const struct nbrec_port_group *nbrec_port_group_table_track_get_first(const struct nbrec_port_group_table *);
#define NBREC_PORT_GROUP_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_port_group_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_port_group_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_port_group_is_new(const struct nbrec_port_group *row)
{
    return nbrec_port_group_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_port_group_is_deleted(const struct nbrec_port_group *row)
{
    return nbrec_port_group_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_port_group_index_destroy_row(const struct nbrec_port_group *);

struct nbrec_port_group *nbrec_port_group_index_find(struct ovsdb_idl_index *, const struct nbrec_port_group *);

int nbrec_port_group_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_port_group *, 
    const struct nbrec_port_group *);
struct ovsdb_idl_cursor nbrec_port_group_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_port_group_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_port_group *);
struct ovsdb_idl_cursor nbrec_port_group_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_port_group *);

struct nbrec_port_group *nbrec_port_group_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_PORT_GROUP_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_port_group_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_port_group_cursor_data(&cursor__), \
                  !(TO) || nbrec_port_group_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_PORT_GROUP_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_port_group_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_port_group_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_PORT_GROUP_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_port_group_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_port_group_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_port_group_init(struct nbrec_port_group *);
void nbrec_port_group_delete(const struct nbrec_port_group *);
struct nbrec_port_group *nbrec_port_group_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_port_group_column_id' of
 * the row referenced by 'struct nbrec_port_group *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_port_group_is_updated(const struct nbrec_port_group *, enum nbrec_port_group_column_id);

void nbrec_port_group_verify_acls(const struct nbrec_port_group *);
void nbrec_port_group_verify_external_ids(const struct nbrec_port_group *);
void nbrec_port_group_verify_name(const struct nbrec_port_group *);
void nbrec_port_group_verify_ports(const struct nbrec_port_group *);

const struct ovsdb_datum *nbrec_port_group_get_acls(const struct nbrec_port_group *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_port_group_get_external_ids(const struct nbrec_port_group *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_port_group_get_name(const struct nbrec_port_group *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_port_group_get_ports(const struct nbrec_port_group *, enum ovsdb_atomic_type key_type);

void nbrec_port_group_set_acls(const struct nbrec_port_group *, struct nbrec_acl **acls, size_t n_acls);
void nbrec_port_group_set_external_ids(const struct nbrec_port_group *, const struct smap *);
void nbrec_port_group_set_name(const struct nbrec_port_group *, const char *name);
void nbrec_port_group_set_ports(const struct nbrec_port_group *, struct nbrec_logical_switch_port **ports, size_t n_ports);

void nbrec_port_group_update_acls_addvalue(const struct nbrec_port_group *,  const struct nbrec_acl *);
void nbrec_port_group_update_acls_delvalue(const struct nbrec_port_group *,  const struct nbrec_acl *);
void nbrec_port_group_add_clause_acls(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **acls, size_t n_acls);
unsigned int nbrec_port_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_port_group_update_external_ids_setkey(const struct nbrec_port_group *,  const char *, const char *);
void nbrec_port_group_update_external_ids_delkey(const struct nbrec_port_group *,  const char *);
void nbrec_port_group_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_port_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_port_group_add_clause_name(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *name);
unsigned int nbrec_port_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_port_group_update_ports_addvalue(const struct nbrec_port_group *,  const struct nbrec_logical_switch_port *);
void nbrec_port_group_update_ports_delvalue(const struct nbrec_port_group *,  const struct nbrec_logical_switch_port *);
void nbrec_port_group_add_clause_ports(struct ovsdb_idl_condition *, enum ovsdb_function function, struct uuid **ports, size_t n_ports);
unsigned int nbrec_port_group_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_port_group *nbrec_port_group_index_init_row(struct ovsdb_idl_index *);
void nbrec_port_group_index_set_acls(const struct nbrec_port_group *,
struct nbrec_acl **acls, size_t n_acls);
void nbrec_port_group_index_set_external_ids(const struct nbrec_port_group *,
const struct smap *);
void nbrec_port_group_index_set_name(const struct nbrec_port_group *,
const char *name);
void nbrec_port_group_index_set_ports(const struct nbrec_port_group *,
struct nbrec_logical_switch_port **ports, size_t n_ports);

/* QoS table. */
struct nbrec_qos {
	struct ovsdb_idl_row header_;

	/* action column. */
	char **key_action;
	int64_t *value_action;
	size_t n_action;

	/* bandwidth column. */
	char **key_bandwidth;
	int64_t *value_bandwidth;
	size_t n_bandwidth;

	/* direction column. */
	char *direction;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* match column. */
	char *match;	/* Always nonnull. */

	/* priority column. */
	int64_t priority;
};

enum nbrec_qos_column_id {
    NBREC_QOS_COL_ACTION,
    NBREC_QOS_COL_BANDWIDTH,
    NBREC_QOS_COL_DIRECTION,
    NBREC_QOS_COL_EXTERNAL_IDS,
    NBREC_QOS_COL_MATCH,
    NBREC_QOS_COL_PRIORITY,
    NBREC_QOS_N_COLUMNS
};

#define nbrec_qos_col_action (nbrec_qos_columns[NBREC_QOS_COL_ACTION])
#define nbrec_qos_col_bandwidth (nbrec_qos_columns[NBREC_QOS_COL_BANDWIDTH])
#define nbrec_qos_col_direction (nbrec_qos_columns[NBREC_QOS_COL_DIRECTION])
#define nbrec_qos_col_external_ids (nbrec_qos_columns[NBREC_QOS_COL_EXTERNAL_IDS])
#define nbrec_qos_col_match (nbrec_qos_columns[NBREC_QOS_COL_MATCH])
#define nbrec_qos_col_priority (nbrec_qos_columns[NBREC_QOS_COL_PRIORITY])

extern struct ovsdb_idl_column nbrec_qos_columns[NBREC_QOS_N_COLUMNS];

const struct nbrec_qos_table *nbrec_qos_table_get(const struct ovsdb_idl *);
const struct nbrec_qos *nbrec_qos_table_first(const struct nbrec_qos_table *);

#define NBREC_QOS_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_qos_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_qos_next(ROW))
#define NBREC_QOS_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_qos_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_qos_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_qos *nbrec_qos_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_qos *nbrec_qos_table_get_for_uuid(const struct nbrec_qos_table *, const struct uuid *);
const struct nbrec_qos *nbrec_qos_first(const struct ovsdb_idl *);
const struct nbrec_qos *nbrec_qos_next(const struct nbrec_qos *);
#define NBREC_QOS_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_qos_first(IDL); \
             (ROW); \
             (ROW) = nbrec_qos_next(ROW))
#define NBREC_QOS_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_qos_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_qos_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_qos_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_qos_row_get_seqno(const struct nbrec_qos *row, enum ovsdb_idl_change change);
const struct nbrec_qos *nbrec_qos_track_get_first(const struct ovsdb_idl *);
const struct nbrec_qos *nbrec_qos_track_get_next(const struct nbrec_qos *);
#define NBREC_QOS_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_qos_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_qos_track_get_next(ROW))

const struct nbrec_qos *nbrec_qos_table_track_get_first(const struct nbrec_qos_table *);
#define NBREC_QOS_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_qos_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_qos_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_qos_is_new(const struct nbrec_qos *row)
{
    return nbrec_qos_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_qos_is_deleted(const struct nbrec_qos *row)
{
    return nbrec_qos_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_qos_index_destroy_row(const struct nbrec_qos *);

struct nbrec_qos *nbrec_qos_index_find(struct ovsdb_idl_index *, const struct nbrec_qos *);

int nbrec_qos_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_qos *, 
    const struct nbrec_qos *);
struct ovsdb_idl_cursor nbrec_qos_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_qos_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_qos *);
struct ovsdb_idl_cursor nbrec_qos_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_qos *);

struct nbrec_qos *nbrec_qos_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_QOS_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_qos_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_qos_cursor_data(&cursor__), \
                  !(TO) || nbrec_qos_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_QOS_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_qos_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_qos_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_QOS_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_qos_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_qos_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_qos_init(struct nbrec_qos *);
void nbrec_qos_delete(const struct nbrec_qos *);
struct nbrec_qos *nbrec_qos_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_qos_column_id' of
 * the row referenced by 'struct nbrec_qos *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_qos_is_updated(const struct nbrec_qos *, enum nbrec_qos_column_id);

void nbrec_qos_verify_action(const struct nbrec_qos *);
void nbrec_qos_verify_bandwidth(const struct nbrec_qos *);
void nbrec_qos_verify_direction(const struct nbrec_qos *);
void nbrec_qos_verify_external_ids(const struct nbrec_qos *);
void nbrec_qos_verify_match(const struct nbrec_qos *);
void nbrec_qos_verify_priority(const struct nbrec_qos *);

const struct ovsdb_datum *nbrec_qos_get_action(const struct nbrec_qos *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_qos_get_bandwidth(const struct nbrec_qos *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_qos_get_direction(const struct nbrec_qos *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_qos_get_external_ids(const struct nbrec_qos *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_qos_get_match(const struct nbrec_qos *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_qos_get_priority(const struct nbrec_qos *, enum ovsdb_atomic_type key_type);

void nbrec_qos_set_action(const struct nbrec_qos *, const char **key_action, const int64_t *value_action, size_t n_action);
void nbrec_qos_set_bandwidth(const struct nbrec_qos *, const char **key_bandwidth, const int64_t *value_bandwidth, size_t n_bandwidth);
void nbrec_qos_set_direction(const struct nbrec_qos *, const char *direction);
void nbrec_qos_set_external_ids(const struct nbrec_qos *, const struct smap *);
void nbrec_qos_set_match(const struct nbrec_qos *, const char *match);
void nbrec_qos_set_priority(const struct nbrec_qos *, int64_t priority);

void nbrec_qos_update_action_setkey(const struct nbrec_qos *,  const char *, int64_t );
void nbrec_qos_update_action_delkey(const struct nbrec_qos *,  const char *);
void nbrec_qos_add_clause_action(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **key_action, const int64_t *value_action, size_t n_action);
unsigned int nbrec_qos_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_qos_update_bandwidth_setkey(const struct nbrec_qos *,  const char *, int64_t );
void nbrec_qos_update_bandwidth_delkey(const struct nbrec_qos *,  const char *);
void nbrec_qos_add_clause_bandwidth(struct ovsdb_idl_condition *, enum ovsdb_function function, const char **key_bandwidth, const int64_t *value_bandwidth, size_t n_bandwidth);
unsigned int nbrec_qos_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_qos_add_clause_direction(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *direction);
unsigned int nbrec_qos_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_qos_update_external_ids_setkey(const struct nbrec_qos *,  const char *, const char *);
void nbrec_qos_update_external_ids_delkey(const struct nbrec_qos *,  const char *);
void nbrec_qos_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_qos_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_qos_add_clause_match(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *match);
unsigned int nbrec_qos_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_qos_add_clause_priority(struct ovsdb_idl_condition *, enum ovsdb_function function, int64_t priority);
unsigned int nbrec_qos_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_qos *nbrec_qos_index_init_row(struct ovsdb_idl_index *);
void nbrec_qos_index_set_action(const struct nbrec_qos *,
const char **key_action, const int64_t *value_action, size_t n_action);
void nbrec_qos_index_set_bandwidth(const struct nbrec_qos *,
const char **key_bandwidth, const int64_t *value_bandwidth, size_t n_bandwidth);
void nbrec_qos_index_set_direction(const struct nbrec_qos *,
const char *direction);
void nbrec_qos_index_set_external_ids(const struct nbrec_qos *,
const struct smap *);
void nbrec_qos_index_set_match(const struct nbrec_qos *,
const char *match);
void nbrec_qos_index_set_priority(const struct nbrec_qos *,
int64_t priority);

/* SSL table. */
struct nbrec_ssl {
	struct ovsdb_idl_row header_;

	/* bootstrap_ca_cert column. */
	bool bootstrap_ca_cert;

	/* ca_cert column. */
	char *ca_cert;	/* Always nonnull. */

	/* certificate column. */
	char *certificate;	/* Always nonnull. */

	/* external_ids column. */
	struct smap external_ids;

	/* private_key column. */
	char *private_key;	/* Always nonnull. */

	/* ssl_ciphers column. */
	char *ssl_ciphers;	/* Always nonnull. */

	/* ssl_protocols column. */
	char *ssl_protocols;	/* Always nonnull. */
};

enum nbrec_ssl_column_id {
    NBREC_SSL_COL_BOOTSTRAP_CA_CERT,
    NBREC_SSL_COL_CA_CERT,
    NBREC_SSL_COL_CERTIFICATE,
    NBREC_SSL_COL_EXTERNAL_IDS,
    NBREC_SSL_COL_PRIVATE_KEY,
    NBREC_SSL_COL_SSL_CIPHERS,
    NBREC_SSL_COL_SSL_PROTOCOLS,
    NBREC_SSL_N_COLUMNS
};

#define nbrec_ssl_col_bootstrap_ca_cert (nbrec_ssl_columns[NBREC_SSL_COL_BOOTSTRAP_CA_CERT])
#define nbrec_ssl_col_ca_cert (nbrec_ssl_columns[NBREC_SSL_COL_CA_CERT])
#define nbrec_ssl_col_certificate (nbrec_ssl_columns[NBREC_SSL_COL_CERTIFICATE])
#define nbrec_ssl_col_external_ids (nbrec_ssl_columns[NBREC_SSL_COL_EXTERNAL_IDS])
#define nbrec_ssl_col_private_key (nbrec_ssl_columns[NBREC_SSL_COL_PRIVATE_KEY])
#define nbrec_ssl_col_ssl_ciphers (nbrec_ssl_columns[NBREC_SSL_COL_SSL_CIPHERS])
#define nbrec_ssl_col_ssl_protocols (nbrec_ssl_columns[NBREC_SSL_COL_SSL_PROTOCOLS])

extern struct ovsdb_idl_column nbrec_ssl_columns[NBREC_SSL_N_COLUMNS];

const struct nbrec_ssl_table *nbrec_ssl_table_get(const struct ovsdb_idl *);
const struct nbrec_ssl *nbrec_ssl_table_first(const struct nbrec_ssl_table *);

#define NBREC_SSL_TABLE_FOR_EACH(ROW, TABLE) \
        for ((ROW) = nbrec_ssl_table_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_ssl_next(ROW))
#define NBREC_SSL_TABLE_FOR_EACH_SAFE(ROW, NEXT, TABLE) \
        for ((ROW) = nbrec_ssl_table_first(TABLE); \
             (ROW) ? ((NEXT) = nbrec_ssl_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

const struct nbrec_ssl *nbrec_ssl_get_for_uuid(const struct ovsdb_idl *, const struct uuid *);
const struct nbrec_ssl *nbrec_ssl_table_get_for_uuid(const struct nbrec_ssl_table *, const struct uuid *);
const struct nbrec_ssl *nbrec_ssl_first(const struct ovsdb_idl *);
const struct nbrec_ssl *nbrec_ssl_next(const struct nbrec_ssl *);
#define NBREC_SSL_FOR_EACH(ROW, IDL) \
        for ((ROW) = nbrec_ssl_first(IDL); \
             (ROW); \
             (ROW) = nbrec_ssl_next(ROW))
#define NBREC_SSL_FOR_EACH_SAFE(ROW, NEXT, IDL) \
        for ((ROW) = nbrec_ssl_first(IDL); \
             (ROW) ? ((NEXT) = nbrec_ssl_next(ROW), 1) : 0; \
             (ROW) = (NEXT))

unsigned int nbrec_ssl_get_seqno(const struct ovsdb_idl *);
unsigned int nbrec_ssl_row_get_seqno(const struct nbrec_ssl *row, enum ovsdb_idl_change change);
const struct nbrec_ssl *nbrec_ssl_track_get_first(const struct ovsdb_idl *);
const struct nbrec_ssl *nbrec_ssl_track_get_next(const struct nbrec_ssl *);
#define NBREC_SSL_FOR_EACH_TRACKED(ROW, IDL) \
        for ((ROW) = nbrec_ssl_track_get_first(IDL); \
             (ROW); \
             (ROW) = nbrec_ssl_track_get_next(ROW))

const struct nbrec_ssl *nbrec_ssl_table_track_get_first(const struct nbrec_ssl_table *);
#define NBREC_SSL_TABLE_FOR_EACH_TRACKED(ROW, TABLE) \
        for ((ROW) = nbrec_ssl_table_track_get_first(TABLE); \
             (ROW); \
             (ROW) = nbrec_ssl_track_get_next(ROW))


/* Returns true if 'row' was inserted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally is new or it
 * may given unexpected results. */
static inline bool nbrec_ssl_is_new(const struct nbrec_ssl *row)
{
    return nbrec_ssl_row_get_seqno(row, OVSDB_IDL_CHANGE_INSERT) > 0;
}

/* Returns true if 'row' was deleted since the last change tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * deleted or it may given unexpected results. */
static inline bool nbrec_ssl_is_deleted(const struct nbrec_ssl *row)
{
    return nbrec_ssl_row_get_seqno(row, OVSDB_IDL_CHANGE_DELETE) > 0;
}

void nbrec_ssl_index_destroy_row(const struct nbrec_ssl *);

struct nbrec_ssl *nbrec_ssl_index_find(struct ovsdb_idl_index *, const struct nbrec_ssl *);

int nbrec_ssl_index_compare(
    struct ovsdb_idl_index *, 
    const struct nbrec_ssl *, 
    const struct nbrec_ssl *);
struct ovsdb_idl_cursor nbrec_ssl_cursor_first(struct ovsdb_idl_index *);
struct ovsdb_idl_cursor nbrec_ssl_cursor_first_eq(
    struct ovsdb_idl_index *, const struct nbrec_ssl *);
struct ovsdb_idl_cursor nbrec_ssl_cursor_first_ge(
    struct ovsdb_idl_index *, const struct nbrec_ssl *);

struct nbrec_ssl *nbrec_ssl_cursor_data(struct ovsdb_idl_cursor *);

#define NBREC_SSL_FOR_EACH_RANGE(ROW, FROM, TO, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ssl_cursor_first_ge(INDEX, FROM); \
             (cursor__.position \
              && ((ROW) = nbrec_ssl_cursor_data(&cursor__), \
                  !(TO) || nbrec_ssl_index_compare(INDEX, ROW, TO) <= 0)); \
             ovsdb_idl_cursor_next(&cursor__))
#define NBREC_SSL_FOR_EACH_EQUAL(ROW, KEY, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ssl_cursor_first_eq(INDEX, KEY); \
             (cursor__.position \
              ? ((ROW) = nbrec_ssl_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next_eq(&cursor__), \
                 true) \
              : false); \
            )
#define NBREC_SSL_FOR_EACH_BYINDEX(ROW, INDEX) \
        for (struct ovsdb_idl_cursor cursor__ = nbrec_ssl_cursor_first(INDEX); \
             (cursor__.position \
              ? ((ROW) = nbrec_ssl_cursor_data(&cursor__), \
                 ovsdb_idl_cursor_next(&cursor__), \
                 true) \
              : false); \
            )

void nbrec_ssl_init(struct nbrec_ssl *);
void nbrec_ssl_delete(const struct nbrec_ssl *);
struct nbrec_ssl *nbrec_ssl_insert(struct ovsdb_idl_txn *);

/* Returns true if the tracked column referenced by 'enum nbrec_ssl_column_id' of
 * the row referenced by 'struct nbrec_ssl *' was updated since the last change
 * tracking reset.
 *
 * Note: This can only be used to test rows of tracked changes. This cannot be
 * used to test if an uncommitted row that has been added locally has been
 * updated or it may given unexpected results. */
bool nbrec_ssl_is_updated(const struct nbrec_ssl *, enum nbrec_ssl_column_id);

void nbrec_ssl_verify_bootstrap_ca_cert(const struct nbrec_ssl *);
void nbrec_ssl_verify_ca_cert(const struct nbrec_ssl *);
void nbrec_ssl_verify_certificate(const struct nbrec_ssl *);
void nbrec_ssl_verify_external_ids(const struct nbrec_ssl *);
void nbrec_ssl_verify_private_key(const struct nbrec_ssl *);
void nbrec_ssl_verify_ssl_ciphers(const struct nbrec_ssl *);
void nbrec_ssl_verify_ssl_protocols(const struct nbrec_ssl *);

const struct ovsdb_datum *nbrec_ssl_get_bootstrap_ca_cert(const struct nbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_ssl_get_ca_cert(const struct nbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_ssl_get_certificate(const struct nbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_ssl_get_external_ids(const struct nbrec_ssl *, enum ovsdb_atomic_type key_type, enum ovsdb_atomic_type value_type);
const struct ovsdb_datum *nbrec_ssl_get_private_key(const struct nbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_ssl_get_ssl_ciphers(const struct nbrec_ssl *, enum ovsdb_atomic_type key_type);
const struct ovsdb_datum *nbrec_ssl_get_ssl_protocols(const struct nbrec_ssl *, enum ovsdb_atomic_type key_type);

void nbrec_ssl_set_bootstrap_ca_cert(const struct nbrec_ssl *, bool bootstrap_ca_cert);
void nbrec_ssl_set_ca_cert(const struct nbrec_ssl *, const char *ca_cert);
void nbrec_ssl_set_certificate(const struct nbrec_ssl *, const char *certificate);
void nbrec_ssl_set_external_ids(const struct nbrec_ssl *, const struct smap *);
void nbrec_ssl_set_private_key(const struct nbrec_ssl *, const char *private_key);
void nbrec_ssl_set_ssl_ciphers(const struct nbrec_ssl *, const char *ssl_ciphers);
void nbrec_ssl_set_ssl_protocols(const struct nbrec_ssl *, const char *ssl_protocols);

void nbrec_ssl_add_clause_bootstrap_ca_cert(struct ovsdb_idl_condition *, enum ovsdb_function function, bool bootstrap_ca_cert);
unsigned int nbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ssl_add_clause_ca_cert(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *ca_cert);
unsigned int nbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ssl_add_clause_certificate(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *certificate);
unsigned int nbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ssl_update_external_ids_setkey(const struct nbrec_ssl *,  const char *, const char *);
void nbrec_ssl_update_external_ids_delkey(const struct nbrec_ssl *,  const char *);
void nbrec_ssl_add_clause_external_ids(struct ovsdb_idl_condition *, enum ovsdb_function function, const struct smap *);
unsigned int nbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ssl_add_clause_private_key(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *private_key);
unsigned int nbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ssl_add_clause_ssl_ciphers(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *ssl_ciphers);
unsigned int nbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);
void nbrec_ssl_add_clause_ssl_protocols(struct ovsdb_idl_condition *, enum ovsdb_function function, const char *ssl_protocols);
unsigned int nbrec_ssl_set_condition(struct ovsdb_idl *, struct ovsdb_idl_condition *);

struct nbrec_ssl *nbrec_ssl_index_init_row(struct ovsdb_idl_index *);
void nbrec_ssl_index_set_bootstrap_ca_cert(const struct nbrec_ssl *,
bool bootstrap_ca_cert);
void nbrec_ssl_index_set_ca_cert(const struct nbrec_ssl *,
const char *ca_cert);
void nbrec_ssl_index_set_certificate(const struct nbrec_ssl *,
const char *certificate);
void nbrec_ssl_index_set_external_ids(const struct nbrec_ssl *,
const struct smap *);
void nbrec_ssl_index_set_private_key(const struct nbrec_ssl *,
const char *private_key);
void nbrec_ssl_index_set_ssl_ciphers(const struct nbrec_ssl *,
const char *ssl_ciphers);
void nbrec_ssl_index_set_ssl_protocols(const struct nbrec_ssl *,
const char *ssl_protocols);

enum nbrec_table_id {
    NBREC_TABLE_ACL,
    NBREC_TABLE_ADDRESS_SET,
    NBREC_TABLE_BFD,
    NBREC_TABLE_CONNECTION,
    NBREC_TABLE_DHCP_OPTIONS,
    NBREC_TABLE_DNS,
    NBREC_TABLE_FORWARDING_GROUP,
    NBREC_TABLE_GATEWAY_CHASSIS,
    NBREC_TABLE_HA_CHASSIS,
    NBREC_TABLE_HA_CHASSIS_GROUP,
    NBREC_TABLE_LOAD_BALANCER,
    NBREC_TABLE_LOAD_BALANCER_HEALTH_CHECK,
    NBREC_TABLE_LOGICAL_ROUTER,
    NBREC_TABLE_LOGICAL_ROUTER_POLICY,
    NBREC_TABLE_LOGICAL_ROUTER_PORT,
    NBREC_TABLE_LOGICAL_ROUTER_STATIC_ROUTE,
    NBREC_TABLE_LOGICAL_SWITCH,
    NBREC_TABLE_LOGICAL_SWITCH_PORT,
    NBREC_TABLE_METER,
    NBREC_TABLE_METER_BAND,
    NBREC_TABLE_NAT,
    NBREC_TABLE_NB_GLOBAL,
    NBREC_TABLE_PORT_GROUP,
    NBREC_TABLE_QOS,
    NBREC_TABLE_SSL,
    NBREC_N_TABLES
};

#define nbrec_table_acl (nbrec_table_classes[NBREC_TABLE_ACL])
#define nbrec_table_address_set (nbrec_table_classes[NBREC_TABLE_ADDRESS_SET])
#define nbrec_table_bfd (nbrec_table_classes[NBREC_TABLE_BFD])
#define nbrec_table_connection (nbrec_table_classes[NBREC_TABLE_CONNECTION])
#define nbrec_table_dhcp_options (nbrec_table_classes[NBREC_TABLE_DHCP_OPTIONS])
#define nbrec_table_dns (nbrec_table_classes[NBREC_TABLE_DNS])
#define nbrec_table_forwarding_group (nbrec_table_classes[NBREC_TABLE_FORWARDING_GROUP])
#define nbrec_table_gateway_chassis (nbrec_table_classes[NBREC_TABLE_GATEWAY_CHASSIS])
#define nbrec_table_ha_chassis (nbrec_table_classes[NBREC_TABLE_HA_CHASSIS])
#define nbrec_table_ha_chassis_group (nbrec_table_classes[NBREC_TABLE_HA_CHASSIS_GROUP])
#define nbrec_table_load_balancer (nbrec_table_classes[NBREC_TABLE_LOAD_BALANCER])
#define nbrec_table_load_balancer_health_check (nbrec_table_classes[NBREC_TABLE_LOAD_BALANCER_HEALTH_CHECK])
#define nbrec_table_logical_router (nbrec_table_classes[NBREC_TABLE_LOGICAL_ROUTER])
#define nbrec_table_logical_router_policy (nbrec_table_classes[NBREC_TABLE_LOGICAL_ROUTER_POLICY])
#define nbrec_table_logical_router_port (nbrec_table_classes[NBREC_TABLE_LOGICAL_ROUTER_PORT])
#define nbrec_table_logical_router_static_route (nbrec_table_classes[NBREC_TABLE_LOGICAL_ROUTER_STATIC_ROUTE])
#define nbrec_table_logical_switch (nbrec_table_classes[NBREC_TABLE_LOGICAL_SWITCH])
#define nbrec_table_logical_switch_port (nbrec_table_classes[NBREC_TABLE_LOGICAL_SWITCH_PORT])
#define nbrec_table_meter (nbrec_table_classes[NBREC_TABLE_METER])
#define nbrec_table_meter_band (nbrec_table_classes[NBREC_TABLE_METER_BAND])
#define nbrec_table_nat (nbrec_table_classes[NBREC_TABLE_NAT])
#define nbrec_table_nb_global (nbrec_table_classes[NBREC_TABLE_NB_GLOBAL])
#define nbrec_table_port_group (nbrec_table_classes[NBREC_TABLE_PORT_GROUP])
#define nbrec_table_qos (nbrec_table_classes[NBREC_TABLE_QOS])
#define nbrec_table_ssl (nbrec_table_classes[NBREC_TABLE_SSL])

extern struct ovsdb_idl_table_class nbrec_table_classes[NBREC_N_TABLES];

extern struct ovsdb_idl_class nbrec_idl_class;

const char * nbrec_get_db_version(void);

#ifdef  __cplusplus
}
#endif

#endif /* NBREC_IDL_HEADER */
